/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c') && (t3->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst();
    rv->code = 'C';

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->code = P('m','l');
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


/* Line 371 of yacc.c  */
#line 714 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     NMA = 277,
     DEFINE = 278,
     ON = 279,
     OFF = 280,
     YES = 281,
     NO = 282,
     S = 283,
     MS = 284,
     US = 285,
     PORT = 286,
     LOG = 287,
     SYSLOG = 288,
     ALL = 289,
     DEBUG = 290,
     TRACE = 291,
     INFO = 292,
     REMOTE = 293,
     WARNING = 294,
     ERROR = 295,
     AUTH = 296,
     FATAL = 297,
     BUG = 298,
     STDERR = 299,
     SOFT = 300,
     TIMEFORMAT = 301,
     ISO = 302,
     OLD = 303,
     SHORT = 304,
     LONG = 305,
     BASE = 306,
     NAME = 307,
     CONFIRM = 308,
     UNDO = 309,
     CHECK = 310,
     TIMEOUT = 311,
     LATENCY = 312,
     LIMIT = 313,
     WATCHDOG = 314,
     CONFIGURE = 315,
     DOWN = 316,
     KERNEL = 317,
     PERSIST = 318,
     SCAN = 319,
     TIME = 320,
     LEARN = 321,
     DEVICE = 322,
     ROUTES = 323,
     GRACEFUL = 324,
     RESTART = 325,
     KRT_SOURCE = 326,
     KRT_METRIC = 327,
     MERGE = 328,
     PATHS = 329,
     TABLE = 330,
     METRIC = 331,
     KRT_PREFSRC = 332,
     KRT_REALM = 333,
     KRT_SCOPE = 334,
     KRT_MTU = 335,
     KRT_WINDOW = 336,
     KRT_RTT = 337,
     KRT_RTTVAR = 338,
     KRT_SSTRESH = 339,
     KRT_CWND = 340,
     KRT_ADVMSS = 341,
     KRT_REORDERING = 342,
     KRT_HOPLIMIT = 343,
     KRT_INITCWND = 344,
     KRT_RTO_MIN = 345,
     KRT_INITRWND = 346,
     KRT_QUICKACK = 347,
     KRT_LOCK_MTU = 348,
     KRT_LOCK_WINDOW = 349,
     KRT_LOCK_RTT = 350,
     KRT_LOCK_RTTVAR = 351,
     KRT_LOCK_SSTRESH = 352,
     KRT_LOCK_CWND = 353,
     KRT_LOCK_ADVMSS = 354,
     KRT_LOCK_REORDERING = 355,
     KRT_LOCK_HOPLIMIT = 356,
     KRT_LOCK_RTO_MIN = 357,
     KRT_FEATURE_ECN = 358,
     KRT_FEATURE_ALLFRAG = 359,
     ROUTER = 360,
     ID = 361,
     PROTOCOL = 362,
     TEMPLATE = 363,
     PREFERENCE = 364,
     DISABLED = 365,
     DIRECT = 366,
     INTERFACE = 367,
     IMPORT = 368,
     EXPORT = 369,
     FILTER = 370,
     NONE = 371,
     STATES = 372,
     FILTERS = 373,
     RECEIVE = 374,
     ACTION = 375,
     WARN = 376,
     BLOCK = 377,
     DISABLE = 378,
     KEEP = 379,
     FILTERED = 380,
     PASSWORD = 381,
     FROM = 382,
     PASSIVE = 383,
     TO = 384,
     EVENTS = 385,
     PACKETS = 386,
     PROTOCOLS = 387,
     INTERFACES = 388,
     ALGORITHM = 389,
     KEYED = 390,
     HMAC = 391,
     MD5 = 392,
     SHA1 = 393,
     SHA256 = 394,
     SHA384 = 395,
     SHA512 = 396,
     PRIMARY = 397,
     STATS = 398,
     COUNT = 399,
     FOR = 400,
     COMMANDS = 401,
     PREEXPORT = 402,
     NOEXPORT = 403,
     GENERATE = 404,
     ROA = 405,
     LISTEN = 406,
     BGP = 407,
     V6ONLY = 408,
     DUAL = 409,
     ADDRESS = 410,
     PASSWORDS = 411,
     DESCRIPTION = 412,
     SORTED = 413,
     RELOAD = 414,
     IN = 415,
     OUT = 416,
     MRTDUMP = 417,
     MESSAGES = 418,
     RESTRICT = 419,
     MEMORY = 420,
     IGP_METRIC = 421,
     CLASS = 422,
     DSCP = 423,
     WAIT = 424,
     MAX = 425,
     FLUSH = 426,
     AS = 427,
     SHOW = 428,
     STATUS = 429,
     SUMMARY = 430,
     ROUTE = 431,
     SYMBOLS = 432,
     ADD = 433,
     DELETE = 434,
     DUMP = 435,
     RESOURCES = 436,
     SOCKETS = 437,
     NEIGHBORS = 438,
     ATTRIBUTES = 439,
     EVAL = 440,
     ECHO = 441,
     ENABLE = 442,
     FUNCTION = 443,
     PRINT = 444,
     PRINTN = 445,
     UNSET = 446,
     RETURN = 447,
     ACCEPT = 448,
     REJECT = 449,
     QUITBIRD = 450,
     INT = 451,
     BOOL = 452,
     IP = 453,
     PREFIX = 454,
     PAIR = 455,
     QUAD = 456,
     EC = 457,
     LC = 458,
     SET = 459,
     STRING = 460,
     BGPMASK = 461,
     BGPPATH = 462,
     CLIST = 463,
     ECLIST = 464,
     LCLIST = 465,
     IF = 466,
     THEN = 467,
     ELSE = 468,
     CASE = 469,
     TRUE = 470,
     FALSE = 471,
     RT = 472,
     RO = 473,
     UNKNOWN = 474,
     GENERIC = 475,
     GW = 476,
     NET = 477,
     MASK = 478,
     PROTO = 479,
     SOURCE = 480,
     SCOPE = 481,
     CAST = 482,
     DEST = 483,
     IFNAME = 484,
     IFINDEX = 485,
     LEN = 486,
     DEFINED = 487,
     CONTAINS = 488,
     RESET = 489,
     PREPEND = 490,
     FIRST = 491,
     LAST = 492,
     LAST_NONAGGREGATED = 493,
     MATCH = 494,
     ROA_CHECK = 495,
     EMPTY = 496,
     WHERE = 497,
     BFD = 498,
     MIN = 499,
     IDLE = 500,
     RX = 501,
     TX = 502,
     INTERVAL = 503,
     MULTIPLIER = 504,
     MULTIHOP = 505,
     NEIGHBOR = 506,
     DEV = 507,
     LOCAL = 508,
     AUTHENTICATION = 509,
     SIMPLE = 510,
     METICULOUS = 511,
     SESSIONS = 512,
     HOLD = 513,
     CONNECT = 514,
     RETRY = 515,
     KEEPALIVE = 516,
     STARTUP = 517,
     VIA = 518,
     NEXT = 519,
     HOP = 520,
     SELF = 521,
     DEFAULT = 522,
     PATH = 523,
     START = 524,
     DELAY = 525,
     FORGET = 526,
     AFTER = 527,
     BGP_PATH = 528,
     BGP_LOCAL_PREF = 529,
     BGP_MED = 530,
     BGP_ORIGIN = 531,
     BGP_NEXT_HOP = 532,
     BGP_ATOMIC_AGGR = 533,
     BGP_AGGREGATOR = 534,
     BGP_COMMUNITY = 535,
     BGP_EXT_COMMUNITY = 536,
     RR = 537,
     RS = 538,
     CLIENT = 539,
     CLUSTER = 540,
     AS4 = 541,
     ADVERTISE = 542,
     IPV4 = 543,
     CAPABILITIES = 544,
     PREFER = 545,
     OLDER = 546,
     MISSING = 547,
     LLADDR = 548,
     DROP = 549,
     IGNORE = 550,
     REFRESH = 551,
     INTERPRET = 552,
     COMMUNITIES = 553,
     BGP_ORIGINATOR_ID = 554,
     BGP_CLUSTER_LIST = 555,
     IGP = 556,
     GATEWAY = 557,
     RECURSIVE = 558,
     MED = 559,
     TTL = 560,
     SECURITY = 561,
     DETERMINISTIC = 562,
     SECONDARY = 563,
     ALLOW = 564,
     AWARE = 565,
     LINK = 566,
     EXTENDED = 567,
     SETKEY = 568,
     BGP_LARGE_COMMUNITY = 569,
     OSPF = 570,
     AREA = 571,
     OSPF_METRIC1 = 572,
     OSPF_METRIC2 = 573,
     OSPF_TAG = 574,
     OSPF_ROUTER_ID = 575,
     RFC1583COMPAT = 576,
     STUB = 577,
     TICK = 578,
     COST = 579,
     COST2 = 580,
     RETRANSMIT = 581,
     HELLO = 582,
     TRANSMIT = 583,
     PRIORITY = 584,
     DEAD = 585,
     TYPE = 586,
     BROADCAST = 587,
     BCAST = 588,
     NONBROADCAST = 589,
     NBMA = 590,
     POINTOPOINT = 591,
     PTP = 592,
     POINTOMULTIPOINT = 593,
     PTMP = 594,
     STRICT = 595,
     CRYPTOGRAPHIC = 596,
     ELIGIBLE = 597,
     POLL = 598,
     NETWORKS = 599,
     HIDDEN = 600,
     VIRTUAL = 601,
     ONLY = 602,
     BUFFER = 603,
     LARGE = 604,
     NORMAL = 605,
     STUBNET = 606,
     TAG = 607,
     EXTERNAL = 608,
     LSADB = 609,
     ECMP = 610,
     WEIGHT = 611,
     NSSA = 612,
     TRANSLATOR = 613,
     STABILITY = 614,
     GLOBAL = 615,
     LSID = 616,
     INSTANCE = 617,
     REAL = 618,
     NETMASK = 619,
     LENGTH = 620,
     LSA = 621,
     SUPPRESSION = 622,
     TOPOLOGY = 623,
     STATE = 624,
     PIPE = 625,
     PEER = 626,
     MODE = 627,
     OPAQUE = 628,
     TRANSPARENT = 629,
     RADV = 630,
     RA = 631,
     MANAGED = 632,
     OTHER = 633,
     CONFIG = 634,
     MTU = 635,
     REACHABLE = 636,
     RETRANS = 637,
     TIMER = 638,
     CURRENT = 639,
     VALID = 640,
     PREFERRED = 641,
     MULT = 642,
     LIFETIME = 643,
     SKIP = 644,
     ONLINK = 645,
     AUTONOMOUS = 646,
     RDNSS = 647,
     DNSSL = 648,
     NS = 649,
     DOMAIN = 650,
     TRIGGER = 651,
     SENSITIVE = 652,
     LOW = 653,
     MEDIUM = 654,
     HIGH = 655,
     RIP = 656,
     INFINITY = 657,
     UPDATE = 658,
     GARBAGE = 659,
     MULTICAST = 660,
     VERSION = 661,
     SPLIT = 662,
     HORIZON = 663,
     POISON = 664,
     REVERSE = 665,
     ZERO = 666,
     PLAINTEXT = 667,
     RIP_METRIC = 668,
     RIP_TAG = 669,
     STATIC = 670,
     PROHIBIT = 671,
     MULTIPATH = 672,
     BLACKHOLE = 673,
     UNREACHABLE = 674,
     BABEL = 675,
     RXCOST = 676,
     WIRED = 677,
     WIRELESS = 678,
     BABEL_METRIC = 679,
     ENTRIES = 680
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 642 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 1210 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1238 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  73
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3552

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  447
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  317
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1063
/* YYNRULES -- Number of states.  */
#define YYNSTATES  2008

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   680

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     438,   439,    29,    27,   443,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   440,   437,
      23,    22,    24,   444,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   445,     2,   446,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   441,     2,   442,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    74,    76,    77,    82,    85,    86,    88,    91,    93,
      95,    99,   101,   105,   107,   109,   111,   113,   115,   117,
     119,   121,   123,   128,   132,   134,   136,   138,   140,   143,
     148,   152,   156,   160,   164,   168,   172,   177,   181,   185,
     190,   196,   200,   204,   209,   212,   213,   215,   216,   218,
     221,   224,   225,   228,   231,   235,   238,   242,   246,   251,
     254,   258,   262,   266,   269,   274,   280,   282,   286,   288,
     290,   292,   297,   298,   301,   304,   307,   309,   311,   317,
     318,   320,   324,   328,   329,   338,   340,   345,   347,   349,
     350,   352,   355,   359,   360,   363,   366,   369,   372,   375,
     378,   382,   386,   390,   395,   398,   402,   405,   408,   410,
     412,   414,   415,   418,   421,   424,   427,   430,   432,   434,
     438,   442,   443,   445,   447,   450,   451,   453,   457,   459,
     463,   465,   466,   469,   472,   475,   478,   482,   486,   490,
     496,   497,   501,   503,   505,   509,   511,   515,   517,   519,
     521,   523,   525,   527,   529,   531,   535,   537,   541,   543,
     545,   550,   552,   553,   557,   562,   564,   567,   568,   574,
     580,   586,   592,   597,   602,   607,   612,   615,   618,   621,
     624,   627,   630,   633,   636,   639,   642,   646,   650,   655,
     661,   663,   664,   668,   673,   678,   679,   682,   686,   690,
     694,   697,   700,   703,   706,   710,   714,   717,   720,   722,
     724,   726,   731,   732,   736,   740,   744,   745,   747,   749,
     754,   755,   758,   761,   764,   767,   770,   773,   776,   777,
     780,   790,   800,   805,   809,   813,   817,   821,   825,   829,
     833,   837,   841,   846,   848,   850,   854,   855,   857,   861,
     865,   869,   873,   878,   883,   888,   893,   896,   898,   900,
     902,   904,   905,   907,   908,   913,   916,   918,   920,   922,
     924,   926,   928,   930,   932,   934,   936,   938,   940,   942,
     944,   947,   950,   951,   955,   957,   961,   963,   965,   967,
     970,   974,   977,   982,   983,   989,   990,   992,   994,   997,
     999,  1003,  1005,  1007,  1009,  1011,  1013,  1017,  1019,  1021,
    1025,  1027,  1029,  1031,  1033,  1039,  1047,  1053,  1061,  1071,
    1079,  1085,  1093,  1099,  1111,  1113,  1115,  1118,  1120,  1128,
    1138,  1146,  1154,  1164,  1172,  1182,  1190,  1200,  1208,  1224,
    1226,  1228,  1230,  1232,  1236,  1238,  1240,  1242,  1244,  1248,
    1250,  1254,  1256,  1260,  1264,  1266,  1269,  1272,  1279,  1281,
    1285,  1286,  1291,  1295,  1297,  1301,  1305,  1309,  1312,  1317,
    1320,  1323,  1326,  1327,  1330,  1333,  1334,  1336,  1338,  1340,
    1342,  1344,  1346,  1348,  1352,  1356,  1358,  1360,  1366,  1374,
    1382,  1383,  1388,  1390,  1392,  1394,  1396,  1398,  1400,  1402,
    1404,  1406,  1408,  1410,  1414,  1418,  1422,  1426,  1430,  1434,
    1438,  1442,  1446,  1450,  1454,  1458,  1462,  1466,  1470,  1473,
    1478,  1480,  1482,  1484,  1486,  1489,  1492,  1496,  1500,  1507,
    1511,  1515,  1519,  1523,  1527,  1533,  1541,  1548,  1555,  1562,
    1569,  1574,  1583,  1588,  1590,  1592,  1594,  1596,  1598,  1600,
    1602,  1603,  1605,  1609,  1611,  1615,  1616,  1618,  1623,  1630,
    1635,  1639,  1645,  1651,  1656,  1663,  1667,  1670,  1676,  1682,
    1691,  1700,  1709,  1718,  1721,  1723,  1726,  1729,  1732,  1733,
    1737,  1743,  1744,  1745,  1748,  1753,  1758,  1763,  1766,  1769,
    1772,  1774,  1776,  1778,  1781,  1784,  1788,  1792,  1793,  1797,
    1798,  1802,  1807,  1811,  1812,  1815,  1818,  1819,  1822,  1823,
    1826,  1831,  1837,  1840,  1841,  1845,  1849,  1853,  1857,  1863,
    1870,  1875,  1882,  1887,  1894,  1899,  1904,  1910,  1917,  1921,
    1925,  1930,  1936,  1942,  1948,  1954,  1960,  1965,  1970,  1976,
    1982,  1988,  1994,  2000,  2006,  2012,  2018,  2025,  2032,  2039,
    2045,  2052,  2061,  2068,  2075,  2081,  2088,  2093,  2099,  2104,
    2109,  2115,  2120,  2126,  2131,  2137,  2143,  2149,  2155,  2162,
    2168,  2174,  2181,  2187,  2193,  2199,  2204,  2207,  2211,  2215,
    2217,  2220,  2224,  2227,  2232,  2236,  2239,  2243,  2245,  2248,
    2253,  2254,  2258,  2261,  2263,  2266,  2270,  2274,  2278,  2282,
    2285,  2289,  2290,  2296,  2297,  2303,  2306,  2309,  2311,  2316,
    2318,  2320,  2321,  2325,  2328,  2331,  2334,  2340,  2343,  2344,
    2348,  2349,  2352,  2355,  2359,  2362,  2365,  2369,  2372,  2375,
    2378,  2380,  2384,  2387,  2390,  2393,  2396,  2399,  2402,  2406,
    2409,  2412,  2415,  2418,  2421,  2424,  2427,  2430,  2434,  2438,
    2442,  2445,  2449,  2452,  2456,  2460,  2465,  2470,  2473,  2476,
    2479,  2483,  2487,  2491,  2494,  2498,  2502,  2506,  2511,  2514,
    2517,  2519,  2520,  2523,  2527,  2529,  2530,  2532,  2535,  2536,
    2539,  2540,  2542,  2546,  2547,  2548,  2551,  2552,  2556,  2557,
    2561,  2562,  2566,  2570,  2572,  2573,  2578,  2585,  2592,  2599,
    2607,  2614,  2622,  2628,  2629,  2632,  2636,  2639,  2643,  2647,
    2650,  2654,  2657,  2660,  2664,  2668,  2674,  2679,  2684,  2687,
    2689,  2692,  2695,  2696,  2700,  2701,  2705,  2708,  2709,  2713,
    2719,  2720,  2725,  2730,  2734,  2737,  2741,  2745,  2749,  2753,
    2758,  2763,  2767,  2770,  2771,  2775,  2776,  2780,  2784,  2788,
    2790,  2792,  2794,  2795,  2796,  2800,  2801,  2805,  2810,  2812,
    2815,  2818,  2821,  2826,  2831,  2832,  2833,  2837,  2838,  2842,
    2846,  2848,  2849,  2850,  2853,  2856,  2857,  2858,  2862,  2864,
    2870,  2872,  2873,  2874,  2877,  2880,  2881,  2882,  2886,  2888,
    2894,  2896,  2899,  2900,  2903,  2906,  2908,  2911,  2916,  2919,
    2922,  2923,  2927,  2933,  2934,  2935,  2938,  2941,  2944,  2947,
    2950,  2953,  2956,  2960,  2964,  2968,  2972,  2976,  2980,  2984,
    2988,  2992,  2996,  2999,  3003,  3007,  3012,  3016,  3019,  3022,
    3024,  3026,  3028,  3030,  3032,  3033,  3037,  3038,  3042,  3047,
    3054,  3061,  3064,  3068,  3072,  3078,  3084,  3089,  3092,  3096,
    3100,  3104,  3106,  3109,  3114,  3118,  3122,  3126,  3129,  3132,
    3135,  3138,  3141,  3143,  3147,  3148,  3151,  3152,  3156,  3161,
    3164,  3166,  3169,  3170,  3174,  3180,  3181,  3182,  3183,  3186,
    3189,  3193,  3197,  3200,  3203,  3207,  3211,  3214,  3218,  3222,
    3223,  3227,  3228,  3232,  3237,  3244,  3251,  3258,  3260,  3262,
    3264,  3266,  3268,  3270,  3272,  3274,  3276,  3278,  3280,  3282,
    3284,  3286,  3288,  3290,  3292,  3294,  3296,  3298,  3300,  3302,
    3304,  3306,  3308,  3310,  3312,  3314,  3316,  3318,  3320,  3322,
    3324,  3326,  3328,  3330,  3332,  3334,  3336,  3338,  3340,  3342,
    3344,  3346,  3348,  3350,  3352,  3354,  3356,  3358,  3360,  3362,
    3364,  3366,  3368,  3370,  3372,  3374,  3376,  3378,  3380,  3382,
    3384,  3386,  3388,  3390,  3392,  3394,  3397,  3400,  3403,  3405,
    3408,  3411,  3414,  3416,  3418,  3421,  3423,  3427,  3431,  3435,
    3439,  3443,  3447,  3451,  3453,  3455,  3457,  3459,  3461,  3463,
    3465,  3467,  3469,  3471,  3473,  3475,  3477,  3479,  3481,  3483,
    3485,  3487,  3489,  3491,  3493,  3495,  3497,  3499,  3501,  3503,
    3505,  3507,  3509,  3511,  3513,  3515,  3517,  3519,  3521,  3523,
    3525,  3527,  3529,  3531,  3533,  3535,  3537,  3539,  3541,  3543,
    3545,  3547,  3549,  3551
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     448,     0,    -1,   449,     3,    -1,     4,   759,    -1,    -1,
     449,   758,    -1,    34,    19,    22,   616,   437,    -1,    15,
      -1,   438,   616,   439,    -1,    19,    -1,   451,    39,    -1,
     451,    40,    -1,   451,    41,    -1,   451,    -1,    35,    -1,
      37,    -1,    36,    -1,    38,    -1,    -1,    18,    -1,    19,
      -1,    -1,    31,    19,    -1,   454,   458,    -1,   456,    -1,
     454,    -1,    30,   451,    -1,   440,   454,    -1,    20,    -1,
      20,    -1,    19,    -1,    20,    -1,    -1,    43,   464,   465,
     437,    -1,    63,   460,    -1,    -1,   460,    -1,    44,   463,
      -1,    55,    -1,    45,    -1,   441,   466,   442,    -1,   467,
      -1,   466,   443,   467,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,    53,
      -1,    54,    -1,   173,   143,   522,   437,    -1,   173,   460,
     437,    -1,   187,    -1,   118,    -1,    62,    -1,    43,    -1,
     469,    20,    -1,   469,    20,   451,    20,    -1,   469,    58,
      60,    -1,   469,    58,    61,    -1,   469,    59,    60,    -1,
     469,    59,    61,    -1,    57,   470,   437,    -1,    46,    68,
     453,    -1,    46,    68,    69,   452,    -1,    70,    50,   452,
      -1,    70,    67,   452,    -1,    71,   479,   480,     3,    -1,
      71,    56,   479,   480,     3,    -1,    71,    64,     3,    -1,
      71,    65,     3,    -1,    71,    66,   479,     3,    -1,    72,
       3,    -1,    -1,    20,    -1,    -1,    67,    -1,    67,   451,
      -1,   498,    73,    -1,    -1,    69,   451,    -1,    74,   453,
      -1,    75,    76,   451,    -1,    77,   453,    -1,    78,    79,
     453,    -1,    80,    81,   453,    -1,    84,    85,   453,   482,
      -1,   498,    78,    -1,    75,    76,   451,    -1,   153,   461,
     457,    -1,    73,    86,   451,    -1,    87,   451,    -1,   116,
     117,   488,   437,    -1,   116,   117,   138,   513,   437,    -1,
      15,    -1,   438,   616,   439,    -1,    17,    -1,    18,    -1,
      19,    -1,   162,   163,   490,   437,    -1,    -1,   490,   491,
      -1,   166,   454,    -1,    42,   451,    -1,   164,    -1,   165,
      -1,    80,    81,   180,   451,   437,    -1,    -1,   169,    -1,
      86,    19,   493,    -1,   161,    86,    19,    -1,    -1,   496,
     161,   456,   181,    15,   183,    15,   437,    -1,   495,    -1,
     495,   441,   496,   442,    -1,   118,    -1,   119,    -1,    -1,
      19,    -1,   138,    19,    -1,    19,   138,    19,    -1,    -1,
     120,   451,    -1,   121,   453,    -1,    46,   519,    -1,   173,
     522,    -1,   124,   501,    -1,   125,   501,    -1,   130,    69,
     503,    -1,   124,    69,   503,    -1,   125,    69,   503,    -1,
     124,   135,   136,   453,    -1,    86,   504,    -1,   116,   117,
     488,    -1,   168,   460,    -1,   126,   581,    -1,   582,    -1,
      45,    -1,   127,    -1,    -1,   131,   132,    -1,   131,   133,
      -1,   131,    81,    -1,   131,   134,    -1,   451,   502,    -1,
      36,    -1,    19,    -1,    46,   143,   519,    -1,    46,   157,
     451,    -1,    -1,    20,    -1,   457,    -1,    20,   457,    -1,
      -1,    28,    -1,   506,   508,   507,    -1,   509,    -1,   510,
     443,   509,    -1,   510,    -1,    -1,   512,   510,    -1,   178,
     451,    -1,   179,   451,    -1,   498,   122,    -1,   515,   499,
     441,    -1,   516,   500,   437,    -1,   516,   518,   437,    -1,
     516,    66,   322,   453,   437,    -1,    -1,   123,   517,   510,
      -1,    45,    -1,    36,    -1,   441,   520,   442,    -1,   521,
      -1,   520,   443,   521,    -1,   128,    -1,    79,    -1,   129,
      -1,   144,    -1,   141,    -1,   142,    -1,    45,    -1,    36,
      -1,   441,   523,   442,    -1,   524,    -1,   523,   443,   524,
      -1,   128,    -1,   174,    -1,   167,   441,   526,   442,    -1,
     527,    -1,    -1,   527,   437,   526,    -1,   528,   441,   529,
     442,    -1,   528,    -1,   137,   460,    -1,    -1,   160,   138,
     459,   437,   529,    -1,   160,   140,   459,   437,   529,    -1,
     204,   138,   459,   437,   529,    -1,   204,   140,   459,   437,
     529,    -1,   138,   459,   437,   529,    -1,   140,   459,   437,
     529,    -1,   117,   451,   437,   529,    -1,   145,   530,   437,
     529,    -1,   146,   148,    -1,   146,   149,    -1,   146,   150,
      -1,   146,   151,    -1,   146,   152,    -1,   147,   148,    -1,
     147,   149,    -1,   147,   150,    -1,   147,   151,    -1,   147,
     152,    -1,   184,   185,     3,    -1,   184,   176,     3,    -1,
     184,   143,   572,     3,    -1,   184,   143,    45,   572,     3,
      -1,    19,    -1,    -1,   184,   144,     3,    -1,   184,   144,
     186,     3,    -1,   184,   187,   539,     3,    -1,    -1,   539,
     456,    -1,   539,   156,   457,    -1,   539,    86,    19,    -1,
     539,   126,   581,    -1,   539,   582,    -1,   539,    45,    -1,
     539,   153,    -1,   539,   136,    -1,   539,   540,    19,    -1,
     539,   118,    19,    -1,   539,   154,    -1,   539,   155,    -1,
     158,    -1,   125,    -1,   159,    -1,   184,   161,   542,     3,
      -1,    -1,   542,   543,   456,    -1,   542,   183,    15,    -1,
     542,    86,    19,    -1,    -1,   171,    -1,   156,    -1,   184,
     188,   545,     3,    -1,    -1,   545,    86,    -1,   545,   199,
      -1,   545,   126,    -1,   545,   118,    -1,   545,   119,    -1,
     545,   161,    -1,   545,    19,    -1,    -1,    86,    19,    -1,
     189,   161,   456,   181,    15,   183,    15,   546,     3,    -1,
     190,   161,   456,   181,    15,   183,    15,   546,     3,    -1,
     182,   161,   546,     3,    -1,   191,   192,     3,    -1,   191,
     193,     3,    -1,   191,   141,     3,    -1,   191,   144,     3,
      -1,   191,   194,     3,    -1,   191,   195,     3,    -1,   191,
      79,     3,    -1,   191,   143,     3,    -1,   196,   616,     3,
      -1,   197,   560,   561,     3,    -1,    45,    -1,    36,    -1,
     441,   466,   442,    -1,    -1,    15,    -1,   134,   571,     3,
      -1,   198,   571,     3,    -1,    81,   571,     3,    -1,   170,
     571,     3,    -1,   170,   171,   571,     3,    -1,   170,   172,
     571,     3,    -1,    46,   571,   519,     3,    -1,   173,   571,
     522,     3,    -1,   175,     3,    -1,    19,    -1,    45,    -1,
      20,    -1,    19,    -1,    -1,    20,    -1,    -1,   126,    19,
     574,   580,    -1,   196,   616,    -1,   207,    -1,   208,    -1,
     209,    -1,   210,    -1,   211,    -1,   212,    -1,   213,    -1,
     214,    -1,   216,    -1,   217,    -1,   218,    -1,   219,    -1,
     220,    -1,   221,    -1,   576,   215,    -1,   576,    19,    -1,
      -1,   577,   437,   578,    -1,   577,    -1,   577,   437,   579,
      -1,   584,    -1,    19,    -1,   580,    -1,   253,   616,    -1,
     438,   579,   439,    -1,   438,   439,    -1,   578,   441,   587,
     442,    -1,    -1,   199,    19,   586,   583,   584,    -1,    -1,
     588,    -1,   622,    -1,   588,   622,    -1,   622,    -1,   441,
     587,   442,    -1,    18,    -1,    15,    -1,    17,    -1,   590,
      -1,    16,    -1,   438,   616,   439,    -1,    19,    -1,    15,
      -1,   438,   616,   439,    -1,    17,    -1,   590,    -1,    16,
      -1,   616,    -1,   438,   593,   443,   593,   439,    -1,   438,
     593,   443,   593,     7,   593,   439,    -1,   438,   593,   443,
      29,   439,    -1,   438,   593,     7,   593,   443,   593,   439,
      -1,   438,   593,     7,   593,   443,   593,     7,   593,   439,
      -1,   438,   593,     7,   593,   443,    29,   439,    -1,   438,
      29,   443,   593,   439,    -1,   438,    29,   443,   593,     7,
     593,   439,    -1,   438,    29,   443,    29,   439,    -1,   438,
     593,   443,   593,   439,     7,   438,   593,   443,   593,   439,
      -1,   228,    -1,   229,    -1,   230,    15,    -1,   231,    -1,
     438,   595,   443,   593,   443,   593,   439,    -1,   438,   595,
     443,   593,   443,   593,     7,   593,   439,    -1,   438,   595,
     443,   593,   443,    29,   439,    -1,   438,   593,   443,   593,
     443,   593,   439,    -1,   438,   593,   443,   593,   443,   593,
       7,   593,   439,    -1,   438,   593,   443,   593,   443,    29,
     439,    -1,   438,   593,   443,   593,     7,   593,   443,    29,
     439,    -1,   438,   593,   443,    29,   443,    29,   439,    -1,
     438,   593,     7,   593,   443,    29,   443,    29,   439,    -1,
     438,    29,   443,    29,   443,    29,   439,    -1,   438,   593,
     443,   593,   443,   593,   439,     7,   438,   593,   443,   593,
     443,   593,   439,    -1,   594,    -1,   596,    -1,   597,    -1,
     591,    -1,   591,     7,   591,    -1,   594,    -1,   596,    -1,
     597,    -1,   592,    -1,   592,     7,   592,    -1,   598,    -1,
     600,   443,   598,    -1,   599,    -1,   601,   443,   599,    -1,
      18,    30,    15,    -1,   602,    -1,   602,    27,    -1,   602,
      28,    -1,   602,   441,    15,   443,    15,   442,    -1,   603,
      -1,   604,   443,   603,    -1,    -1,   605,   601,   440,   587,
      -1,   605,     6,   587,    -1,   614,    -1,   438,   616,   439,
      -1,    13,   608,    14,    -1,    30,   609,    30,    -1,    15,
     608,    -1,    15,     7,    15,   608,    -1,    29,   608,    -1,
     444,   608,    -1,   606,   608,    -1,    -1,    15,   609,    -1,
     444,   609,    -1,    -1,    15,    -1,   226,    -1,   227,    -1,
      20,    -1,   590,    -1,   602,    -1,    17,    -1,   445,   600,
     446,    -1,   445,   604,   446,    -1,    16,    -1,   607,    -1,
     438,   616,   443,   616,   439,    -1,   438,   595,   443,   616,
     443,   616,   439,    -1,   438,   616,   443,   616,   443,   616,
     439,    -1,    -1,    19,   438,   621,   439,    -1,    19,    -1,
     138,    -1,   232,    -1,   233,    -1,   235,    -1,   236,    -1,
     237,    -1,   238,    -1,   239,    -1,   240,    -1,   241,    -1,
     438,   616,   439,    -1,   616,    27,   616,    -1,   616,    28,
     616,    -1,   616,    29,   616,    -1,   616,    30,   616,    -1,
     616,    11,   616,    -1,   616,    12,   616,    -1,   616,    22,
     616,    -1,   616,    10,   616,    -1,   616,    23,   616,    -1,
     616,     9,   616,    -1,   616,    24,   616,    -1,   616,     8,
     616,    -1,   616,    25,   616,    -1,   616,    26,   616,    -1,
      32,   616,    -1,   243,   438,   616,   439,    -1,   614,    -1,
     610,    -1,   611,    -1,   120,    -1,   612,   615,    -1,   612,
     763,    -1,   616,    33,   209,    -1,   616,    33,   242,    -1,
     616,    33,   234,   438,   616,   439,    -1,   616,    33,   247,
      -1,   616,    33,   248,    -1,   616,    33,   249,    -1,    27,
     252,    27,    -1,    28,   252,    28,    -1,    28,    28,   252,
      28,    28,    -1,    28,    28,    28,   252,    28,    28,    28,
      -1,   246,   438,   616,   443,   616,   439,    -1,   189,   438,
     616,   443,   616,   439,    -1,   190,   438,   616,   443,   616,
     439,    -1,   126,   438,   616,   443,   616,   439,    -1,   251,
     438,    19,   439,    -1,   251,   438,    19,   443,   616,   443,
     616,   439,    -1,    19,   438,   621,   439,    -1,   206,    -1,
     204,    -1,   205,    -1,    51,    -1,   200,    -1,   201,    -1,
     616,    -1,    -1,   618,    -1,   618,   443,   619,    -1,   616,
      -1,   616,   443,   620,    -1,    -1,   620,    -1,   222,   616,
     223,   589,    -1,   222,   616,   223,   589,   224,   589,    -1,
      19,    22,   616,   437,    -1,   203,   616,   437,    -1,   612,
     763,    22,   616,   437,    -1,   612,   615,    22,   616,   437,
      -1,   120,    22,   616,   437,    -1,   202,   438,   612,   763,
     439,   437,    -1,   617,   619,   437,    -1,   613,   437,    -1,
     225,   616,   441,   605,   442,    -1,   612,   763,    33,   252,
     437,    -1,   612,   763,    33,   246,   438,   616,   439,   437,
      -1,   612,   763,    33,   189,   438,   616,   439,   437,    -1,
     612,   763,    33,   190,   438,   616,   439,   437,    -1,   612,
     763,    33,   126,   438,   616,   439,   437,    -1,   498,   254,
      -1,   500,    -1,   123,   633,    -1,   261,   634,    -1,   262,
     638,    -1,    -1,   625,   624,   437,    -1,   623,   499,   441,
     625,   442,    -1,    -1,    -1,   259,   452,    -1,   255,   257,
     259,   452,    -1,   255,   258,   259,   452,    -1,   256,   258,
     259,   452,    -1,   260,   451,    -1,   139,   453,    -1,   265,
     630,    -1,   525,    -1,   127,    -1,   266,    -1,   146,   148,
      -1,   146,   149,    -1,   267,   146,   148,    -1,   267,   146,
     149,    -1,    -1,   631,   629,   437,    -1,    -1,   441,   631,
     442,    -1,   627,   511,   632,   628,    -1,   627,   632,   628,
      -1,    -1,    31,    19,    -1,   263,   460,    -1,    -1,   264,
     454,    -1,    -1,   261,   453,    -1,   454,   635,   636,   637,
      -1,   184,   254,   268,   535,     3,    -1,   498,   163,    -1,
      -1,   641,    42,   451,    -1,   641,   183,   451,    -1,   640,
     499,   441,    -1,   642,   500,   437,    -1,   642,   264,   183,
     451,   437,    -1,   642,   264,   454,   183,   451,   437,    -1,
     642,   262,   641,   437,    -1,   642,   262,   454,   455,   641,
     437,    -1,   642,   123,    20,   437,    -1,   642,   293,   296,
     117,   488,   437,    -1,   642,   293,   295,   437,    -1,   642,
     294,   295,   437,    -1,   642,   269,    76,   451,   437,    -1,
     642,   273,   269,    76,   451,   437,    -1,   642,   122,   437,
      -1,   642,   261,   437,    -1,   642,   261,   451,   437,    -1,
     642,   275,   276,   277,   437,    -1,   642,   275,   276,   135,
     437,    -1,   642,   303,   304,   277,   437,    -1,   642,   303,
     304,   305,   437,    -1,   642,   303,   304,   306,   437,    -1,
     642,   313,   122,   437,    -1,   642,   313,   314,   437,    -1,
     642,   279,    87,   453,   437,    -1,   642,   315,    87,   453,
     437,    -1,   642,   312,    87,   453,   437,    -1,   642,   301,
     302,   453,   437,    -1,   642,   318,   315,   453,   437,    -1,
     642,   278,   286,   451,   437,    -1,   642,   278,   285,   451,
     437,    -1,   642,   236,   166,   454,   437,    -1,   642,   280,
     281,    76,   451,   437,    -1,   642,   270,   281,    76,   451,
     437,    -1,   642,   270,   271,    76,   451,   437,    -1,   642,
     272,    76,   451,   437,    -1,   642,    51,   282,    76,   451,
     437,    -1,   642,    51,   180,    76,   451,   443,   451,   437,
      -1,   642,   134,   283,    51,   453,   437,    -1,   642,   198,
     187,   307,   453,   437,    -1,   642,   198,   297,   453,   437,
      -1,   642,   198,   323,   174,   453,   437,    -1,   642,   300,
     453,   437,    -1,   642,   298,   299,   453,   437,    -1,   642,
     137,   460,   437,    -1,   642,   324,   453,   437,    -1,   642,
     187,    69,   451,   437,    -1,   642,   139,   453,   437,    -1,
     642,   308,   309,   453,   437,    -1,   642,   319,   453,   437,
      -1,   642,   189,    85,   257,   437,    -1,   642,   189,    85,
     258,   437,    -1,   642,   189,    85,   453,   437,    -1,   642,
     320,   264,   183,   437,    -1,   642,   320,   264,   183,   451,
     437,    -1,   642,    80,    81,   453,   437,    -1,   642,    80,
      81,   321,   437,    -1,   642,    80,    81,    76,   451,   437,
      -1,   642,   312,    86,   504,   437,    -1,   642,   316,   317,
     453,   437,    -1,   642,    66,   322,   453,   437,    -1,   642,
     254,   453,   437,    -1,   498,   326,    -1,   643,   499,   441,
      -1,   644,   645,   437,    -1,   500,    -1,   332,   453,    -1,
     333,   116,   453,    -1,   366,   453,    -1,   366,   453,    69,
     451,    -1,    84,   364,   453,    -1,   334,   451,    -1,   373,
     117,   451,    -1,   647,    -1,   327,   488,    -1,   646,   441,
     648,   442,    -1,    -1,   648,   649,   437,    -1,   333,   453,
      -1,   368,    -1,   186,   453,    -1,   278,   368,   453,    -1,
     278,   335,   451,    -1,   278,   336,   451,    -1,   333,   335,
     451,    -1,   369,   453,    -1,   369,   370,   451,    -1,    -1,
     355,   650,   441,   661,   442,    -1,    -1,   364,   651,   441,
     661,   442,    -1,   362,   652,    -1,   123,   674,    -1,   656,
      -1,   653,   441,   654,   442,    -1,   653,    -1,   456,    -1,
      -1,   654,   655,   437,    -1,   356,   453,    -1,   186,   453,
      -1,   335,   451,    -1,   659,   669,   441,   657,   442,    -1,
     659,   669,    -1,    -1,   657,   658,   437,    -1,    -1,   338,
     451,    -1,   337,   451,    -1,   339,   281,   451,    -1,   180,
     451,    -1,   341,   451,    -1,   341,   155,   451,    -1,   265,
     127,    -1,   265,   266,    -1,   265,   352,    -1,   525,    -1,
     357,   322,   488,    -1,   335,   451,    -1,   338,   451,    -1,
     354,   451,    -1,   337,   451,    -1,   180,   451,    -1,   341,
     451,    -1,   341,   155,   451,    -1,   342,   343,    -1,   342,
     344,    -1,   342,   345,    -1,   342,   346,    -1,   342,   347,
      -1,   342,   348,    -1,   342,   349,    -1,   342,   350,    -1,
     374,   343,   453,    -1,   348,   375,   453,    -1,   339,   281,
     451,    -1,   340,   451,    -1,   351,   345,   453,    -1,   333,
     453,    -1,    66,   322,   453,    -1,   366,   367,   451,    -1,
     322,   377,   378,   453,    -1,   194,   441,   665,   442,    -1,
     265,   127,    -1,   265,   266,    -1,   265,   352,    -1,   257,
     359,   361,    -1,   257,   359,   360,    -1,   257,   359,   451,
      -1,   258,   514,    -1,   258,   340,   451,    -1,   258,   376,
     451,    -1,   316,   317,   453,    -1,   316,   317,   258,   358,
      -1,   254,   453,    -1,   319,   453,    -1,   525,    -1,    -1,
     661,   662,    -1,   663,   664,   437,    -1,   456,    -1,    -1,
     356,    -1,   363,   451,    -1,    -1,   665,   667,    -1,    -1,
     353,    -1,   454,   666,   437,    -1,    -1,    -1,   373,   451,
      -1,    -1,   510,   671,   669,    -1,    -1,   672,   660,   437,
      -1,    -1,   441,   672,   442,    -1,   668,   670,   673,    -1,
      20,    -1,    -1,   184,   326,   535,     3,    -1,   184,   326,
     194,   535,   675,     3,    -1,   184,   326,   123,   535,   675,
       3,    -1,   184,   326,   379,   535,   675,     3,    -1,   184,
     326,   379,    45,   535,   675,     3,    -1,   184,   326,   380,
     535,   675,     3,    -1,   184,   326,   380,    45,   535,   675,
       3,    -1,   184,   326,   365,   684,     3,    -1,    -1,   684,
     371,    -1,   684,   327,   488,    -1,   684,   322,    -1,   684,
     342,    15,    -1,   684,   372,   488,    -1,   684,   277,    -1,
     684,   116,   488,    -1,   684,    19,    -1,   498,   381,    -1,
     685,   499,   441,    -1,   686,   500,   437,    -1,   686,   382,
      86,    19,   437,    -1,   686,   383,   384,   437,    -1,   686,
     383,   385,   437,    -1,   498,   386,    -1,   500,    -1,   123,
     701,    -1,   210,   707,    -1,    -1,   403,   689,   713,    -1,
      -1,   404,   690,   719,    -1,   407,   456,    -1,    -1,   691,
     688,   437,    -1,   687,   499,   441,   691,   442,    -1,    -1,
     255,   387,   259,   451,    -1,   181,   387,   259,   451,    -1,
     255,   281,   451,    -1,   388,   453,    -1,   389,   390,   453,
      -1,   322,   391,   451,    -1,   392,    76,   451,    -1,   393,
     394,   451,    -1,   395,   276,    69,   451,    -1,   278,   399,
     451,   721,    -1,   278,   120,   697,    -1,   210,   707,    -1,
      -1,   403,   695,   713,    -1,    -1,   404,   696,   719,    -1,
     403,   264,   453,    -1,   404,   264,   453,    -1,   409,    -1,
     410,    -1,   411,    -1,    -1,    -1,   699,   694,   437,    -1,
      -1,   441,   699,   442,    -1,   693,   511,   700,   698,    -1,
     456,    -1,   400,   453,    -1,   401,   453,    -1,   402,   453,
      -1,   396,   399,   451,   721,    -1,   397,   399,   451,   721,
      -1,    -1,    -1,   705,   703,   437,    -1,    -1,   441,   705,
     442,    -1,   702,   706,   704,    -1,   454,    -1,    -1,    -1,
     405,   708,    -1,   399,   720,    -1,    -1,    -1,   712,   710,
     437,    -1,   708,    -1,   441,   709,   712,   442,   711,    -1,
      20,    -1,    -1,    -1,   406,   714,    -1,   399,   720,    -1,
      -1,    -1,   718,   716,   437,    -1,   714,    -1,   441,   715,
     718,   442,   717,    -1,   451,    -1,   398,   451,    -1,    -1,
     408,   453,    -1,   498,   412,    -1,   500,    -1,   366,   453,
      -1,   366,   453,    69,   451,    -1,   413,   451,    -1,   123,
     732,    -1,    -1,   724,   723,   437,    -1,   722,   499,   441,
     724,   442,    -1,    -1,    -1,    87,   451,    -1,   383,   416,
      -1,   383,   343,    -1,   139,   453,    -1,   166,   454,    -1,
      42,   451,    -1,   417,   451,    -1,   417,   358,   453,    -1,
     418,   419,   453,    -1,   420,   421,   453,    -1,    66,   422,
     453,    -1,   414,    76,   451,    -1,    67,    76,   451,    -1,
     415,    76,   451,    -1,   366,   367,   451,    -1,   257,   359,
     451,    -1,   258,   376,   451,    -1,   258,   514,    -1,   258,
     340,   451,    -1,   316,   317,   453,    -1,   316,   317,   258,
     358,    -1,    66,   322,   453,    -1,   254,   453,    -1,   265,
     729,    -1,   525,    -1,   127,    -1,   423,    -1,   352,    -1,
     148,    -1,    -1,   730,   728,   437,    -1,    -1,   441,   730,
     442,    -1,   726,   511,   731,   727,    -1,   184,   412,   144,
     535,   675,     3,    -1,   184,   412,   194,   535,   675,     3,
      -1,   498,   426,    -1,   735,   499,   441,    -1,   736,   500,
     437,    -1,   736,    66,   322,   453,   437,    -1,   736,   312,
      86,   504,   437,    -1,   736,   740,   743,   437,    -1,   187,
     456,    -1,   274,   454,   455,    -1,   738,   367,   451,    -1,
     738,   254,   453,    -1,   738,    -1,   739,   738,    -1,   737,
     274,   454,   455,    -1,   737,   274,    20,    -1,   737,   428,
     739,    -1,   737,   314,   454,    -1,   737,   305,    -1,   737,
     205,    -1,   737,   429,    -1,   737,   430,    -1,   737,   427,
      -1,   622,    -1,   254,   453,   437,    -1,    -1,   742,   741,
      -1,    -1,   441,   742,   442,    -1,   184,   426,   535,     3,
      -1,   498,   431,    -1,   500,    -1,   123,   754,    -1,    -1,
     747,   746,   437,    -1,   745,   499,   441,   747,   442,    -1,
      -1,    -1,    -1,    42,   451,    -1,   432,   451,    -1,   338,
     259,   451,    -1,   414,   259,   451,    -1,   342,   433,    -1,
     342,   434,    -1,   257,   359,   451,    -1,   258,   376,   451,
      -1,   258,   514,    -1,   258,   340,   451,    -1,    66,   322,
     453,    -1,    -1,   752,   751,   437,    -1,    -1,   441,   752,
     442,    -1,   749,   511,   753,   750,    -1,   184,   431,   144,
     535,   675,     3,    -1,   184,   431,   194,   535,   675,     3,
      -1,   184,   431,   436,   535,   675,     3,    -1,   437,    -1,
     450,    -1,   462,    -1,   468,    -1,   471,    -1,   472,    -1,
     487,    -1,   489,    -1,   492,    -1,   494,    -1,   497,    -1,
     760,    -1,   505,    -1,   573,    -1,   575,    -1,   585,    -1,
     473,    -1,   474,    -1,   475,    -1,   476,    -1,   477,    -1,
     478,    -1,   531,    -1,   532,    -1,   533,    -1,   534,    -1,
     536,    -1,   537,    -1,   538,    -1,   541,    -1,   544,    -1,
     547,    -1,   548,    -1,   549,    -1,   550,    -1,   551,    -1,
     552,    -1,   553,    -1,   554,    -1,   555,    -1,   556,    -1,
     557,    -1,   558,    -1,   559,    -1,   562,    -1,   563,    -1,
     564,    -1,   565,    -1,   566,    -1,   567,    -1,   568,    -1,
     569,    -1,   570,    -1,   639,    -1,   676,    -1,   677,    -1,
     678,    -1,   679,    -1,   680,    -1,   681,    -1,   682,    -1,
     683,    -1,   733,    -1,   734,    -1,   744,    -1,   755,    -1,
     756,    -1,   757,    -1,   761,   442,    -1,   762,   442,    -1,
     516,   442,    -1,   626,    -1,   642,   442,    -1,   644,   442,
      -1,   686,   442,    -1,   692,    -1,   725,    -1,   736,   442,
      -1,   748,    -1,   481,   499,   441,    -1,   761,   500,   437,
      -1,   761,   483,   437,    -1,   761,   486,   437,    -1,   484,
     499,   441,    -1,   762,   500,   437,    -1,   762,   485,   437,
      -1,    82,    -1,    83,    -1,    88,    -1,    89,    -1,    90,
      -1,    91,    -1,    92,    -1,    93,    -1,    94,    -1,    95,
      -1,    96,    -1,    97,    -1,    98,    -1,    99,    -1,   100,
      -1,   101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,
      -1,   106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,
      -1,   111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,
      -1,   177,    -1,     5,    -1,   287,    -1,   284,    -1,   288,
      -1,   286,    -1,   285,    -1,   289,    -1,   290,    -1,   291,
      -1,   310,    -1,   311,    -1,   292,    -1,   325,    -1,   328,
      -1,   329,    -1,   330,    -1,   331,    -1,   424,    -1,   425,
      -1,   435,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   846,   846,   847,   850,   852,   860,   869,   870,   871,
     878,   879,   880,   888,   889,   890,   891,   892,   893,   899,
     900,   907,   908,   912,   919,   920,   924,   928,   935,   943,
     944,   951,   952,   958,   967,   968,   972,   977,   978,   982,
     983,   987,   988,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1006,  1007,  1017,  1018,  1019,  1020,  1023,  1024,
    1025,  1026,  1027,  1028,  1032,  1038,  1039,  1040,  1041,  1049,
    1052,  1059,  1062,  1065,  1068,  1072,  1073,  1077,  1078,  1079,
    1087,  1092,  1093,  1097,  1098,  1102,  1109,  1110,  1111,  1123,
    1128,  1132,  1146,  1147,  1161,  1162,  1166,  1167,  1168,  1169,
    1176,  1190,  1192,  1194,  1198,  1199,  1200,  1201,  1206,  1212,
    1213,  1217,  1225,  1229,  1231,  1237,  1238,  1245,  1246,  1250,
    1256,  1260,  1269,  1278,  1280,  1284,  1285,  1286,  1287,  1288,
    1289,  1290,  1291,  1292,  1293,  1294,  1295,  1299,  1300,  1301,
    1302,  1306,  1307,  1308,  1309,  1310,  1314,  1320,  1324,  1332,
    1333,  1341,  1349,  1350,  1351,  1355,  1356,  1360,  1365,  1366,
    1370,  1372,  1380,  1384,  1385,  1391,  1398,  1399,  1400,  1401,
    1405,  1413,  1419,  1420,  1421,  1425,  1426,  1430,  1431,  1432,
    1433,  1434,  1435,  1441,  1442,  1443,  1447,  1448,  1452,  1453,
    1459,  1460,  1463,  1465,  1469,  1470,  1474,  1494,  1495,  1496,
    1497,  1498,  1499,  1500,  1501,  1502,  1506,  1507,  1508,  1509,
    1510,  1511,  1512,  1513,  1514,  1515,  1521,  1524,  1527,  1530,
    1534,  1535,  1538,  1541,  1545,  1549,  1554,  1560,  1567,  1572,
    1577,  1582,  1586,  1590,  1594,  1603,  1611,  1615,  1622,  1623,
    1624,  1629,  1633,  1640,  1647,  1651,  1659,  1660,  1661,  1666,
    1670,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1684,  1689,
    1697,  1704,  1711,  1719,  1721,  1723,  1725,  1727,  1729,  1731,
    1733,  1736,  1740,  1746,  1747,  1748,  1752,  1753,  1759,  1761,
    1763,  1765,  1767,  1769,  1773,  1777,  1780,  1784,  1785,  1786,
    1790,  1791,  1792,  1800,  1800,  1810,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1850,  1861,  1862,  1869,  1870,  1877,  1886,  1890,  1894,
    1918,  1919,  1923,  1936,  1936,  1952,  1953,  1956,  1957,  1961,
    1964,  1973,  1986,  1987,  1988,  1989,  1990,  1994,  2002,  2003,
    2004,  2005,  2006,  2010,  2013,  2014,  2015,  2016,  2017,  2018,
    2019,  2020,  2021,  2022,  2027,  2028,  2029,  2030,  2034,  2035,
    2036,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2052,
    2053,  2054,  2055,  2056,  2060,  2061,  2062,  2063,  2064,  2068,
    2069,  2073,  2074,  2078,  2085,  2086,  2087,  2088,  2095,  2096,
    2099,  2100,  2107,  2119,  2120,  2124,  2125,  2129,  2130,  2131,
    2132,  2133,  2134,  2138,  2139,  2140,  2144,  2145,  2146,  2147,
    2148,  2149,  2150,  2151,  2152,  2153,  2154,  2158,  2159,  2160,
    2170,  2174,  2197,  2211,  2212,  2213,  2214,  2215,  2216,  2217,
    2218,  2219,  2220,  2224,  2225,  2226,  2227,  2228,  2229,  2230,
    2231,  2232,  2233,  2234,  2235,  2236,  2237,  2238,  2239,  2240,
    2242,  2243,  2244,  2246,  2248,  2250,  2252,  2253,  2254,  2255,
    2256,  2257,  2267,  2268,  2269,  2270,  2271,  2272,  2273,  2274,
    2276,  2277,  2282,  2305,  2306,  2307,  2308,  2309,  2310,  2314,
    2317,  2318,  2319,  2327,  2334,  2343,  2344,  2348,  2354,  2364,
    2373,  2379,  2384,  2391,  2396,  2402,  2403,  2404,  2412,  2413,
    2414,  2415,  2416,  2422,  2434,  2435,  2436,  2437,  2440,  2442,
    2446,  2450,  2464,  2484,  2485,  2486,  2487,  2488,  2489,  2490,
    2491,  2495,  2496,  2497,  2498,  2499,  2500,  2503,  2505,  2508,
    2510,  2514,  2517,  2522,  2523,  2524,  2528,  2529,  2533,  2534,
    2537,  2556,  2562,  2587,  2589,  2590,  2594,  2595,  2596,  2597,
    2598,  2599,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
    2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,
    2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,
    2633,  2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,
    2643,  2649,  2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,
    2658,  2659,  2660,  2661,  2662,  2663,  2674,  2684,  2685,  2689,
    2690,  2691,  2692,  2693,  2694,  2695,  2696,  2697,  2700,  2715,
    2718,  2720,  2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,
    2732,  2733,  2733,  2734,  2734,  2735,  2736,  2737,  2741,  2742,
    2746,  2754,  2756,  2760,  2761,  2762,  2766,  2767,  2770,  2772,
    2775,  2776,  2777,  2778,  2779,  2780,  2781,  2782,  2783,  2784,
    2785,  2788,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,
    2816,  2817,  2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,
    2826,  2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,
    2836,  2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,
    2846,  2849,  2851,  2854,  2856,  2865,  2867,  2868,  2871,  2873,
    2877,  2878,  2881,  2891,  2912,  2914,  2918,  2918,  2921,  2923,
    2926,  2928,  2932,  2936,  2937,  2942,  2945,  2948,  2953,  2956,
    2961,  2964,  2968,  2972,  2975,  2976,  2977,  2978,  2979,  2980,
    2981,  2982,  2988,  2995,  2996,  2997,  3002,  3003,  3009,  3019,
    3020,  3021,  3022,  3022,  3023,  3023,  3024,  3031,  3033,  3037,
    3041,  3059,  3060,  3061,  3062,  3063,  3064,  3065,  3066,  3067,
    3068,  3073,  3074,  3075,  3075,  3076,  3076,  3077,  3078,  3082,
    3083,  3084,  3087,  3105,  3107,  3110,  3112,  3116,  3119,  3132,
    3133,  3134,  3135,  3140,  3148,  3156,  3158,  3161,  3163,  3167,
    3171,  3181,  3186,  3187,  3188,  3192,  3204,  3206,  3210,  3211,
    3215,  3228,  3233,  3234,  3235,  3239,  3251,  3253,  3257,  3258,
    3263,  3264,  3268,  3269,  3275,  3288,  3289,  3290,  3291,  3292,
    3295,  3297,  3301,  3305,  3328,  3358,  3359,  3360,  3361,  3362,
    3363,  3364,  3368,  3369,  3370,  3371,  3372,  3373,  3374,  3375,
    3376,  3377,  3378,  3379,  3380,  3381,  3382,  3383,  3384,  3385,
    3389,  3390,  3391,  3392,  3395,  3397,  3400,  3402,  3406,  3412,
    3415,  3422,  3429,  3430,  3431,  3432,  3433,  3436,  3446,  3455,
    3459,  3465,  3466,  3470,  3475,  3481,  3484,  3489,  3490,  3491,
    3492,  3493,  3497,  3498,  3501,  3503,  3506,  3508,  3512,  3518,
    3525,  3526,  3529,  3531,  3535,  3539,  3552,  3575,  3576,  3577,
    3578,  3579,  3580,  3581,  3582,  3583,  3584,  3585,  3586,  3589,
    3591,  3594,  3596,  3601,  3606,  3609,  3612,  3619,  3619,  3619,
    3619,  3619,  3619,  3619,  3619,  3619,  3619,  3619,  3619,  3619,
    3619,  3619,  3619,  3620,  3620,  3620,  3620,  3620,  3620,  3620,
    3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,
    3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,
    3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,
    3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,  3620,
    3620,  3620,  3620,  3620,  3620,  3621,  3621,  3621,  3621,  3621,
    3621,  3621,  3621,  3621,  3621,  3621,  3622,  3622,  3622,  3622,
    3623,  3623,  3623,  3624,  3624,  3624,  3624,  3624,  3624,  3624,
    3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,
    3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,  3624,
    3624,  3624,  3624,  3624,  3625,  3625,  3626,  3627,  3628,  3629,
    3630,  3631,  3632,  3633,  3634,  3635,  3636,  3637,  3637,  3637,
    3637,  3637,  3637,  3637
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256",
  "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY",
  "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW", "STATUS",
  "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO", "ENABLE",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "LC",
  "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE", "CAST",
  "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "AUTHENTICATION",
  "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT", "RETRY",
  "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH",
  "START", "DELAY", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC",
  "SECONDARY", "ALLOW", "AWARE", "LINK", "EXTENDED", "SETKEY",
  "BGP_LARGE_COMMUNITY", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST",
  "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "LENGTH", "LSA", "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE",
  "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RADV", "RA", "MANAGED",
  "OTHER", "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT",
  "VALID", "PREFERRED", "MULT", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS",
  "RDNSS", "DNSSL", "NS", "DOMAIN", "TRIGGER", "SENSITIVE", "LOW",
  "MEDIUM", "HIGH", "RIP", "INFINITY", "UPDATE", "GARBAGE", "MULTICAST",
  "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE",
  "UNREACHABLE", "BABEL", "RXCOST", "WIRED", "WIRELESS", "BABEL_METRIC",
  "ENTRIES", "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['",
  "']'", "$accept", "config", "conf_entries", "definition", "expr",
  "expr_us", "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_mp_limit", "kern_item",
  "kif_proto_start", "kif_item", "kern_sys_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "gr_opts", "tab_sorted", "newtab",
  "roa_table_start", "roa_table_opts", "roa_table", "proto_start",
  "proto_name", "proto_item", "imexport", "limit_action", "limit_spec",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_list_nopx", "iface_patt_init",
  "iface_patt", "tos", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "password_algorithm", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "cnum", "pair_item", "ec_kind", "ec_item", "lc_item",
  "set_item", "switch_item", "set_items", "switch_items", "fprefix_s",
  "fprefix", "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item", "bfd_auth_type",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,    59,    40,    41,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   447,   448,   448,   449,   449,   450,   451,   451,   451,
     452,   452,   452,   453,   453,   453,   453,   453,   453,   454,
     454,   455,   455,   456,   457,   457,   458,   458,   459,   460,
     460,   461,   461,   462,   463,   463,   464,   464,   464,   465,
     465,   466,   466,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   468,   468,   469,   469,   469,   469,   470,   470,
     470,   470,   470,   470,   471,   472,   472,   472,   472,   473,
     474,   475,   476,   477,   478,   479,   479,   480,   480,   480,
     481,   482,   482,   483,   483,   483,   483,   483,   483,   484,
     485,   485,   486,   486,   487,   487,   488,   488,   488,   488,
     488,   489,   490,   490,   491,   491,   491,   491,   492,   493,
     493,   494,   495,   496,   496,   497,   497,   498,   498,   499,
     499,   499,   499,   500,   500,   500,   500,   500,   500,   500,
     500,   500,   500,   500,   500,   500,   500,   501,   501,   501,
     501,   502,   502,   502,   502,   502,   503,   503,   504,   505,
     505,   506,   507,   507,   507,   508,   508,   509,   510,   510,
     511,   512,   513,   514,   514,   515,   516,   516,   516,   516,
     517,   518,   519,   519,   519,   520,   520,   521,   521,   521,
     521,   521,   521,   522,   522,   522,   523,   523,   524,   524,
     525,   525,   526,   526,   527,   527,   528,   529,   529,   529,
     529,   529,   529,   529,   529,   529,   530,   530,   530,   530,
     530,   530,   530,   530,   530,   530,   531,   532,   533,   534,
     535,   535,   536,   537,   538,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   540,   540,
     540,   541,   542,   542,   542,   542,   543,   543,   543,   544,
     545,   545,   545,   545,   545,   545,   545,   545,   546,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   560,   560,   561,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   571,   571,
     572,   572,   572,   574,   573,   575,   576,   576,   576,   576,
     576,   576,   576,   576,   576,   576,   576,   576,   576,   576,
     576,   577,   578,   578,   579,   579,   580,   581,   581,   582,
     583,   583,   584,   586,   585,   587,   587,   588,   588,   589,
     589,   590,   591,   591,   591,   591,   591,   591,   592,   592,
     592,   592,   592,   593,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   595,   595,   595,   595,   596,   596,
     596,   597,   597,   597,   597,   597,   597,   597,   597,   598,
     598,   598,   598,   598,   599,   599,   599,   599,   599,   600,
     600,   601,   601,   602,   603,   603,   603,   603,   604,   604,
     605,   605,   605,   606,   606,   607,   607,   608,   608,   608,
     608,   608,   608,   609,   609,   609,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   611,   611,   611,
     612,   613,   614,   615,   615,   615,   615,   615,   615,   615,
     615,   615,   615,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   617,   617,   617,   617,   617,   617,   618,
     619,   619,   619,   620,   620,   621,   621,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   623,   624,   624,   624,   624,   625,   625,
     626,   627,   628,   629,   629,   629,   629,   629,   629,   629,
     629,   630,   630,   630,   630,   630,   630,   631,   631,   632,
     632,   633,   634,   635,   635,   635,   636,   636,   637,   637,
     638,   639,   640,   641,   641,   641,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   643,   644,   644,   645,
     645,   645,   645,   645,   645,   645,   645,   645,   646,   647,
     648,   648,   649,   649,   649,   649,   649,   649,   649,   649,
     649,   650,   649,   651,   649,   649,   649,   649,   652,   652,
     653,   654,   654,   655,   655,   655,   656,   656,   657,   657,
     658,   658,   658,   658,   658,   658,   658,   658,   658,   658,
     658,   659,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   660,   660,   660,   660,   660,   660,   660,   660,   660,
     660,   661,   661,   662,   663,   664,   664,   664,   665,   665,
     666,   666,   667,   668,   669,   669,   671,   670,   672,   672,
     673,   673,   674,   675,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   684,   684,   684,   684,   684,   684,
     684,   684,   685,   686,   686,   686,   686,   686,   687,   688,
     688,   688,   689,   688,   690,   688,   688,   691,   691,   692,
     693,   694,   694,   694,   694,   694,   694,   694,   694,   694,
     694,   694,   694,   695,   694,   696,   694,   694,   694,   697,
     697,   697,   698,   699,   699,   700,   700,   701,   702,   703,
     703,   703,   703,   703,   704,   705,   705,   706,   706,   707,
     708,   709,   710,   710,   710,   711,   712,   712,   713,   713,
     714,   715,   716,   716,   716,   717,   718,   718,   719,   719,
     720,   720,   721,   721,   722,   723,   723,   723,   723,   723,
     724,   724,   725,   726,   727,   728,   728,   728,   728,   728,
     728,   728,   728,   728,   728,   728,   728,   728,   728,   728,
     728,   728,   728,   728,   728,   728,   728,   728,   728,   728,
     729,   729,   729,   729,   730,   730,   731,   731,   732,   733,
     734,   735,   736,   736,   736,   736,   736,   737,   738,   738,
     738,   739,   739,   740,   740,   740,   740,   740,   740,   740,
     740,   740,   741,   741,   742,   742,   743,   743,   744,   745,
     746,   746,   747,   747,   748,   749,   750,   751,   751,   751,
     751,   751,   751,   751,   751,   751,   751,   751,   751,   752,
     752,   753,   753,   754,   755,   756,   757,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   760,   760,   760,   760,   760,
     760,   760,   760,   760,   760,   760,   761,   761,   761,   761,
     762,   762,   762,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     0,     2,     2,     3,     2,     3,     3,     4,     2,
       3,     3,     3,     2,     4,     5,     1,     3,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     1,     5,     0,
       1,     3,     3,     0,     8,     1,     4,     1,     1,     0,
       1,     2,     3,     0,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     4,     2,     3,     2,     2,     1,     1,
       1,     0,     2,     2,     2,     2,     2,     1,     1,     3,
       3,     0,     1,     1,     2,     0,     1,     3,     1,     3,
       1,     0,     2,     2,     2,     2,     3,     3,     3,     5,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       4,     1,     0,     3,     4,     1,     2,     0,     5,     5,
       5,     5,     4,     4,     4,     4,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       1,     4,     0,     3,     3,     3,     0,     1,     1,     4,
       0,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       9,     9,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     3,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     0,     3,     1,     3,     1,     1,     1,     2,
       3,     2,     4,     0,     5,     0,     1,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     3,     1,     1,     3,
       1,     1,     1,     1,     5,     7,     5,     7,     9,     7,
       5,     7,     5,    11,     1,     1,     2,     1,     7,     9,
       7,     7,     9,     7,     9,     7,     9,     7,    15,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     4,     2,
       2,     2,     0,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     5,     7,     7,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     3,     5,     7,     6,     6,     6,     6,
       4,     8,     4,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     3,     1,     3,     0,     1,     4,     6,     4,
       3,     5,     5,     4,     6,     3,     2,     5,     5,     8,
       8,     8,     8,     2,     1,     2,     2,     2,     0,     3,
       5,     0,     0,     2,     4,     4,     4,     2,     2,     2,
       1,     1,     1,     2,     2,     3,     3,     0,     3,     0,
       3,     4,     3,     0,     2,     2,     0,     2,     0,     2,
       4,     5,     2,     0,     3,     3,     3,     3,     5,     6,
       4,     6,     4,     6,     4,     4,     5,     6,     3,     3,
       4,     5,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     5,     6,     4,     5,     4,     4,
       5,     4,     5,     4,     5,     5,     5,     5,     6,     5,
       5,     6,     5,     5,     5,     4,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     7,
       6,     7,     5,     0,     2,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     5,     4,     4,     2,     1,
       2,     2,     0,     3,     0,     3,     2,     0,     3,     5,
       0,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       4,     3,     2,     0,     3,     0,     3,     3,     3,     1,
       1,     1,     0,     0,     3,     0,     3,     4,     1,     2,
       2,     2,     4,     4,     0,     0,     3,     0,     3,     3,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     0,     0,     2,     2,     0,     0,     3,     1,     5,
       1,     2,     0,     2,     2,     1,     2,     4,     2,     2,
       0,     3,     5,     0,     0,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     4,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     4,     6,
       6,     2,     3,     3,     5,     5,     4,     2,     3,     3,
       3,     1,     2,     4,     3,     3,     3,     2,     2,     2,
       2,     2,     1,     3,     0,     2,     0,     3,     4,     2,
       1,     2,     0,     3,     5,     0,     0,     0,     2,     2,
       3,     3,     2,     2,     3,     3,     2,     3,     3,     0,
       3,     0,     3,     4,     6,     6,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     2,
       2,     2,     1,     1,     2,     1,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   420,     0,     0,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,     3,     1,     2,     0,     0,     0,     0,     0,
       0,     0,     0,   117,   118,     0,     0,     0,     0,   420,
       0,   927,   928,   929,   930,   931,   932,   119,   119,   933,
     934,   935,   936,   115,   937,     0,   939,   119,   123,   940,
     941,   942,   119,   998,   119,   123,   119,   123,   119,   123,
     119,  1002,   119,  1003,   119,   123,   119,  1005,     5,   938,
     123,   123,   287,   289,   288,     0,    76,    75,     0,     0,
      75,    77,    74,     0,     0,     0,     0,     0,     0,   286,
     258,   291,     0,   242,     0,     0,   225,   250,     0,   221,
       0,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   402,   406,   415,   412,   331,   422,   409,
       0,     0,   405,   420,   453,     0,     0,     0,   407,   408,
       0,     0,     0,   420,     0,   410,   411,   416,   451,   452,
       0,   450,     0,   274,   273,     0,   276,     0,     0,    30,
      29,    35,    38,    36,     0,    18,     0,     0,    57,    56,
      55,    54,     0,     0,     0,     0,     0,   109,     0,   293,
       0,   102,     0,     0,   295,   323,   120,     0,     0,     0,
     113,    80,    89,   165,   542,   503,   606,   742,   748,   824,
     871,   899,     0,     0,     0,     0,     0,     0,    18,   170,
       0,     0,     0,     0,     0,   997,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    18,     0,   543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,    18,   999,
       0,     0,     0,     0,    18,     0,     0,    18,     0,  1000,
     609,     0,     0,   617,     0,     0,     0,  1001,     0,     0,
       0,     0,     0,     0,     0,  1004,     0,     0,   896,     0,
       0,    18,     0,    18,     0,     0,     0,     0,   995,     0,
       0,     0,     0,    32,   996,     0,     0,   173,   172,     0,
       0,    77,    71,    72,     0,    78,     0,   280,   278,     0,
       0,   281,   184,   183,     0,     0,     0,     0,   290,   292,
     291,     0,   222,     0,   246,   217,   216,     0,     0,   221,
     220,   221,   221,   733,   221,   221,     0,   221,   221,     0,
     221,   221,   221,    19,    20,     0,     0,     0,   269,   265,
     270,   266,   263,   264,   267,   268,   402,   422,   402,   420,
     402,   402,     0,   393,     0,   420,     0,     0,     0,   405,
     405,     0,   448,   420,   420,   420,   420,   420,     0,   354,
     355,     0,   357,     0,     0,   332,   335,   333,   337,   420,
     334,   372,   369,   370,   371,   379,     0,   384,   388,     0,
    1044,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,   423,  1043,   424,   425,   426,   427,   428,   429,   430,
     431,   432,  1046,  1049,  1048,  1045,  1047,  1050,  1051,  1052,
    1055,  1053,  1054,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,   454,   455,   271,   420,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,     0,    43,
      44,    45,    46,    47,    48,    49,    50,    51,     0,    41,
     277,     0,   279,   420,     0,    37,    39,     0,     0,     7,
       9,    14,    16,    15,    17,     0,   420,    13,    65,   149,
     150,    58,     0,     0,    64,     0,    67,    68,     0,   110,
     111,    96,    98,    99,   100,   161,   420,     0,   312,   112,
       0,     0,    53,     0,     0,   121,  1006,  1010,     0,   166,
     126,    18,   148,   134,     0,   124,   125,   151,   139,     0,
     312,   140,     0,   420,   128,   138,     0,   129,     0,   136,
     127,   167,   168,   508,   546,     0,     0,    18,    18,   558,
       0,     0,     0,     0,     0,    18,     0,    18,     0,     0,
       0,   559,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      18,     0,    18,     0,    18,     0,    18,     0,     0,    18,
      18,    18,     0,     0,     0,   547,   607,    18,   618,   610,
      18,   615,   612,     0,   608,   620,   743,     0,     0,     0,
     744,   757,   830,   872,    18,   877,     0,   873,   888,     0,
     887,     0,   891,     0,   889,   890,   894,     0,   902,     0,
      83,     0,    85,    18,    18,    18,    93,  1008,  1009,  1007,
       0,    31,     0,  1012,  1011,   178,   177,   179,   181,   182,
     180,     0,   175,   284,     0,    73,    79,    69,   282,   283,
     188,   189,     0,   186,   285,   259,   262,     0,   218,   223,
     241,     0,   248,   247,     0,     0,   224,   231,     0,     0,
     239,   312,   233,   232,   236,   237,     0,   238,   240,   226,
       0,   230,   249,   257,   251,   254,   255,   253,   256,   252,
       0,   724,   724,     0,   221,   724,   221,   724,   725,   724,
     724,   898,   724,   724,   724,     0,     0,    23,     0,     0,
       0,   397,   399,     0,   400,   401,   395,   383,   483,   486,
       0,   462,     0,     0,   463,   403,   404,   396,     0,     0,
       0,     0,     0,     0,   356,   420,   433,   420,     0,     0,
       0,   343,     0,     0,   413,   385,   386,     0,     0,   414,
     445,   443,   441,   438,   439,   440,   442,   444,   446,   447,
     434,   435,   436,   437,   456,     0,   457,   459,   460,   461,
     275,     0,   272,     0,    34,     0,    33,    66,     0,     0,
      60,    61,    62,    63,    10,    11,    12,     0,   151,     0,
       0,    94,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,     0,     0,     0,   294,
     316,     0,   106,   107,     0,   101,   103,    52,     0,   312,
     122,     0,   116,     0,   135,   155,   158,   171,   147,   141,
     131,   317,   318,   137,    18,   319,   132,   130,   123,     0,
       0,     0,     0,     0,     0,   552,    18,   588,   591,     0,
       0,     0,     0,    18,     0,    18,     0,   605,   560,     0,
     543,     0,     0,   550,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   554,     0,   555,
       0,   586,     0,     0,     0,     0,     0,     0,     0,   566,
     567,     0,     0,     0,   593,     0,   589,   614,   611,     0,
     616,     0,     0,   746,   747,   123,   123,     0,     0,   884,
      21,   886,     0,   881,   885,   420,   876,   123,    92,    84,
      86,    87,    81,    90,    25,    24,    91,   174,     0,    70,
     185,     0,   219,   245,   244,   243,   228,   235,   229,   227,
     234,   541,   723,     0,     0,   732,   741,     0,   739,   736,
       0,     0,   734,     0,   724,     0,   724,     0,     0,     0,
       0,     0,     0,    26,    27,     0,     0,   402,   394,   420,
     472,     0,     0,   420,   420,   420,   449,   420,   470,   420,
       0,     0,   420,   420,   420,   420,   336,   331,   420,   373,
     380,     0,     0,   389,   420,    42,     6,    40,     8,    59,
     108,   162,    95,    97,   311,   310,   312,   420,   105,   104,
     321,   314,     0,   324,     0,   169,   156,     0,   151,     0,
     146,   133,   511,   511,     0,   510,   504,     0,     0,     0,
     604,     0,   600,   599,     0,   590,   594,   595,   596,     0,
     584,     0,   575,    22,     0,   544,   545,   548,     0,   556,
       0,     0,   579,     0,   562,   561,   574,   573,   568,     0,
       0,   587,   571,   563,   564,   565,   592,   602,   570,   569,
     603,   572,   597,     0,   613,   713,    18,     0,    18,   631,
       0,     0,   633,   623,    18,   619,     0,   637,   714,   745,
     760,     0,   752,   754,     0,   759,   749,     0,   833,    18,
       0,   832,   825,     0,   874,   875,   883,    21,    18,     0,
     882,     0,   476,     0,   477,   478,     0,   420,   474,   475,
     473,   420,   420,    18,   897,     0,     0,   420,   892,   895,
     905,   904,   900,     0,     0,    88,   176,   187,   727,   726,
     740,   735,   737,   738,     0,   728,     0,   730,   869,   870,
     924,   925,   926,     0,     0,   398,   484,     0,   464,     0,
       0,     0,     0,     0,   420,   417,   420,     0,     0,   343,
       0,     0,     0,     0,     0,     0,     0,   313,     0,   420,
     327,     0,   320,     0,   152,   153,   157,   159,   144,   142,
     143,   145,   151,   505,   529,   506,   533,   507,   509,     0,
     580,   601,   582,   583,   585,   551,   549,   578,   577,   557,
     576,   553,   598,   151,   636,   624,     0,     0,    18,     0,
     622,     0,     0,   640,   635,   639,     0,     0,   629,   621,
       0,   647,   151,   750,   788,   797,   751,     0,     0,   756,
     758,   151,   829,   826,   828,   831,   878,   880,   879,   420,
     420,   420,   420,     0,     0,     0,     0,     0,     0,   496,
     479,   481,     0,   151,   901,   903,    82,   729,   731,   258,
     258,     0,   469,   467,   468,   466,   420,     0,     0,   352,
       0,   420,   350,   420,   346,     0,   420,   344,   420,   420,
       0,   458,   322,   328,   315,     0,   154,   160,   529,   527,
     512,     0,     0,   536,     0,   716,   720,   626,   627,   625,
     628,   701,   661,   641,   701,   630,   715,   648,   785,   795,
     794,   801,   800,   808,   753,   810,   811,   818,   755,   866,
       0,     0,     0,     0,     0,   490,   420,   390,   893,   420,
     420,     0,   420,   495,   921,     0,     0,   465,     0,   418,
     419,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   387,     0,   512,     0,   532,   534,   535,     0,
     538,   581,   714,   718,   722,     0,     0,     0,   650,   783,
     782,     0,   799,   806,   816,   864,   834,   827,   489,   421,
     493,     0,   420,   487,   329,     0,     0,     0,     0,     0,
       0,     0,     0,   482,   919,   906,   260,   261,   471,   367,
     351,   349,     0,   420,   347,   365,   345,     0,   420,   363,
     420,   361,   360,   420,   358,     0,   531,     0,    18,     0,
       0,     0,     0,     0,     0,   530,   520,   191,   195,     0,
     537,    18,   540,   717,     0,   632,   704,   702,   705,    18,
       0,    18,   638,     0,   634,     0,     0,     0,     0,     0,
       0,   646,   660,     0,     0,   787,     0,     0,    18,    18,
      18,   798,     0,   802,   812,     0,   868,     0,     0,   420,
     420,   338,   342,   340,   420,   497,   341,   377,   374,   375,
     376,   381,     0,   492,   491,   420,   420,   420,   420,   498,
     907,   923,     0,     0,     0,     0,     0,     0,     0,   114,
     196,   518,   192,     0,     0,     0,   513,   517,   521,     0,
     522,     0,   519,   197,   528,   539,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   721,
     700,     0,   706,     0,     0,   644,   645,   643,   642,   654,
     657,   658,   659,   652,   651,     0,     0,   655,   649,     0,
       0,     0,     0,     0,    18,     0,     0,     0,     0,   773,
     775,   786,     0,     0,     0,   789,   790,   791,   796,     0,
       0,   805,     0,     0,     0,   815,     0,     0,     0,     0,
       0,    18,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   867,   859,     0,   494,   330,
     488,   392,   343,     0,   420,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   922,     0,
     366,   348,   364,   420,   362,   420,   359,     0,     0,     0,
       0,     0,   523,   524,     0,     0,     0,     0,     0,     0,
       0,     0,    18,   666,   708,   698,     0,     0,     0,     0,
       0,   693,   687,   688,   689,    18,   699,     0,   682,   662,
     665,   663,     0,   680,     0,   667,   669,   670,   671,   672,
     673,   674,   675,   676,    18,    18,   664,     0,    18,   719,
     707,   703,   653,   656,     0,   772,     0,     0,     0,     0,
       0,   764,    18,     0,     0,     0,    18,     0,    18,     0,
     784,   822,   822,     0,   820,   804,   803,   809,   807,   814,
     813,   819,   817,   840,    18,    18,     0,   835,   838,   839,
     857,     0,     0,     0,   852,   860,   863,   862,   861,   858,
      18,     0,   837,   836,     0,     0,    18,   841,    18,    18,
     865,   339,   420,   378,   391,   382,     0,     0,     0,     0,
     908,    18,     0,     0,     0,   916,     0,   912,   913,     0,
     909,   920,     0,     0,   190,   192,   514,   515,   516,   525,
     526,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   194,   683,     0,   691,   690,   692,   163,   164,
     694,   695,     0,   696,    18,   679,   668,   678,   681,   684,
     677,     0,   763,     0,   779,   780,   781,   771,   822,   766,
     765,   767,   768,     0,   777,   774,   778,   776,    18,   792,
     793,   821,   856,   845,   847,   850,   853,   851,     0,   854,
     849,   846,   848,   842,   843,   844,     0,   502,   500,   501,
     499,   918,   914,   917,   915,   910,   911,   353,   420,   193,
     197,   197,   197,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   197,     0,     0,     0,     0,   686,   710,
     709,   697,   685,   762,   761,   770,   769,   823,   855,     0,
     204,   202,   203,   205,   197,   197,   197,   197,   711,     0,
     420,   198,   199,   200,   201,   712,     0,   368
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    92,   567,   576,   568,   405,   950,  1015,
    1016,   797,  1883,   213,   722,    93,   555,   214,   558,   548,
     549,    94,   222,   223,    95,    96,    20,    21,    22,    23,
      24,    25,   141,   366,    97,  1225,   349,    98,   355,   350,
      99,   587,   100,   590,   906,   101,   580,   102,   103,   598,
     104,   105,   238,   266,   614,  1110,   920,   603,   106,   915,
    1276,  1107,   916,  1387,  1388,   878,   879,  1761,   107,   108,
     607,   267,   360,   731,   732,   375,   742,   743,  1526,  1737,
    1527,  1528,  1751,  1887,    26,    27,    28,    29,   396,    30,
      31,    32,   387,   770,    33,   384,   755,    34,   388,   377,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,   206,   551,    48,    49,    50,    51,    52,
      53,    54,    55,    56,   135,   381,   109,   588,   110,   896,
     897,   898,  1102,   922,   923,   615,   909,   900,   111,   593,
    1268,  1269,  1483,   195,   451,  1577,   829,   452,   830,   453,
     454,   455,  1581,   456,  1582,   196,   458,   459,  1485,   421,
     197,   422,   431,   198,   199,   200,  1216,   201,   521,  1259,
    1217,  1351,  1352,   809,   810,  1270,   112,  1117,   928,   113,
    1282,  1456,  1529,  1612,  1455,  1390,  1283,  1285,  1393,  1460,
    1532,  1287,    57,   114,   644,   115,   116,   117,   321,   322,
     323,   991,  1176,  1311,  1316,  1314,  1315,  1466,  1543,  1177,
    1468,  1553,  1178,  1641,  1465,  1537,  1538,  1644,  1894,  1999,
    1980,  1303,  1321,  1396,  1462,  1534,  1464,  1304,  1033,    58,
      59,    60,    61,    62,    63,    64,    65,   783,   118,   119,
     120,  1187,  1327,  1328,   995,   121,  1322,  1672,  1807,  1809,
    1917,  1555,  1554,  1470,  1323,  1325,  1562,  1472,  1471,  1410,
    1326,  1413,  1473,  1682,  1817,  1563,  1414,  1417,  1474,  1686,
    1821,  1564,  1418,  1815,  1929,   122,  1193,   996,   123,  1331,
    1566,  1707,  1839,  1565,  1476,  1332,    66,    67,   124,   125,
     337,  1003,  1004,   338,  1219,  1005,   707,    68,   126,  1223,
    1007,   127,  1353,  1591,  1729,  1590,  1495,  1354,    69,    70,
      71,   128,    72,   129,   130,   131,   522
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1607
static const yytype_int16 yypact[] =
{
     182,  3276,   220,   817,   745,  1058,   233,   745,   745,   674,
     745,   271,   159,  2177,   164,   179,  1297,  1897,   116,   745,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607,   335,   711,   381,   505,   615,
     291,   373,   280, -1607, -1607,   420,   383,   322,   636,  1897,
     475, -1607, -1607, -1607, -1607, -1607, -1607,   127,   127, -1607,
   -1607, -1607, -1607,    64, -1607,  2529, -1607,   127,  3022, -1607,
   -1607, -1607,   127, -1607,   127,  2801,   127,  1266,   127,  3037,
     127, -1607,   127, -1607,   127,  2784,   127, -1607, -1607, -1607,
    2759,  3064, -1607, -1607, -1607,   118, -1607,   479,   523,   544,
     479,   498, -1607,   616,   623,   745,   745,   646,   198, -1607,
     586,   748,   152, -1607,   686,   694, -1607, -1607,   478,   575,
     -32,   743,     9,   715,   715,   801,   818,   834,   841,   876,
     902,   904,   906,    44, -1607, -1607, -1607,   881,   338, -1607,
     666,   105,    17,  1897, -1607,   486,   496,   499, -1607, -1607,
     529,   548,   553,  1088,   183, -1607, -1607, -1607, -1607, -1607,
    2383, -1607,  3414, -1607, -1607,  1688,   937,   991,   987, -1607,
   -1607,   949, -1607, -1607,    -7,   257,   118,   229, -1607, -1607,
   -1607, -1607,   767,   583,   229,   229,   845,   874,   213, -1607,
    1026, -1607,   198,   612,  3472, -1607,   922,  1034,   622,   628,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,   635,   118,   760,  1098,  1002,   229,   639, -1607,
     804,   417,  1052,   769,   198, -1607,   688,   693,   697,   700,
      25,   833,  1070,   719,  1138,   877,   769,   639,  1090,  1077,
     110,   999,   639,   150,   715,   300,  1093,   209,  1094,   895,
     898,   665,  1084,   899,   701,   884,   888,   639,   887,   872,
     882,   921,   -16,  1105,   879,   878,   639,   933,   639, -1607,
     765,   758,   840,    43,   639,  1089,   229,   639,  1100, -1607,
   -1607,   770,   774, -1607,   777,  1134,   630, -1607,   784,   781,
     791,   792,   914,   715,  1149, -1607,   805,   413,   797,   809,
    1175,   639,  1186,   639,  1184,  1189,  1187,   229, -1607,   837,
     838,   839,  1212,  1269, -1607,   858,   859, -1607, -1607,   785,
    1294,   498, -1607, -1607,  1298,   229,  1299, -1607, -1607,  1300,
    1305, -1607, -1607, -1607,    59,  1306,  1281,  1307, -1607, -1607,
     998,  1308, -1607,  1310,   530, -1607, -1607,  3235,  1133,   743,
   -1607,   743,   743, -1607,   457,   554,  1317,   743,   743,  1318,
     743,   743,   743, -1607, -1607,    10,  1152,  1154, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607,    28, -1607,    44,  1897,
      44,    44,  1316, -1607,  1321,  1228,  1313,   176,  1309,    17,
      17,  1311,  1312,  1897,  1897,  1897,  1897,  1897,  1325, -1607,
   -1607,  1331, -1607,   908,    58, -1607, -1607, -1607, -1607,   955,
   -1607,  1346, -1607, -1607, -1607, -1607,   195,    80, -1607,   253,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,  1897,  1897,  1897,  1897,  1897,  1897,
    1897,  1897,  1897,  1897,  1897,  1897,  1897,  1897,   919, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,   580, -1607,
   -1607,  1352, -1607,  1897,   769, -1607, -1607,  1688,   924, -1607,
   -1607, -1607, -1607, -1607, -1607,   229,  1897, -1607, -1607, -1607,
   -1607,   229,   967,   976, -1607,   565, -1607, -1607,   229, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607,  1897,   925,  3331, -1607,
      -6,   926, -1607,   918,  1339, -1607, -1607, -1607,   -90, -1607,
   -1607,   639, -1607, -1607,    43, -1607, -1607, -1607, -1607,   153,
    3188, -1607,  1223,  1897, -1607, -1607,   153, -1607,   153, -1607,
   -1607, -1607, -1607, -1607, -1607,  1288,  1290,   639,    94, -1607,
     932,  1320,   935,   938,   229,   386,  1066,   639,  1200,   715,
     941, -1607,   942,  1349,    52,   229,  1198,   229,  1319,  1322,
     229,  1323,     0,   229,   229,   639,  1326,   948,  1267,   952,
     639,   957,   639,   406,   639,  1098,   639,   960,   964,   639,
     639,   639,   973,  1209,   974, -1607, -1607,   639, -1607, -1607,
     639, -1607,  1335,   229, -1607, -1607, -1607,  1409,   979,   992,
   -1607, -1607, -1607, -1607,   639, -1607,  1098, -1607, -1607,   866,
   -1607,   715, -1607,  1161, -1607, -1607, -1607,  1005, -1607,   229,
   -1607,   229, -1607,   639,   639,   639, -1607, -1607, -1607, -1607,
     229, -1607,   715, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607,   596, -1607, -1607,  1433, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,   598, -1607, -1607, -1607, -1607,  1441, -1607, -1607,
   -1607,  1426, -1607, -1607,  1431,   715, -1607, -1607,  1434,  1439,
   -1607,  3188, -1607, -1607, -1607, -1607,   715, -1607, -1607, -1607,
    1440, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
    1447,  1446,  1446,  1061,   743,  1446,   743,  1446, -1607,  1446,
    1446, -1607,  1446,  1446,  1446,   229,   715, -1607,  1455,  1457,
    1458, -1607, -1607,  1062, -1607, -1607, -1607, -1607,   185, -1607,
    1022, -1607,  1225,  1450, -1607, -1607, -1607, -1607,   320,   351,
     552,  1201,   714,   -13, -1607,  1897, -1607,  1897,  1037,    21,
    1038,  1257,   272,   318, -1607, -1607, -1607,  1467,  1466, -1607,
    3354,  3354,  3354,  3499,  3499,  3354,  3354,  3354,  3354,  3354,
     947,   947,  1312,  1312, -1607,  1048, -1607, -1607, -1607, -1607,
   -1607,  1688, -1607,  2425, -1607,   613, -1607, -1607,  1397,  1475,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1050, -1607,  1065,
    1848, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607,   240,  1068,  1057, -1607,
   -1607,   229, -1607, -1607,   715, -1607, -1607, -1607,  2809,  3331,
   -1607,   715, -1607,  1071, -1607,  1481, -1607,  1069, -1607,  1382,
   -1607, -1607, -1607, -1607,   639,  3472, -1607, -1607,  2873,   229,
     229,  1081,   229,  1082,  1083, -1607,   639, -1607, -1607,  1095,
    1097,  1099,  1101,   639,  1102,   639,  1104, -1607, -1607,  1495,
   -1607,   229,   229, -1607,  1106,   229,  1108,   229,   229,  1112,
     229,  1114,  1116,  1121,  1125,  1126,   229, -1607,    43, -1607,
    1127, -1607,  1129,  1130,  1135,  1136,  1137,  1144,  1145, -1607,
   -1607,  1146,  1148,  1150, -1607,   160, -1607, -1607, -1607,   229,
   -1607,   514,  1151, -1607, -1607,  2733,  2842,  1153,  1158, -1607,
    1349, -1607,   715,   -28,  1161,   829, -1607,  3095, -1607, -1607,
   -1607, -1607,  1452, -1607,    10, -1607, -1607, -1607,   785, -1607,
   -1607,    59, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607,  1527,  1528, -1607, -1607,    43, -1607, -1607,
      43,  1520, -1607,    43,  1446,  1572,  1446,  1583,  1593,  1594,
    1598,  1599,  1600, -1607, -1607,  1421,  1422,    44, -1607,  1897,
   -1607,  1578,  1580,  1897,  1897,  1897, -1607,  1897, -1607,  1897,
     773,   115,  1675,  1897,  1696,  1897, -1607, -1607,  1897, -1607,
   -1607,  1166,   881, -1607,  1897, -1607, -1607, -1607, -1607, -1607,
   -1607,  1069, -1607, -1607, -1607, -1607,  3331,   408, -1607, -1607,
   -1607,  1173,  1172, -1607,  1432, -1607, -1607,   873, -1607,   582,
   -1607, -1607, -1607, -1607,   715, -1607, -1607,  1177,  1174,  1178,
   -1607,  1181, -1607, -1607,  1190, -1607, -1607, -1607, -1607,  1193,
   -1607,  1194, -1607, -1607,    86, -1607, -1607, -1607,  1197, -1607,
    1204,  1205, -1607,  1206, -1607, -1607, -1607, -1607, -1607,  1207,
    1208, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607,  1210, -1607, -1607,   639,   254,    60, -1607,
    1327,   715, -1607, -1607,   202, -1607,  1211, -1607,  1262, -1607,
   -1607,   715, -1607, -1607,   715, -1607, -1607,  1213, -1607,   639,
     229, -1607, -1607,  1217, -1607, -1607, -1607,  1349,   639,   229,
     -28,    20, -1607,  1616, -1607, -1607,  1219,  1897, -1607, -1607,
   -1607,  1897,  1897,   639, -1607,  2383,  1218,  1742, -1607, -1607,
   -1607, -1607, -1607,  1222,   229, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,  1657, -1607,  1659, -1607, -1607, -1607,
   -1607, -1607, -1607,  1648,  1653, -1607, -1607,  1641, -1607,  1948,
    2020,  2066,  2127,   806,  1897, -1607,  1897,   242,     8,  3472,
    1227,   331,    13,  1229,  1257,  1656,  2166, -1607,  1232,    99,
   -1607,  3331, -1607,  1661,   715, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,  1236, -1607,    47, -1607, -1607,   229,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607,   229,   229,   639,   229,
   -1607,  1237,    43, -1607, -1607,  1238,  1239,   229, -1607, -1607,
     229,  1240, -1607, -1607, -1607,  1244, -1607,    46,    54, -1607,
   -1607, -1607, -1607,  1618, -1607, -1607, -1607, -1607, -1607,  1897,
    1228,  1897, -1607,  2545,  3263,   936,  1260,  1676,   248, -1607,
    3472,  1258,  1263, -1607, -1607, -1607, -1607, -1607, -1607,   586,
     586,  1678, -1607, -1607, -1607, -1607,  1897,  2195,  2221, -1607,
    1681,  1897, -1607,  1764, -1607,  1689,  1897,  1713,  1814,  1879,
    1280, -1607, -1607, -1607, -1607,  1544, -1607,  1069,  1236, -1607,
   -1607,  1710,   769,  1468,  1314,  1069,  1303, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1304, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1315,
     229,  2571,  1324,  2617,  2436, -1607,  2598, -1607, -1607,  1897,
    1897,   816,  1742, -1607,  1334,  1743,  1744, -1607,  2252, -1607,
   -1607,  1329,  1337,   380,    24,  1347,   419,  1328,  1348,    39,
    1358,    45, -1607,  1733, -1607,   733, -1607, -1607, -1607,   715,
    1491, -1607,  1262, -1607, -1607,    15,   349,    35,   761, -1607,
   -1607,   746, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607,  1359,   408,  1530, -1607,    33,  2654,  2726,  1340,  1350,
    1361,  1362,  1365, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,  1735,  1897, -1607, -1607, -1607,  1736,  1897, -1607,
    1897,  1778, -1607,  1897, -1607,  1366, -1607,   769,   639,  1363,
     808,  1548,   229,   229,   279, -1607, -1607, -1607,  1367,  1370,
   -1607,   639, -1607, -1607,  2992, -1607, -1607, -1607,    79,   639,
     229,   639, -1607,  1372, -1607,   229,    61,   229,   229,  1529,
     231, -1607, -1607,  1375,  1233, -1607,  1416,  1418,   639,   639,
     639, -1607,  1381,   303,   262,  2519, -1607,  1383,  1377,  2598,
     165, -1607, -1607, -1607,   955, -1607, -1607,  1816, -1607, -1607,
   -1607, -1607,   314, -1607, -1607,  1897,  1897,  1897,  1897, -1607,
     915, -1607,  1385,  1386,  1389,  1378,  1398,  1400,  1401, -1607,
   -1607, -1607,  1702,  1586,  1596,  1602, -1607, -1607, -1607,   945,
   -1607,  1717, -1607,   721, -1607, -1607,  1545,   229,  1425,   639,
    1521,   377,   148,  1562,   639,  1505,   639,   229,   229,   229,
    1606,   229,   384,  1504,  1508,  1543,   229,  1522,  1557, -1607,
   -1607,  1454, -1607,   229,  1482, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607,   229,   229, -1607, -1607,  1516,
     715,  -107,   -44,  1513,   639,  1515,  1844,  1534,  1654,  1669,
    1671, -1607,  1499,   229,   229, -1607, -1607, -1607, -1607,   226,
     715, -1607,  1500,   226,  1918, -1607,  1506,   229,  -166,  1865,
     229,   639,   715,   639,  1585,   512,    30,  1628,  1579,  -194,
    1872,  1873,   210,  1531,  1540, -1607, -1607,  1514, -1607, -1607,
   -1607, -1607,  2280,    84,   165,   104,  2321,  2347,  2373,  2399,
     229,  1630,  1603,   528,  1704,   663,  1705,   229, -1607,  1518,
   -1607, -1607, -1607,  1897, -1607,  1897, -1607,  1523,  1542,   229,
     229,   229, -1607, -1607,   962,   229,  1946,  1946,   966,   673,
     727,  1525,   639, -1607, -1607, -1607,   132,   229,   229,   229,
     229, -1607, -1607, -1607, -1607,   374, -1607,  1604, -1607, -1607,
   -1607, -1607,   229, -1607,   229, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,   639,   639, -1607,   229,   639, -1607,
   -1607, -1607, -1607, -1607,  1721, -1607,   229,  1724,   506,   229,
     229, -1607,   639,   229,   229,  1915,   639,    46,   639,    54,
   -1607,  1581,  1581,   229, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,   639,   639,   229, -1607, -1607, -1607,
   -1607,   229,   229,   229, -1607, -1607, -1607, -1607, -1607, -1607,
     515,   229, -1607, -1607,   229,   229,   639, -1607,   639,   639,
   -1607, -1607,  1897, -1607, -1607, -1607,  1549,  1550,  1555,  1558,
   -1607,   639,   229,   229,   229, -1607,   229, -1607, -1607,   229,
   -1607, -1607,  1559,  1551, -1607,  1702, -1607, -1607, -1607, -1607,
   -1607,  1560, -1607,  1563,  1564,   705,   851,  1565,  1946,  1946,
    1946,  1946, -1607, -1607,    37, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,  1638, -1607,   639, -1607, -1607, -1607, -1607, -1607,
   -1607,   229, -1607,   229, -1607, -1607, -1607, -1607,  1581, -1607,
   -1607, -1607, -1607,   229, -1607, -1607, -1607, -1607,   639, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1650, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607,  2280, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1897, -1607,
     721,   721,   721, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607,   721,  1569,  1574,  1575,  1576, -1607,  1663,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  1566,
   -1607, -1607, -1607, -1607,   721,   721,   721,   721, -1607,  1577,
    1897, -1607, -1607, -1607, -1607, -1607,  1582, -1607
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1607, -1607, -1607, -1607,  -180,  -224,   -35,  -195,  -809,  -160,
    -749, -1607, -1130,   -86, -1607, -1607, -1607, -1607, -1607,  1461,
    1159, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,   762,  1658, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607,  -308, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,  1430,  -101,  1761, -1607,   259,  -381, -1607, -1607,
   -1607, -1607,   916,  -600,  -665, -1607, -1607,  -975, -1607, -1607,
   -1607, -1607,   184, -1607,  1007,   -40, -1607,  1006, -1074,   151,
   -1492, -1607,  -669, -1607, -1607, -1607, -1607, -1607,  -134, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,  -225,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,   913,  1655, -1607, -1607, -1607, -1607,
    -867,   940,   763,  1445,  1276,  1651, -1607,  1142, -1607, -1607,
   -1318, -1607,   470,  -186,  1220,   341, -1062, -1393,  1862, -1392,
   -1351,  1226,   343, -1607, -1607,  -185,  1224, -1607, -1607, -1607,
   -1607,  -395,   720, -1607, -1607,  -986, -1607,  -167,   846,   -17,
   -1607, -1607,   624,  1004,   724,  -983, -1607, -1607, -1607, -1607,
     953,   617, -1607, -1607, -1607,   679, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,  1120, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607,   668, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607,   611, -1607, -1607, -1607, -1607, -1607,   675, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
     421,   399, -1607, -1607, -1607, -1607,   273,   398, -1607, -1607,
   -1607, -1607,   274,   401, -1606, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607,  1096, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607, -1607,
   -1607, -1607, -1607, -1607, -1607, -1607, -1111
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -486
static const yytype_int16 yytable[] =
{
     202,   577,   233,   406,   407,   678,   423,   917,   450,   457,
    1258,  1260,  1262,  1263,   310,  1371,   320,  1029,   328,  1215,
    1376,   801,  1218,   802,   336,   804,   805,   399,  1073,   351,
     356,  1503,   429,   403,   404,   800,   901,   570,   556,  1570,
     795,  1101,  1339,   416,   575,   575,  1510,   417,  1571,  1572,
    1573,  1077,  1513,   403,   404,   403,   404,   418,   581,   416,
     582,   583,   584,   417,   403,   404,   524,   525,   526,   527,
     528,   911,   234,   418,  1415,   559,  1798,   605,  1391,   560,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   643,
     646,   538,  1578,  1579,   951,   561,   562,   563,   564,  1571,
    1572,  1573,  1077,   642,  1348,  -326,   667,   835,   836,   559,
    1738,  1215,   397,   560,  -326,  -326,  -326,  -326,  1201,  1571,
    1572,  1573,  1077,   524,   525,   526,   527,   528,   951,   561,
     562,   563,   564,   427,  1580,   961,   681,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   236,   559,   538,  1842,
    1202,   560,   203,   400,   357,   382,  1824,  1835,   902,   903,
     904,   204,   398,   358,  1568,   559,   432,   716,   559,   560,
     932,  -325,   560,   695,  1796,   559,   444,   619,  1836,   560,
    -325,  -325,  -325,  -325,  1201,   736,     1,   740,  1650,   918,
     632,  1196,   591,   524,   525,   526,   527,   528,   445,   446,
     447,   177,   448,   401,   812,   625,  1930,   529,   530,   531,
     532,   533,   534,   535,   536,   537,  1202,   559,   538,  1203,
      73,   560,  1843,   606,   620,   559,  1198,   769,   581,   560,
     582,   583,   584,   741,   372,   952,   142,   561,   562,   563,
     564,   559,   633,   373,   559,   560,   559,   640,   560,   423,
     560,   423,  1711,   423,   423,   780,  1825,   781,   782,  1094,
     785,   787,   661,   789,   790,   237,   792,   793,   794,   952,
    1430,   672,   559,   674,   149,  1762,   560,   962,  1091,   679,
    1797,  1431,   682,  1215,   977,  1203,  1383,   445,   446,   447,
    1077,   448,   561,   562,   563,   564,   914,   636,   668,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,   710,   626,   712,  1442,
    1392,  1444,  1985,  1481,  1446,   998,  1449,  1451,   403,   404,
     150,  1211,  1578,  1579,  1212,   163,   565,  1651,   524,   525,
     526,   527,   528,   445,   446,   447,  1077,   448,   383,  1199,
     164,   867,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   585,   912,   538,   208,  1799,  1424,   428,  1275,   524,
     525,   526,   527,   528,  1580,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,   226,   529,   530,   531,   532,   533,   534,   535,
     536,   537,  1837,  1738,   538,   575,  1656,  1211,  1336,   559,
    1212,   869,   227,   560,  1552,  1309,  1854,   228,   877,   559,
     569,   559,   803,   560,  1101,   560,  1608,   637,   808,   561,
     562,   563,   564,  1652,  1763,   933,   818,   819,   820,   821,
     822,   561,   562,   563,   564,  1609,  1068,  1201,   813,   919,
    1069,   905,   831,   638,   557,  1642,   919,   600,   919,   229,
    1215,  1593,  1643,  1484,   946,   402,  1595,  1372,  1596,   215,
     796,  1598,  1377,  1838,   939,  1095,  1378,  1535,  1340,  1202,
    1640,   430,   608,  1504,  1074,   954,   419,   956,   864,   230,
     959,  1574,   420,   963,   964,  1575,   390,  1544,  1511,  1978,
     648,   586,   419,   645,  1514,   231,   616,  1411,   420,   953,
     649,  1706,  1895,  1896,   235,  1416,  1215,   826,   566,   136,
    1764,   827,   784,   990,  1000,   240,  1001,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   837,  1852,  1295,   216,  1386,   362,  1014,  1203,  1008,
     559,  1009,   566,   750,   560,  1539,   863,  -326,   217,  1774,
    1013,  -326,  1574,   610,   611,  1610,  1611,   363,   218,   868,
     561,   562,   563,   564,  1255,  1757,  1758,   205,  1256,   359,
     524,   525,   526,   527,   528,   365,   913,   219,  1846,   880,
     566,  1014,  1317,   390,   529,   530,   531,   532,   533,   534,
     535,   536,   537,  1215,  1215,   538,  1484,   641,   566,  1306,
    1307,   566,   931,   934,   390,  1025,   925,  1162,   566,   786,
     942,  1054,   944,  -325,   874,   875,   876,  -325,  1204,  1205,
    1206,  1207,  1208,  1209,  1210,  1053,   751,  1884,   698,   367,
     965,   449,  1308,   220,  1813,   970,   368,   972,  1059,   976,
    1211,   978,  1902,  1212,   981,   982,   983,  1165,   833,   374,
     566,   834,   987,   940,   941,   988,   450,   450,   566,   371,
    1044,   586,  1046,   457,   559,   209,   210,  1408,   560,   997,
    1150,  1683,  1245,  1278,   566,   224,  1419,   566,  1684,   566,
     613,  1872,   376,  1873,   561,   562,   563,   564,  1010,  1011,
    1012,  1369,   225,   973,  1540,  1370,   752,   699,  1434,   385,
    1757,  1758,   221,   132,   133,   566,   838,   386,   391,   839,
    1166,   753,  1679,  1395,  1685,  1541,  1757,  1758,  1680,  1099,
    1078,   974,   975,   754,  1279,  1280,  1281,  1759,   700,   134,
    1834,  1098,   524,   525,   526,   527,   528,   701,  1215,  1230,
     209,   210,  1231,   403,   404,  1233,   529,   530,   531,   532,
     533,   534,   535,   536,   537,  1681,   389,   538,  1865,  1118,
    1119,  1104,  1121,  1760,  1714,   211,   449,  1715,  1974,  1975,
    1976,  1977,   390,  1063,   132,   133,   212,   378,   379,   392,
    1374,  1135,  1136,  1938,  1375,  1138,   425,  1140,  1141,   232,
    1143,   524,   525,   526,   527,   528,  1149,   571,   209,   210,
     134,  1542,  1167,   380,  1064,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   408,  1163,   538,  1197,  1070,  1164,
    1071,  1888,   566,  1889,   524,   525,   526,   527,   528,  1501,
      74,   409,   566,  1502,   566,   572,   573,  1116,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   410,  1745,   538,
     702,   703,   704,   705,   411,   145,   146,  1168,  1201,   608,
    -325,    75,  1832,  1963,  1964,  1965,  1966,  1967,  1506,  1746,
      76,  1747,  1507,    77,   725,  1890,  1748,  1891,  1863,  1169,
    1517,  1170,  1518,   609,    78,   926,  1171,   927,  1172,   412,
    1202,  1749,  1173,  1174,   403,   404,   999,    79,  1833,  1111,
     423,   403,   404,  1274,  1186,  1192,  1989,    80,  1517,   361,
    1519,  1124,   364,    81,  1864,   413,  1222,   414,  1129,   415,
    1131,   424,  1014,   726,   727,  1914,  1915,  1916,   426,  1286,
     143,   144,   147,   148,   433,  1750,   728,   729,  1519,   730,
     610,   611,   207,    82,   434,    83,    84,   435,  2006,   612,
     393,  1545,  1488,    85,   524,   525,   526,   527,   528,  1203,
     653,   654,   550,   566,   394,   395,  1175,  1720,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   436,   173,   538,
     174,   175,   176,   177,   178,   179,   536,   537,    86,    87,
     538,  1721,   180,   181,   828,   182,   437,   183,  1520,  1521,
      88,   438,  1522,  1523,   552,  1065,   657,   658,  1524,  1968,
    1969,  1970,  1971,  1972,  1402,  1489,  1490,   665,   666,   553,
    1334,  1313,   554,    89,   688,   689,    90,   378,   379,  1338,
     574,  1324,   860,   861,  1329,   578,  1546,   870,   871,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,   872,   873,  1017,  1018,
    1020,  1021,   808,   579,  1356,   589,  1249,  1250,  1251,   592,
    1252,  1211,  1253,   595,  1212,  1087,   861,   613,   369,   370,
     594,  1264,  1491,   596,  1035,  1603,  1604,  1266,  1492,   597,
     524,   525,   526,   527,   528,   184,   599,   566,   136,  1014,
    1036,   185,   601,  1213,   529,   530,   531,   532,   533,   534,
     535,   536,   537,  1742,  1743,   538,  1867,  1868,  1547,  1548,
    1549,   173,  1550,   174,   175,   176,   177,   178,   179,  1394,
    1879,  1880,  1885,  1886,   137,   180,   181,   602,   182,   604,
     183,   618,   138,   139,   140,   621,  1397,  1398,   854,  1400,
     622,  1305,  1412,  1310,  1435,  1436,   772,  1405,   623,  1318,
    1406,   624,  1556,  1557,   186,   187,  1558,  1559,  1560,   815,
     816,   628,   773,   855,  1333,   627,   629,  1067,   630,   634,
     631,   856,   635,  1337,   651,   639,   857,   858,   859,   647,
     650,   655,  1722,  1723,   652,  1525,   663,  1037,  1346,   659,
     656,   188,   189,   439,   440,   441,   442,   660,  1561,   662,
    1343,   664,   669,   671,  1344,  1345,   670,   673,   190,   676,
    1350,   191,   675,  1551,   677,   680,   192,   684,   184,   524,
     525,   526,   527,   528,   185,   685,  1254,   683,   686,   774,
     687,   690,   691,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   692,   693,   538,   696,   694,  1367,   706,  1368,
    1477,   173,   697,   174,   175,   176,   177,   178,   179,  1366,
     708,   775,   776,  1724,    91,   180,   181,  1725,   182,   777,
     183,   709,   711,   713,  1530,   524,   525,   526,   527,   528,
     714,  1214,   715,  1399,   717,   718,   719,   186,   187,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   720,   721,
     538,  1990,  1991,  1992,   778,   723,   724,   733,  1606,  1576,
     745,   735,   737,   738,  1993,  1536,  1458,  1536,   739,   744,
     746,   748,   253,   749,   188,   189,   439,   440,   441,   442,
     788,   791,  1421,   808,  1423,  2001,  2002,  2003,  2004,  1726,
     806,   190,   779,   798,   191,   799,   807,   814,  1038,   192,
     811,   817,   575,  1607,   823,   538,   824,  1727,   184,  1438,
     312,   825,   255,   832,   185,   862,   908,  1728,   910,   924,
    1646,   866,   881,   907,   929,  1649,   930,  1653,  1654,   935,
    1657,   936,   937,   943,   945,   938,   165,  1427,   947,   948,
     949,   955,   256,  1039,   968,   967,   257,   258,  1040,   969,
     260,   261,   985,   193,   971,   957,   262,   979,   958,   960,
     194,   980,   966,  1041,   989,   524,   525,   526,   527,   528,
     984,   986,  1486,  1487,  1659,  1350,   993,   186,   187,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   992,   994,
     538,  1600,  1042,  1043,   263,  1002,  1019,  1753,   166,   264,
     167,   168,  1006,  1660,  1022,  1023,  1024,  1769,  1770,  1771,
    1031,  1773,  1775,  1026,   188,   189,  1786,  1034,  1027,  1030,
    1045,  1060,  1047,  1790,  1048,  1049,  1032,  1050,  1051,  1052,
    1055,   190,  1056,  1057,   191,  1792,  1793,  1061,  1062,   192,
    1072,  1075,  1081,  1601,  1082,  1412,  1084,  1090,  1661,   169,
     170,   171,   172,  1811,  1812,  1089,  1615,  1829,  1097,  1814,
    1324,  1058,  1092,  1814,  1645,  1096,  1647,  1823,  1105,  1106,
    1827,  1662,  1108,  1109,  1133,  1876,  1877,  1878,  1120,  1122,
    1123,  1224,  1847,  1675,  1676,  1677,   193,  1576,   239,  1576,
    1228,  1229,  1125,   194,  1126,  1232,  1127,   252,  1128,  1130,
    1860,  1132,   268,  1137,   269,  1139,   311,  1870,   324,  1142,
     329,  1144,   330,  1145,   331,  1663,   339,  1712,  1146,   575,
     575,   575,  1147,  1148,  1151,  1881,  1152,  1153,  1716,  1717,
    1718,  1719,  1154,  1155,  1156,  1235,  1897,  1898,  1899,  1900,
    1901,  1157,  1158,  1159,  1755,  1160,  1237,  1161,  1179,  1766,
    1194,  1768,  1905,   313,  1906,  1195,  1238,  1239,   314,   315,
     316,  1240,  1241,  1242,  1243,  1244,  1247,  1909,  1248,  1265,
    1271,  1272,  1412,  1273,  1288,  1290,  1912,  1289,  1291,  1918,
    1919,  1664,  1665,  1921,  1922,  1666,  1667,  1292,  1668,  1801,
    1293,  1294,   317,  1931,  1296,  1320,  1669,  1670,  1341,   318,
    1066,  1297,  1298,  1299,  1300,  1301,  1934,  1302,  1319,  1312,
    1330,  1935,  1936,  1937,  1335,  1349,  1828,  1342,  1830,  1355,
    1357,  1940,  1358,  1359,  1941,  1942,   193,  -485,  1360,  1361,
    1373,  1380,  1379,   194,  1382,  1671,  1385,  1389,  1401,  1403,
    1404,  1407,  1952,  1953,  1954,  1409,  1955,  1420,   173,  1956,
     174,   175,   176,   177,   178,   179,  1076,  1428,  1429,  1979,
    1433,  1432,   180,   181,  1257,   182,  1437,   183,   319,   173,
    1441,   174,   175,   176,   177,   178,   179,  1893,  1445,  1234,
    1447,  1236,  1452,   180,   181,  1261,   182,  1453,   183,  1457,
    1903,  1983,  1459,  1984,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1986,  1463,  1469,  1496,  1497,  1515,  1907,
    1908,  1461,  1531,  1910,  1569,   173,  1475,   174,   175,   176,
     177,   178,   179,  1479,  1592,  1594,  1508,  1920,  1499,   180,
     181,  1924,   182,  1926,   183,  1494,  1500,   173,  1585,   174,
     175,   176,   177,   178,   179,  1597,  1505,  1509,  1586,  1932,
    1933,   180,   181,  1443,   182,   184,   183,  1512,  1567,  1587,
    1588,   185,  1589,  1599,  1602,  1939,  1605,  1614,  1613,  1648,
    1655,  1943,  1658,  1944,  1945,  1673,   184,  1674,  1678,  1709,
    1708,  1733,   185,  1713,  1730,  1731,  1951,   173,  1732,   174,
     175,   176,   177,   178,   179,  1946,  1088,  1734,  1735,  1517,
    1736,   180,   181,  1448,   182,  1739,   183,  1776,  1777,  1778,
    1779,  1780,  1781,  1782,  1783,  1740,   524,   525,   526,   527,
     528,  1741,   184,  1744,   186,   187,  1754,  1752,   185,  1982,
     529,   530,   531,   532,   533,   534,   535,   536,   537,  1765,
    1756,   538,  1767,  1784,   184,   186,   187,  1772,  1785,  1787,
     185,  1789,   173,  1987,   174,   175,   176,   177,   178,   179,
    1788,   188,   189,  1794,  1800,  1802,   180,   181,  1450,   182,
     173,   183,   174,   175,   176,   177,   178,   179,   190,  1791,
    1803,   191,   188,   189,   180,   181,   192,   182,  1804,   183,
    1805,   186,   187,  1806,   184,  1808,  1810,  1818,  1415,   190,
     185,  1826,   191,  1822,  1831,  1840,  1841,   192,  1844,  1845,
    1848,  1850,  1861,   186,   187,  1871,   524,   525,   526,   527,
     528,  1849,  1862,  1866,  1869,  1874,  1882,  1892,   188,   189,
     529,   530,   531,   532,   533,   534,   535,   536,   537,  1875,
    1911,   538,  1904,  1913,  1923,   190,  1947,  1948,   191,  1928,
     188,   189,  1949,   192,  1958,  1950,  1981,  1960,  1957,   184,
    1961,  1962,  1973,   186,   187,   185,  1994,   190,  1988,  2000,
     191,  1995,  1996,  1997,  2005,   192,  1998,   184,   865,   734,
    1085,  2007,   617,   185,  1277,  1226,  1959,  1227,   524,   525,
     526,   527,   528,   899,  1384,   747,  1267,  1028,   771,  1710,
     188,   189,   529,   530,   531,   532,   533,   534,   535,   536,
     537,  1103,  1079,   538,  1853,   443,  1493,   190,  1855,  1080,
     191,  1347,  1083,  1246,  1422,   192,  1284,  1454,   186,   187,
    1134,  1516,  1467,  1533,   524,   525,   526,   527,   528,  1816,
    1925,  1795,  1820,  1927,  1819,     0,   186,   187,   529,   530,
     531,   532,   533,   534,   535,   536,   537,     0,     0,   538,
    1200,     0,     0,     0,     0,   188,   189,     0,     0,     0,
       0,     0,     0,   193,     0,     0,     0,     0,     0,     0,
     194,     0,   190,   188,   189,   191,     0,     0,     0,     0,
     192,     0,     0,     0,   193,   524,   525,   526,   527,   528,
     190,   194,     0,   191,     0,     0,     0,     0,   192,   529,
     530,   531,   532,   533,   534,   535,   536,   537,     0,     0,
     538,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   524,   525,   526,   527,   528,  -480,
     193,     0,     0,     0,     0,     0,     0,   194,   529,   530,
     531,   532,   533,   534,   535,   536,   537,     0,     0,   538,
       0,     0,   193,   524,   525,   526,   527,   528,     0,   194,
       0,     0,     0,     0,     0,     0,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,     0,     0,   538,   524,
     525,   526,   527,   528,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   193,     0,   538,     0,     0,     0,     0,   194,
     524,   525,   526,   527,   528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   529,   530,   531,   532,   533,   534,
     535,   536,   537,     0,     0,   538,     0,  1093,   524,   525,
     526,   527,   528,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   529,   530,   531,   532,   533,   534,   535,   536,
     537,     0,     0,   538,     0,     0,     0,   193,     0,     0,
     151,   152,     0,     0,   194,     0,     0,     0,     0,   524,
     525,   526,   527,   528,     0,   193,     0,     0,   153,     0,
       0,     0,   194,   529,   530,   531,   532,   533,   534,   535,
     536,   537,     0,   154,   538,   524,   525,   526,   527,   528,
       0,     0,   155,     0,   156,   157,     0,     0,     0,   529,
     530,   531,   532,   533,   534,   535,   536,   537,     0,     0,
     538,   524,   525,   526,   527,   528,     0,  1362,   460,     0,
       0,     0,     0,     0,     0,   529,   530,   531,   532,   533,
     534,   535,   536,   537,     0,     0,   538,   524,   525,   526,
     527,   528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
       0,   158,   538,   524,   525,   526,   527,   528,     0,     0,
       0,   460,     0,     0,     0,     0,     0,   529,   530,   531,
     532,   533,   534,   535,   536,   537,     0,     0,   538,  1363,
       0,     0,     0,     0,     0,   461,   462,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,     0,
       0,     0,     0,   159,     0,  1364,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   461,   462,
       0,   491,     0,     0,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,     0,   524,   525,   526,   527,   528,     0,     0,
     492,  1687,     0,     0,     0,     0,  1365,   529,   530,   531,
     532,   533,   534,   535,   536,   537,     0,     0,   538,   524,
     525,   526,   527,   528,     0,  1688,  1689,     0,     0,   160,
       0,     0,     0,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   241,   161,   538,  1381,  1690,   242,   162,     0,
       0,     0,     0,   492,     0,   493,   494,  1201,   495,   496,
     497,   498,   499,   500,   501,   524,   525,   526,   527,   528,
       0,     0,     0,     0,  1439,     0,     0,     0,     0,   529,
     530,   531,   532,   533,   534,   535,   536,   537,     0,  1202,
     538,   243,     0,     0,     0,     0,  1517,     0,  1691,     0,
    1440,     0,   524,   525,   526,   527,   528,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   529,   530,   531,   532,
     533,   534,   535,   536,   537,  1692,  1519,   538,     0,     0,
       0,  1498,   244,   511,   512,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   513,     0,
       0,   514,   515,   516,   517,     0,     0,     0,  1203,  1851,
     502,   503,   504,   505,   506,   507,   508,   509,   510,     0,
       0,     0,     0,     0,   524,   525,   526,   527,   528,     0,
       0,     0,     0,     0,     0,     0,   511,   512,   529,   530,
     531,   532,   533,   534,   535,   536,   537,     0,     0,   538,
    1856,   513,     0,     0,   514,   515,   516,   517,     0,     0,
       0,     0,     0,  1693,     0,     0,  1694,  1695,     0,   253,
       0,     0,     0,   245,  1696,     0,  1857,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1204,  1205,
    1206,  1207,  1208,  1209,  1210,   253,     0,   518,   519,     0,
       0,     0,  1858,     0,     0,     0,     0,     0,   520,   255,
    1211,     0,     0,  1212,     0,     0,     0,     0,     0,     0,
     253,     0,   340,   341,   342,  1697,   343,   344,  1859,   345,
       0,     0,     0,   346,     0,   255,   347,   253,     0,   256,
     332,     0,   270,   257,   258,   246,  1180,   260,   261,     0,
     518,   519,  1086,   262,     0,     0,     0,   271,     0,     0,
     255,   520,     0,     0,     0,   256,     0,     0,     0,   257,
     258,   272,     0,   260,   261,  1698,     0,   255,   253,   262,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     256,   263,  1699,     0,   257,   258,   264,     0,   260,   261,
     247,     0,     0,     0,   262,   248,     0,   256,     0,   253,
       0,   257,   258,   273,   274,   260,   261,   263,   255,     0,
       0,   262,   264,  1700,  1701,   275,  1702,  1703,   276,  1704,
     277,   249,     0,  1181,     0,     0,     0,     0,     0,     0,
       0,     0,   263,     0,     0,   250,     0,   264,   256,   255,
     251,  1705,   257,   258,     0,  1188,   260,   261,     0,   263,
       0,   333,   262,     0,   264,     0,     0,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,   278,   256,
     279,     0,     0,   257,   258,     0,  1112,   260,   261,   280,
       0,     0,     0,   262,     0,     0,     0,     0,  1478,     0,
     263,     0,     0,     0,     0,   264,   882,   883,   884,   885,
     886,   887,   888,   889,     0,   890,   891,   892,   893,   894,
     895,     0,     0,     0,     0,     0,     0,   281,     0,  1482,
       0,   263,     0,     0,     0,     0,   264,     0,     0,     0,
       0,     0,     0,     0,  1480,   282,     0,     0,  1616,     0,
       0,     0,   283,   284,     0,   285,     0,     0,   253,     0,
     286,   287,     0,   288,   289,     0,   290,     0,     0,   291,
     292,   293,     0,   253,     0,     0,     0,     0,   254,     0,
       0,  1583,     0,     0,   294,   295,   334,     0,     0,   296,
       0,   297,   298,     0,   299,     0,     0,     0,   255,   300,
     253,     0,     0,   301,   302,     0,   303,   304,     0,   305,
     306,   307,     0,   255,     0,   308,     0,     0,     0,  1517,
       0,     0,     0,     0,  1113,  1114,  1182,  1183,   256,   352,
    1184,   253,   257,   258,     0,   259,   260,   261,     0,     0,
     255,     0,   262,   256,     0,     0,     0,   257,   258,  1519,
       0,   260,   261,  1584,     0,     0,     0,   262,     0,     0,
       0,     0,  1617,     0,     0,  1185,     0,     0,     0,     0,
     256,   255,     0,     0,   257,   258,  1618,     0,   260,   261,
     263,     0,     0,     0,   262,   264,     0,     0,     0,     0,
       0,   348,     0,     0,     0,   263,     0,   921,  1189,     0,
     264,   256,     0,     0,     0,   257,   258,   353,  1220,   260,
     261,     0,     0,     0,     0,   262,   335,     0,     0,     0,
       0,     0,   263,     0,     0,     0,     0,   264,   756,     0,
       0,     0,     0,   309,     0,     0,  1619,     0,  1100,  1620,
    1621,     0,     0,   403,   404,  1190,     0,  1622,     0,     0,
       0,     0,     0,   263,     0,     0,     0,     0,   264,     0,
       0,   524,   525,   526,   527,   528,     0,     0,     0,     0,
     757,     0,     0,     0,  1191,   529,   530,   531,   532,   533,
     534,   535,   536,   537,     0,     0,   538,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1623,     0,
       0,  1624,     0,     0,  1625,  1115,     0,     0,     0,     0,
       0,   758,     4,     0,     0,  1626,     0,  1627,     0,  1628,
    1629,  1630,  1631,  1632,  1633,     0,     0,     0,     0,     0,
    1634,     0,     0,  1635,     0,     0,  1636,     5,     6,     0,
       0,     0,     0,   759,     0,     0,     0,     7,  1637,     0,
     760,   761,  -486,  -486,  -486,     0,  1638,     0,     0,     0,
       0,   762,     0,     0,     0,     0,  -486,  -486,  -486,  -486,
    -486,   534,   535,   536,   537,     0,     0,   538,   763,   764,
     765,   766,     0,   767,   768,   882,   883,   884,   885,   886,
     887,   888,   889,     0,   890,   891,   892,   893,   894,   895,
       8,     0,     0,     0,     0,     0,     0,   523,     0,   325,
     326,     0,   524,   525,   526,   527,   528,     0,     0,     0,
       0,     0,     0,     0,  1639,     0,   529,   530,   531,   532,
     533,   534,   535,   536,   537,     0,     9,   538,     0,    10,
       0,    11,     0,     0,     0,     0,     0,     0,    12,     0,
      13,     0,     0,     0,   265,    14,    15,    16,     0,     0,
       0,     0,    17,    18,    19,     0,     0,     0,     0,   327,
     524,   525,   526,   527,   528,     0,  1426,     0,   613,     0,
       0,     0,     0,     0,   529,   530,   531,   532,   533,   534,
     535,   536,   537,     0,     0,   538,   354,   524,   525,   526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   529,   530,   531,   532,   533,   534,   535,   536,   537,
       0,     0,   538,     0,     0,     0,     0,  1221,   882,   883,
     884,   885,   886,   887,   888,   889,     0,   890,   891,   892,
     893,   894,   895
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1607)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-486)))

static const yytype_int16 yycheck[] =
{
      17,   225,    88,   163,   164,   313,   173,   607,   194,   194,
    1072,  1073,  1074,  1075,   115,     7,   117,   766,   119,  1005,
       7,   416,  1005,   418,   125,   420,   421,   161,     7,   130,
     131,     7,    15,    18,    19,     7,    42,   217,    45,     6,
      30,   908,    22,    15,   224,   225,     7,    19,    15,    16,
      17,    18,     7,    18,    19,    18,    19,    29,    15,    15,
      17,    18,    19,    19,    18,    19,     8,     9,    10,    11,
      12,   161,    89,    29,    20,    15,   120,   257,    31,    19,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   284,
     285,    33,  1485,  1485,    42,    35,    36,    37,    38,    15,
      16,    17,    18,   283,  1215,     6,   122,    27,    28,    15,
    1602,  1097,   144,    19,    15,    16,    17,    18,    19,    15,
      16,    17,    18,     8,     9,    10,    11,    12,    42,    35,
      36,    37,    38,    28,  1485,   135,   316,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    19,    15,    33,   343,
      51,    19,    36,   144,    36,     3,   322,   127,   164,   165,
     166,    45,   194,    45,  1482,    15,   183,   347,    15,    19,
      76,     6,    19,   333,   281,    15,   193,   263,   148,    19,
      15,    16,    17,    18,    19,   365,     4,   128,   127,    36,
     276,  1000,   232,     8,     9,    10,    11,    12,    15,    16,
      17,    18,    19,   194,    28,   180,  1812,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    51,    15,    33,   120,
       0,    19,   416,   258,   264,    15,   254,   387,    15,    19,
      17,    18,    19,   174,    36,   183,     3,    35,    36,    37,
      38,    15,   277,    45,    15,    19,    15,   282,    19,   416,
      19,   418,  1570,   420,   421,   389,   422,   391,   392,    19,
     394,   395,   297,   397,   398,   138,   400,   401,   402,   183,
      22,   306,    15,   308,     3,   127,    19,   277,   878,   314,
     387,    33,   317,  1269,   665,   120,  1269,    15,    16,    17,
      18,    19,    35,    36,    37,    38,   604,   187,   314,   200,
     201,   202,   203,   204,   205,   206,   341,   282,   343,  1371,
     263,  1373,  1918,  1424,  1376,   696,  1378,  1379,    18,    19,
     161,   222,  1715,  1715,   225,   161,    69,   266,     8,     9,
      10,    11,    12,    15,    16,    17,    18,    19,   186,   367,
     161,   565,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   138,   442,    33,    19,   399,  1342,   252,  1107,     8,
       9,    10,    11,    12,  1715,   200,   201,   202,   203,   204,
     205,   206,    81,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   352,  1875,    33,   565,   155,   222,  1197,    15,
     225,   571,    19,    19,  1468,   335,  1714,   117,   578,    15,
     216,    15,   419,    19,  1271,    19,   127,   297,   425,    35,
      36,    37,    38,   352,   266,   321,   433,   434,   435,   436,
     437,    35,    36,    37,    38,   146,   439,    19,   252,   609,
     443,   437,   449,   323,   441,   356,   616,   253,   618,    19,
    1426,  1503,   363,  1426,   639,   436,  1508,   439,  1510,    68,
     440,  1513,   439,   423,   634,   215,   443,   442,   438,    51,
    1534,   444,    45,   439,   443,   645,   438,   647,   554,    86,
     650,   438,   444,   653,   654,   442,    19,   442,   439,   442,
     271,   438,   438,   183,   439,   163,    69,   441,   444,   437,
     281,  1565,   360,   361,    19,   441,  1482,   439,   438,    20,
     352,   443,    45,   683,   699,   441,   701,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   441,   438,   437,   143,  1274,     3,   722,   120,   709,
      15,   711,   438,     3,    19,   186,   553,   438,   157,   155,
     720,   442,   438,   126,   127,   266,   267,     3,    43,   566,
      35,    36,    37,    38,   439,   178,   179,   441,   443,   441,
       8,     9,    10,    11,    12,    67,   601,    62,   358,   586,
     438,   766,   370,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,  1569,  1570,    33,  1569,   437,   438,   335,
     336,   438,   627,   628,    19,   755,   613,   437,   438,    45,
     635,   796,   637,   438,    39,    40,    41,   442,   200,   201,
     202,   203,   204,   205,   206,   795,    86,  1747,   205,     3,
     655,   438,   368,   118,   398,   660,     3,   662,   443,   664,
     222,   666,   258,   225,   669,   670,   671,   123,   443,   441,
     438,   446,   677,   257,   258,   680,   832,   833,   438,     3,
     784,   438,   786,   838,    15,    19,    20,  1322,    19,   694,
     968,   399,  1057,    81,   438,    50,  1331,   438,   406,   438,
     253,  1733,    86,  1735,    35,    36,    37,    38,   713,   714,
     715,   439,    67,   277,   335,   443,   156,   274,  1353,     3,
     178,   179,   187,    19,    20,   438,   443,     3,   123,   446,
     186,   171,   399,  1303,   442,   356,   178,   179,   405,   904,
     438,   305,   306,   183,   132,   133,   134,   340,   305,    45,
    1695,   901,     8,     9,    10,    11,    12,   314,  1714,  1037,
      19,    20,  1040,    18,    19,  1043,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   442,   268,    33,  1723,   929,
     930,   911,   932,   376,   440,    44,   438,   443,  1888,  1889,
    1890,  1891,    19,   443,    19,    20,    55,    19,    20,   194,
     439,   951,   952,   258,   443,   955,   438,   957,   958,   143,
     960,     8,     9,    10,    11,    12,   966,    20,    19,    20,
      45,   442,   278,    45,   443,    22,    23,    24,    25,    26,
      27,    28,    29,    30,     3,   985,    33,  1002,   825,   989,
     827,   138,   438,   140,     8,     9,    10,    11,    12,   439,
       3,     3,   438,   443,   438,    58,    59,   928,    22,    23,
      24,    25,    26,    27,    28,    29,    30,     3,   117,    33,
     427,   428,   429,   430,     3,   171,   172,   333,    19,    45,
     442,    34,   340,   148,   149,   150,   151,   152,   439,   138,
      43,   140,   443,    46,    79,   138,   145,   140,   340,   355,
     137,   357,   139,    69,    57,   616,   362,   618,   364,     3,
      51,   160,   368,   369,    18,    19,    20,    70,   376,   924,
    1057,    18,    19,    20,   995,   996,  1958,    80,   137,   137,
     167,   936,   140,    86,   376,     3,  1007,     3,   943,     3,
     945,    30,  1107,   128,   129,   409,   410,   411,   252,  1114,
       7,     8,     9,    10,   438,   204,   141,   142,   167,   144,
     126,   127,    19,   116,   438,   118,   119,   438,  2000,   135,
     365,   180,   126,   126,     8,     9,    10,    11,    12,   120,
     285,   286,    15,   438,   379,   380,   442,    42,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   438,    13,    33,
      15,    16,    17,    18,    19,    20,    29,    30,   161,   162,
      33,    66,    27,    28,    29,    30,   438,    32,   255,   256,
     173,   438,   259,   260,     3,   443,   295,   296,   265,   148,
     149,   150,   151,   152,  1312,   189,   190,    86,    87,    22,
    1190,  1171,    63,   196,   384,   385,   199,    19,    20,  1199,
     437,  1181,   442,   443,  1184,   180,   265,    60,    61,   200,
     201,   202,   203,   204,   205,   206,    60,    61,   442,   443,
     442,   443,  1059,   169,  1224,    19,  1063,  1064,  1065,   437,
    1067,   222,  1069,    19,   225,   442,   443,   253,   145,   146,
     138,  1078,   246,   441,     3,   257,   258,  1084,   252,   441,
       8,     9,    10,    11,    12,   120,   441,   438,    20,  1274,
      19,   126,   322,   254,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   148,   149,    33,   433,   434,   337,   338,
     339,    13,   341,    15,    16,    17,    18,    19,    20,  1289,
     148,   149,   146,   147,    56,    27,    28,    19,    30,   117,
      32,    69,    64,    65,    66,   437,  1306,  1307,   209,  1309,
     437,  1166,  1327,  1168,  1359,  1360,     3,  1317,   441,  1174,
    1320,   441,   396,   397,   189,   190,   400,   401,   402,   429,
     430,    81,    19,   234,  1189,   322,   437,   443,    20,    69,
     283,   242,    85,  1198,   269,   166,   247,   248,   249,    76,
      76,    87,   257,   258,   276,   442,   304,   116,  1213,   295,
     281,   226,   227,   228,   229,   230,   231,   299,   442,   302,
    1207,   309,    87,   315,  1211,  1212,   317,   264,   243,   441,
    1217,   246,   437,   442,   364,   116,   251,   437,   120,     8,
       9,    10,    11,    12,   126,   441,   443,   117,   441,    86,
      86,   437,   441,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   441,   441,    33,    86,   322,  1254,   441,  1256,
    1420,    13,   437,    15,    16,    17,    18,    19,    20,   443,
     441,   118,   119,   338,   437,    27,    28,   342,    30,   126,
      32,    86,    76,    79,  1459,     8,     9,    10,    11,    12,
      81,   442,    85,  1308,   437,   437,   437,   189,   190,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    76,    20,
      33,  1960,  1961,  1962,   161,   437,   437,     3,  1522,  1485,
      19,     3,     3,     3,  1973,  1465,  1392,  1467,     3,     3,
       3,     3,    46,     3,   226,   227,   228,   229,   230,   231,
       3,     3,  1339,  1340,  1341,  1994,  1995,  1996,  1997,   414,
      14,   243,   199,   181,   246,   181,    15,    28,   277,   251,
      27,    30,  1522,  1523,    19,    33,    15,   432,   120,  1366,
      84,   443,    86,     7,   126,     3,   438,   442,    19,   136,
    1540,   437,   437,   437,    76,  1545,    76,  1547,  1548,   437,
    1550,    51,   437,   307,   174,   437,    79,   441,   437,   437,
      31,   183,   116,   322,   117,   437,   120,   121,   327,   437,
     124,   125,   183,   438,   437,    76,   130,   437,    76,    76,
     445,   437,    76,   342,    69,     8,     9,    10,    11,    12,
     437,   437,  1429,  1430,   181,  1432,   437,   189,   190,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    19,   437,
      33,  1517,   371,   372,   168,   274,     3,  1617,   141,   173,
     143,   144,   437,   210,     3,    19,    15,  1627,  1628,  1629,
       3,  1631,  1632,    19,   226,   227,  1636,   782,    19,    19,
     785,   439,   787,  1643,   789,   790,    20,   792,   793,   794,
      15,   243,    15,    15,   246,  1655,  1656,   252,    28,   251,
     443,   443,    15,  1518,    18,  1680,   438,   437,   255,   192,
     193,   194,   195,  1673,  1674,    20,  1531,  1692,   441,  1679,
    1660,   439,   437,  1683,  1539,   437,  1541,  1687,   437,    28,
    1690,   278,   443,   131,    19,  1739,  1740,  1741,   437,   437,
     437,    69,  1702,  1558,  1559,  1560,   438,  1713,    98,  1715,
       3,     3,   437,   445,   437,    15,   437,   107,   437,   437,
    1720,   437,   112,   437,   114,   437,   116,  1727,   118,   437,
     120,   437,   122,   437,   124,   322,   126,  1574,   437,  1739,
    1740,  1741,   437,   437,   437,  1745,   437,   437,  1585,  1586,
    1587,  1588,   437,   437,   437,     3,  1756,  1757,  1758,  1759,
    1760,   437,   437,   437,  1619,   437,     3,   437,   437,  1624,
     437,  1626,  1772,   327,  1774,   437,     3,     3,   332,   333,
     334,     3,     3,     3,   183,   183,    28,  1787,    28,   443,
     437,   439,  1807,   181,   437,   437,  1796,   443,   437,  1799,
    1800,   388,   389,  1803,  1804,   392,   393,   437,   395,  1664,
     437,   437,   366,  1813,   437,   373,   403,   404,    22,   373,
     439,   437,   437,   437,   437,   437,  1826,   437,   437,   322,
     437,  1831,  1832,  1833,   437,   437,  1691,   438,  1693,   437,
       3,  1841,     3,    15,  1844,  1845,   438,   439,    15,    28,
     443,    15,   443,   445,   442,   442,    15,   441,   441,   441,
     441,   441,  1862,  1863,  1864,   441,  1866,    69,    13,  1869,
      15,    16,    17,    18,    19,    20,   439,   437,    22,  1894,
     437,   443,    27,    28,    29,    30,    28,    32,   442,    13,
      29,    15,    16,    17,    18,    19,    20,  1752,    29,  1044,
       7,  1046,   442,    27,    28,    29,    30,   183,    32,    19,
    1765,  1911,   264,  1913,    46,    47,    48,    49,    50,    51,
      52,    53,    54,  1923,   441,   441,     3,     3,    15,  1784,
    1785,   437,   261,  1788,   224,    13,   441,    15,    16,    17,
      18,    19,    20,   439,    29,    29,   438,  1802,   439,    27,
      28,  1806,    30,  1808,    32,   441,   439,    13,   438,    15,
      16,    17,    18,    19,    20,     7,   439,   439,   438,  1824,
    1825,    27,    28,    29,    30,   120,    32,   439,   439,   438,
     438,   126,   437,   437,   441,  1840,   258,   437,   441,   437,
     281,  1846,   437,  1848,  1849,   399,   120,   399,   437,   442,
     437,   443,   126,     7,   439,   439,  1861,    13,   439,    15,
      16,    17,    18,    19,    20,  1852,   439,   439,   438,   137,
     439,    27,    28,    29,    30,   259,    32,   343,   344,   345,
     346,   347,   348,   349,   350,   259,     8,     9,    10,    11,
      12,   259,   120,   146,   189,   190,   441,   322,   126,  1904,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   317,
     359,    33,   377,   375,   120,   189,   190,   281,   345,   367,
     126,   437,    13,  1928,    15,    16,    17,    18,    19,    20,
     343,   226,   227,   387,   391,   390,    27,    28,    29,    30,
      13,    32,    15,    16,    17,    18,    19,    20,   243,   437,
      76,   246,   226,   227,    27,    28,   251,    30,   394,    32,
     276,   189,   190,   264,   120,   264,   437,   437,    20,   243,
     126,    76,   246,   437,   359,   317,   367,   251,    76,    76,
     419,   437,   322,   189,   190,   437,     8,     9,    10,    11,
      12,   421,   359,   259,   259,   442,    20,   442,   226,   227,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   437,
     259,    33,   378,   259,    69,   243,   437,   437,   246,   408,
     226,   227,   437,   251,   443,   437,   358,   437,   439,   120,
     437,   437,   437,   189,   190,   126,   437,   243,   358,   443,
     246,   437,   437,   437,   437,   251,   353,   120,   557,   361,
     861,   439,   261,   126,  1108,  1018,  1875,  1021,     8,     9,
      10,    11,    12,   588,  1271,   380,  1096,   761,   387,  1569,
     226,   227,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   909,   832,    33,  1713,   193,  1432,   243,  1715,   833,
     246,  1215,   838,  1059,  1340,   251,  1113,  1388,   189,   190,
     950,  1454,  1404,  1462,     8,     9,    10,    11,    12,  1680,
    1807,  1660,  1684,  1809,  1683,    -1,   189,   190,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
    1004,    -1,    -1,    -1,    -1,   226,   227,    -1,    -1,    -1,
      -1,    -1,    -1,   438,    -1,    -1,    -1,    -1,    -1,    -1,
     445,    -1,   243,   226,   227,   246,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,   438,     8,     9,    10,    11,    12,
     243,   445,    -1,   246,    -1,    -1,    -1,    -1,   251,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,   437,
     438,    -1,    -1,    -1,    -1,    -1,    -1,   445,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,   438,     8,     9,    10,    11,    12,    -1,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   438,    -1,    33,    -1,    -1,    -1,    -1,   445,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,   439,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,   438,    -1,    -1,
     143,   144,    -1,    -1,   445,    -1,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,   438,    -1,    -1,   161,    -1,
      -1,    -1,   445,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,   176,    33,     8,     9,    10,    11,    12,
      -1,    -1,   185,    -1,   187,   188,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,   439,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,   254,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,   439,
      -1,    -1,    -1,    -1,    -1,    82,    83,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    -1,
      -1,    -1,    -1,   326,    -1,   439,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
      -1,   138,    -1,    -1,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,    -1,     8,     9,    10,    11,    12,    -1,    -1,
     177,    42,    -1,    -1,    -1,    -1,   439,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    66,    67,    -1,    -1,   412,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    73,   426,    33,   439,    87,    78,   431,    -1,
      -1,    -1,    -1,   177,    -1,   232,   233,    19,   235,   236,
     237,   238,   239,   240,   241,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,   439,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    51,
      33,   122,    -1,    -1,    -1,    -1,   137,    -1,   139,    -1,
     439,    -1,     8,     9,    10,    11,    12,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   166,   167,    33,    -1,    -1,
      -1,   439,   163,   310,   311,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   325,    -1,
      -1,   328,   329,   330,   331,    -1,    -1,    -1,   120,   439,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,   311,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
     439,   325,    -1,    -1,   328,   329,   330,   331,    -1,    -1,
      -1,    -1,    -1,   254,    -1,    -1,   257,   258,    -1,    46,
      -1,    -1,    -1,   254,   265,    -1,   439,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,
     202,   203,   204,   205,   206,    46,    -1,   424,   425,    -1,
      -1,    -1,   439,    -1,    -1,    -1,    -1,    -1,   435,    86,
     222,    -1,    -1,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    73,    74,    75,   316,    77,    78,   439,    80,
      -1,    -1,    -1,    84,    -1,    86,    87,    46,    -1,   116,
      66,    -1,    51,   120,   121,   326,   123,   124,   125,    -1,
     424,   425,   437,   130,    -1,    -1,    -1,    66,    -1,    -1,
      86,   435,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,    80,    -1,   124,   125,   366,    -1,    86,    46,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     116,   168,   383,    -1,   120,   121,   173,    -1,   124,   125,
     381,    -1,    -1,    -1,   130,   386,    -1,   116,    -1,    46,
      -1,   120,   121,   122,   123,   124,   125,   168,    86,    -1,
      -1,   130,   173,   414,   415,   134,   417,   418,   137,   420,
     139,   412,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,   426,    -1,   173,   116,    86,
     431,   442,   120,   121,    -1,   123,   124,   125,    -1,   168,
      -1,   187,   130,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,   187,   116,
     189,    -1,    -1,   120,   121,    -1,   123,   124,   125,   198,
      -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   437,    -1,
     168,    -1,    -1,    -1,    -1,   173,   207,   208,   209,   210,
     211,   212,   213,   214,    -1,   216,   217,   218,   219,   220,
     221,    -1,    -1,    -1,    -1,    -1,    -1,   236,    -1,   441,
      -1,   168,    -1,    -1,    -1,    -1,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,   254,    -1,    -1,    66,    -1,
      -1,    -1,   261,   262,    -1,   264,    -1,    -1,    46,    -1,
     269,   270,    -1,   272,   273,    -1,   275,    -1,    -1,   278,
     279,   280,    -1,    46,    -1,    -1,    -1,    -1,    66,    -1,
      -1,   437,    -1,    -1,   293,   294,   312,    -1,    -1,   298,
      -1,   300,   301,    -1,   303,    -1,    -1,    -1,    86,   308,
      46,    -1,    -1,   312,   313,    -1,   315,   316,    -1,   318,
     319,   320,    -1,    86,    -1,   324,    -1,    -1,    -1,   137,
      -1,    -1,    -1,    -1,   261,   262,   403,   404,   116,    75,
     407,    46,   120,   121,    -1,   123,   124,   125,    -1,    -1,
      86,    -1,   130,   116,    -1,    -1,    -1,   120,   121,   167,
      -1,   124,   125,   437,    -1,    -1,    -1,   130,    -1,    -1,
      -1,    -1,   180,    -1,    -1,   442,    -1,    -1,    -1,    -1,
     116,    86,    -1,    -1,   120,   121,   194,    -1,   124,   125,
     168,    -1,    -1,    -1,   130,   173,    -1,    -1,    -1,    -1,
      -1,   442,    -1,    -1,    -1,   168,    -1,    19,   366,    -1,
     173,   116,    -1,    -1,    -1,   120,   121,   153,   123,   124,
     125,    -1,    -1,    -1,    -1,   130,   442,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,   173,     3,    -1,
      -1,    -1,    -1,   442,    -1,    -1,   254,    -1,   439,   257,
     258,    -1,    -1,    18,    19,   413,    -1,   265,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,   173,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,   442,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,    -1,
      -1,   319,    -1,    -1,   322,   442,    -1,    -1,    -1,    -1,
      -1,    86,    46,    -1,    -1,   333,    -1,   335,    -1,   337,
     338,   339,   340,   341,   342,    -1,    -1,    -1,    -1,    -1,
     348,    -1,    -1,   351,    -1,    -1,   354,    71,    72,    -1,
      -1,    -1,    -1,   118,    -1,    -1,    -1,    81,   366,    -1,
     125,   126,     8,     9,    10,    -1,   374,    -1,    -1,    -1,
      -1,   136,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,   153,   154,
     155,   156,    -1,   158,   159,   207,   208,   209,   210,   211,
     212,   213,   214,    -1,   216,   217,   218,   219,   220,   221,
     134,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,   382,
     383,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   442,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,   170,    33,    -1,   173,
      -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,   182,    -1,
     184,    -1,    -1,    -1,   442,   189,   190,   191,    -1,    -1,
      -1,    -1,   196,   197,   198,    -1,    -1,    -1,    -1,   442,
       8,     9,    10,    11,    12,    -1,   223,    -1,   253,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,   442,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,    -1,   442,   207,   208,
     209,   210,   211,   212,   213,   214,    -1,   216,   217,   218,
     219,   220,   221
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   448,   449,    46,    71,    72,    81,   134,   170,
     173,   175,   182,   184,   189,   190,   191,   196,   197,   198,
     473,   474,   475,   476,   477,   478,   531,   532,   533,   534,
     536,   537,   538,   541,   544,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   639,   676,   677,
     678,   679,   680,   681,   682,   683,   733,   734,   744,   755,
     756,   757,   759,     0,     3,    34,    43,    46,    57,    70,
      80,    86,   116,   118,   119,   126,   161,   162,   173,   196,
     199,   437,   450,   462,   468,   471,   472,   481,   484,   487,
     489,   492,   494,   495,   497,   498,   505,   515,   516,   573,
     575,   585,   623,   626,   640,   642,   643,   644,   685,   686,
     687,   692,   722,   725,   735,   736,   745,   748,   758,   760,
     761,   762,    19,    20,    45,   571,    20,    56,    64,    65,
      66,   479,     3,   571,   571,   171,   172,   571,   571,     3,
     161,   143,   144,   161,   176,   185,   187,   188,   254,   326,
     412,   426,   431,   161,   161,    79,   141,   143,   144,   192,
     193,   194,   195,    13,    15,    16,    17,    18,    19,    20,
      27,    28,    30,    32,   120,   126,   189,   190,   226,   227,
     243,   246,   251,   438,   445,   590,   602,   607,   610,   611,
     612,   614,   616,    36,    45,   441,   560,   571,    19,    19,
      20,    44,    55,   460,   464,    68,   143,   157,    43,    62,
     118,   187,   469,   470,    50,    67,    81,    19,   117,    19,
      86,   163,   143,   460,   616,    19,    19,   138,   499,   499,
     441,    73,    78,   122,   163,   254,   326,   381,   386,   412,
     426,   431,   499,    46,    66,    86,   116,   120,   121,   123,
     124,   125,   130,   168,   173,   442,   500,   518,   499,   499,
      51,    66,    80,   122,   123,   134,   137,   139,   187,   189,
     198,   236,   254,   261,   262,   264,   269,   270,   272,   273,
     275,   278,   279,   280,   293,   294,   298,   300,   301,   303,
     308,   312,   313,   315,   316,   318,   319,   320,   324,   442,
     500,   499,    84,   327,   332,   333,   334,   366,   373,   442,
     500,   645,   646,   647,   499,   382,   383,   442,   500,   499,
     499,   499,    66,   187,   312,   442,   500,   737,   740,   499,
      73,    74,    75,    77,    78,    80,    84,    87,   442,   483,
     486,   500,    75,   153,   442,   485,   500,    36,    45,   441,
     519,   479,     3,     3,   479,    67,   480,     3,     3,   571,
     571,     3,    36,    45,   441,   522,    86,   546,    19,    20,
      45,   572,     3,   186,   542,     3,     3,   539,   545,   268,
      19,   123,   194,   365,   379,   380,   535,   144,   194,   535,
     144,   194,   436,    18,    19,   454,   456,   456,     3,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    29,   438,
     444,   606,   608,   614,    30,   438,   252,    28,   252,    15,
     444,   609,   616,   438,   438,   438,   438,   438,   438,   228,
     229,   230,   231,   595,   616,    15,    16,    17,    19,   438,
     590,   591,   594,   596,   597,   598,   600,   602,   603,   604,
       5,    82,    83,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   138,   177,   232,   233,   235,   236,   237,   238,   239,
     240,   241,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   310,   311,   325,   328,   329,   330,   331,   424,   425,
     435,   615,   763,     3,     8,     9,    10,    11,    12,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    33,    46,
      47,    48,    49,    50,    51,    52,    53,    54,   466,   467,
      15,   561,     3,    22,    63,   463,    45,   441,   465,    15,
      19,    35,    36,    37,    38,    69,   438,   451,   453,   519,
     451,    20,    58,    59,   437,   451,   452,   452,   180,   169,
     493,    15,    17,    18,    19,   138,   438,   488,   574,    19,
     490,   522,   437,   586,   138,    19,   441,   441,   496,   441,
     519,   322,    19,   504,   117,   451,   453,   517,    45,    69,
     126,   127,   135,   253,   501,   582,    69,   501,    69,   460,
     522,   437,   437,   441,   441,   180,   282,   322,    81,   437,
      20,   283,   460,   453,    69,    85,   187,   297,   323,   166,
     453,   437,   451,   454,   641,   183,   454,    76,   271,   281,
      76,   269,   276,   285,   286,    87,   281,   295,   296,   295,
     299,   453,   302,   304,   309,    86,    87,   122,   314,    87,
     317,   315,   453,   264,   453,   437,   441,   364,   488,   453,
     116,   451,   453,   117,   437,   441,   441,    86,   384,   385,
     437,   441,   441,   441,   322,   456,    86,   437,   205,   274,
     305,   314,   427,   428,   429,   430,   441,   743,   441,    86,
     453,    76,   453,    79,    81,    85,   451,   437,   437,   437,
      76,    20,   461,   437,   437,    79,   128,   129,   141,   142,
     144,   520,   521,     3,   480,     3,   451,     3,     3,     3,
     128,   174,   523,   524,     3,    19,     3,   572,     3,     3,
       3,    86,   156,   171,   183,   543,     3,    45,    86,   118,
     125,   126,   136,   153,   154,   155,   156,   158,   159,   456,
     540,   582,     3,    19,    86,   118,   119,   126,   161,   199,
     535,   535,   535,   684,    45,   535,    45,   535,     3,   535,
     535,     3,   535,   535,   535,    30,   440,   458,   181,   181,
       7,   608,   608,   616,   608,   608,    14,    15,   616,   620,
     621,    27,    28,   252,    28,   609,   609,    30,   616,   616,
     616,   616,   616,    19,    15,   443,   439,   443,    29,   593,
     595,   616,     7,   443,   446,    27,    28,   441,   443,   446,
     616,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     616,   616,   616,   616,   209,   234,   242,   247,   248,   249,
     442,   443,     3,   616,   460,   466,   437,   452,   616,   451,
      60,    61,    60,    61,    39,    40,    41,   451,   512,   513,
     616,   437,   207,   208,   209,   210,   211,   212,   213,   214,
     216,   217,   218,   219,   220,   221,   576,   577,   578,   580,
     584,    42,   164,   165,   166,   437,   491,   437,   438,   583,
      19,   161,   442,   453,   488,   506,   509,   510,    36,   451,
     503,    19,   580,   581,   136,   616,   503,   503,   625,    76,
      76,   453,    76,   321,   453,   437,    51,   437,   437,   451,
     257,   258,   453,   307,   453,   174,   454,   437,   437,    31,
     455,    42,   183,   437,   451,   183,   451,    76,    76,   451,
      76,   135,   277,   451,   451,   453,    76,   437,   117,   437,
     453,   437,   453,   277,   305,   306,   453,   504,   453,   437,
     437,   453,   453,   453,   437,   183,   437,   453,   453,    69,
     451,   648,    19,   437,   437,   691,   724,   453,   504,    20,
     454,   454,   274,   738,   739,   742,   437,   747,   451,   451,
     453,   453,   453,   451,   454,   456,   457,   442,   443,     3,
     442,   443,     3,    19,    15,   456,    19,    19,   581,   457,
      19,     3,    20,   675,   675,     3,    19,   116,   277,   322,
     327,   342,   371,   372,   535,   675,   535,   675,   675,   675,
     675,   675,   675,   451,   454,    15,    15,    15,   439,   443,
     439,   252,    28,   443,   443,   443,   439,   443,   439,   443,
     616,   616,   443,     7,   443,   443,   439,    18,   438,   591,
     598,    15,    18,   603,   438,   467,   437,   442,   439,    20,
     437,   510,   437,   439,    19,   215,   437,   441,   451,   454,
     439,   577,   579,   584,   456,   437,    28,   508,   443,   131,
     502,   453,   123,   261,   262,   442,   500,   624,   451,   451,
     437,   451,   437,   437,   453,   437,   437,   437,   437,   453,
     437,   453,   437,    19,   641,   451,   451,   437,   451,   437,
     451,   451,   437,   451,   437,   437,   437,   437,   437,   451,
     488,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   451,   451,   123,   186,   278,   333,   355,
     357,   362,   364,   368,   369,   442,   649,   656,   659,   437,
     123,   210,   403,   404,   407,   442,   500,   688,   123,   366,
     413,   442,   500,   723,   437,   437,   455,   454,   254,   367,
     738,    19,    51,   120,   200,   201,   202,   203,   204,   205,
     206,   222,   225,   254,   442,   612,   613,   617,   622,   741,
     123,   442,   500,   746,    69,   482,   521,   524,     3,     3,
     488,   488,    15,   488,   675,     3,   675,     3,     3,     3,
       3,     3,     3,   183,   183,   608,   620,    28,    28,   616,
     616,   616,   616,   616,   443,   439,   443,    29,   593,   616,
     593,    29,   593,   593,   616,   443,   616,   578,   587,   588,
     622,   437,   439,   181,    20,   457,   507,   509,    81,   132,
     133,   134,   627,   633,   627,   634,   454,   638,   437,   443,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   668,   674,   453,   335,   336,   368,   335,
     453,   650,   322,   456,   652,   653,   651,   370,   453,   437,
     373,   669,   693,   701,   456,   702,   707,   689,   690,   456,
     437,   726,   732,   453,   451,   437,   455,   453,   451,    22,
     438,    22,   438,   616,   616,   616,   453,   615,   763,   437,
     616,   618,   619,   749,   754,   437,   451,     3,     3,    15,
      15,    28,   439,   439,   439,   439,   443,   616,   616,   439,
     443,     7,   439,   443,   439,   443,     7,   439,   443,   443,
      15,   439,   442,   622,   579,    15,   457,   510,   511,   441,
     632,    31,   263,   635,   451,   510,   670,   451,   451,   453,
     451,   441,   488,   441,   441,   451,   451,   441,   511,   441,
     706,   441,   454,   708,   713,    20,   441,   714,   719,   511,
      69,   616,   621,   616,   612,   437,   223,   441,   437,    22,
      22,    33,   443,   437,   511,   546,   546,    28,   616,   439,
     439,    29,   593,    29,   593,    29,   593,     7,    29,   593,
      29,   593,   442,   183,   632,   631,   628,    19,   460,   264,
     636,   437,   671,   441,   673,   661,   654,   661,   657,   441,
     700,   705,   704,   709,   715,   441,   731,   451,   437,   439,
     437,   763,   441,   589,   622,   605,   616,   616,   126,   189,
     190,   246,   252,   619,   441,   753,     3,     3,   439,   439,
     439,   439,   443,     7,   439,   439,   439,   443,   438,   439,
       7,   439,   439,     7,   439,    15,   628,   137,   139,   167,
     255,   256,   259,   260,   265,   442,   525,   527,   528,   629,
     454,   261,   637,   669,   672,   442,   456,   662,   663,   186,
     335,   356,   442,   655,   442,   180,   265,   337,   338,   339,
     341,   442,   525,   658,   699,   698,   396,   397,   400,   401,
     402,   442,   703,   712,   718,   730,   727,   439,   587,   224,
       6,    15,    16,    17,   438,   442,   590,   592,   594,   596,
     597,   599,   601,   437,   437,   438,   438,   438,   438,   437,
     752,   750,    29,   593,    29,   593,   593,     7,   593,   437,
     460,   453,   441,   257,   258,   258,   452,   451,   127,   146,
     266,   267,   630,   441,   437,   453,    66,   180,   194,   254,
     257,   258,   265,   316,   319,   322,   333,   335,   337,   338,
     339,   340,   341,   342,   348,   351,   354,   366,   374,   442,
     525,   660,   356,   363,   664,   453,   451,   453,   437,   451,
     127,   266,   352,   451,   451,   281,   155,   451,   437,   181,
     210,   255,   278,   322,   388,   389,   392,   393,   395,   403,
     404,   442,   694,   399,   399,   453,   453,   453,   437,   399,
     405,   442,   710,   399,   406,   442,   716,    42,    66,    67,
      87,   139,   166,   254,   257,   258,   265,   316,   366,   383,
     414,   415,   417,   418,   420,   442,   525,   728,   437,   442,
     589,   587,   616,     7,   440,   443,   616,   616,   616,   616,
      42,    66,   257,   258,   338,   342,   414,   432,   442,   751,
     439,   439,   439,   443,   439,   438,   439,   526,   527,   259,
     259,   259,   148,   149,   146,   117,   138,   140,   145,   160,
     204,   529,   322,   451,   441,   453,   359,   178,   179,   340,
     376,   514,   127,   266,   352,   317,   453,   377,   453,   451,
     451,   451,   281,   451,   155,   451,   343,   344,   345,   346,
     347,   348,   349,   350,   375,   345,   451,   367,   343,   437,
     451,   437,   451,   451,   387,   707,   281,   387,   120,   399,
     391,   453,   390,    76,   394,   276,   264,   695,   264,   696,
     437,   451,   451,   398,   451,   720,   708,   711,   437,   720,
     714,   717,   437,   451,   322,   422,    76,   451,   453,   454,
     453,   359,   340,   376,   514,   127,   148,   352,   423,   729,
     317,   367,   343,   416,    76,    76,   358,   451,   419,   421,
     437,   439,   438,   592,   587,   599,   439,   439,   439,   439,
     451,   322,   359,   340,   376,   514,   259,   433,   434,   259,
     451,   437,   593,   593,   442,   437,   452,   452,   452,   148,
     149,   451,    20,   459,   459,   146,   147,   530,   138,   140,
     138,   140,   442,   453,   665,   360,   361,   451,   451,   451,
     451,   451,   258,   453,   378,   451,   451,   453,   453,   451,
     453,   259,   451,   259,   409,   410,   411,   697,   451,   451,
     453,   451,   451,    69,   453,   713,   453,   719,   408,   721,
     721,   451,   453,   453,   451,   451,   451,   451,   258,   453,
     451,   451,   451,   453,   453,   453,   616,   437,   437,   437,
     437,   453,   451,   451,   451,   451,   451,   439,   443,   526,
     437,   437,   437,   148,   149,   150,   151,   152,   148,   149,
     150,   151,   152,   437,   459,   459,   459,   459,   442,   454,
     667,   358,   453,   451,   451,   721,   451,   453,   358,   593,
     529,   529,   529,   529,   437,   437,   437,   437,   353,   666,
     443,   529,   529,   529,   529,   437,   593,   439
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 846 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 847 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 860 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 870 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 871 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 878 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 879 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 880 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 889 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 890 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 891 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 892 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 893 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 900 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 907 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 908 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 912 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 920 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 924 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 928 "cf-parse.y"
    {
     (yyval.i) = ipa_masklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 935 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 944 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[(1) - (1)].s)).s;
   }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 951 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 952 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 958 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 967 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 968 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 972 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 977 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 982 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 983 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 987 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 988 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 992 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 993 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 994 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 995 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 996 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 997 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 998 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 999 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 1000 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 1006 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1007 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1017 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1020 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1023 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1024 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 1025 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1026 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1027 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1028 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 1038 "cf-parse.y"
    { new_config->latency_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 1039 "cf-parse.y"
    { new_config->latency_limit = (yyvsp[(4) - (4)].i32); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1040 "cf-parse.y"
    { new_config->watchdog_warning = (yyvsp[(3) - (3)].i32); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1041 "cf-parse.y"
    { new_config->watchdog_timeout = ((yyvsp[(3) - (3)].i32) + 999999) TO_S; }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1050 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1053 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1060 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1063 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1066 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1069 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1072 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1087 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1092 "cf-parse.y"
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1093 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) <= 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1097 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1098 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1102 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1109 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1110 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1111 "cf-parse.y"
    {
      THIS_KRT->merge_paths = (yyvsp[(3) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[(3) - (4)].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1123 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1128 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1132 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1146 "cf-parse.y"
    { THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1147 "cf-parse.y"
    { THIS_KRT->sys.metric = (yyvsp[(2) - (2)].i); }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1161 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1162 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1167 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1169 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1176 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[(1) - (1)].s)).i;
#ifndef IPV6
     else if ((yyvsp[(1) - (1)].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[(1) - (1)].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1198 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1199 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1200 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1201 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1206 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1212 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1213 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1217 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1225 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1231 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1245 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1246 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1250 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1256 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1260 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[(2) - (2)].s)->class != SYM_TEMPLATE) && ((yyvsp[(2) - (2)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(2) - (2)].s)->def);
   }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1269 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1280 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1284 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1285 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1286 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1287 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1288 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1289 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1290 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1291 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1292 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1293 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1294 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1295 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1299 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 1301 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 1302 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 1306 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 1307 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 1308 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 1309 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 1310 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 1314 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 1320 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 1324 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 1332 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 1333 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 1341 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 1349 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 1350 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 1351 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 1355 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 1356 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 1370 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 1372 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 1391 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 1401 "cf-parse.y"
    { DIRECT_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 1405 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 1419 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 1420 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 1421 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 1426 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 1430 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 1431 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 1432 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 1433 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 1434 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 1435 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 1441 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 1442 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 1443 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 1448 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 1452 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 1453 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 1474 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->length = strlen((yyvsp[(2) - (2)].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 1494 "cf-parse.y"
    { }
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 1495 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 1496 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 1497 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 1498 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 1499 "cf-parse.y"
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[(2) - (4)].time); }
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 1500 "cf-parse.y"
    { this_p_item->gento = this_p_item->accto = (yyvsp[(2) - (4)].time); }
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 1501 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 1502 "cf-parse.y"
    { this_p_item->alg = (yyvsp[(2) - (4)].i); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 1506 "cf-parse.y"
    { (yyval.i) = ALG_MD5; }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.i) = ALG_SHA1; }
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 1508 "cf-parse.y"
    { (yyval.i) = ALG_SHA256; }
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 1509 "cf-parse.y"
    { (yyval.i) = ALG_SHA384; }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 1510 "cf-parse.y"
    { (yyval.i) = ALG_SHA512; }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_MD5; }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA1; }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA256; }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA384; }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.i) = ALG_HMAC_SHA512; }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 1522 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 1525 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 1528 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 1531 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 1535 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 1539 "cf-parse.y"
    { if_show(); }
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 1542 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 1546 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 1549 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 1554 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 1560 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 1567 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 1572 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 1577 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 1582 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 1586 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 1590 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 1594 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 1603 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 1611 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 1615 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 1622 "cf-parse.y"
    { (yyval.i) = RSEM_PREEXPORT; }
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 1623 "cf-parse.y"
    { (yyval.i) = RSEM_EXPORT; }
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 1624 "cf-parse.y"
    { (yyval.i) = RSEM_NOEXPORT; }
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 1630 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 1633 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 1640 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 1647 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 1651 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 1659 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 1660 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 1661 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 1667 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 1670 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 1673 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 1674 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 1675 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 1676 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 1677 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 1678 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 1679 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 1684 "cf-parse.y"
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 1689 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 1698 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 1705 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 1712 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 1720 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 1722 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 1724 "cf-parse.y"
    { io_log_dump(); cli_msg(0, ""); }
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 1726 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 1728 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 1730 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 1732 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 1734 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 1737 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 1740 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 1746 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 1753 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 1760 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 1762 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 1764 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 1766 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 1768 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 1770 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 1774 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 1778 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 1781 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 1784 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 1785 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 1786 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 1790 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 1791 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 1792 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 1800 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 1801 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 1810 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 1818 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 1819 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 1820 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.i) = T_LC; }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 1826 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.i) = T_LCLIST; }
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 1828 "cf-parse.y"
    {
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 1850 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 1862 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 1869 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 1870 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 1877 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 1886 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 1894 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 1918 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 1923 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 1936 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 324:
/* Line 1792 of yacc.c  */
#line 1939 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name);
     cf_pop_scope();
   }
    break;

  case 325:
/* Line 1792 of yacc.c  */
#line 1952 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 326:
/* Line 1792 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 327:
/* Line 1792 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 328:
/* Line 1792 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 329:
/* Line 1792 of yacc.c  */
#line 1961 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 330:
/* Line 1792 of yacc.c  */
#line 1964 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 331:
/* Line 1792 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 332:
/* Line 1792 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 333:
/* Line 1792 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 334:
/* Line 1792 of yacc.c  */
#line 1988 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 335:
/* Line 1792 of yacc.c  */
#line 1989 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 336:
/* Line 1792 of yacc.c  */
#line 1990 "cf-parse.y"
    {
     (yyval.v) = f_eval((yyvsp[(2) - (3)].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
    break;

  case 337:
/* Line 1792 of yacc.c  */
#line 1994 "cf-parse.y"
    {
     if (!cf_symbol_is_constant((yyvsp[(1) - (1)].s))) cf_error("%s: constant expected", (yyvsp[(1) - (1)].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[(1) - (1)].s)))) cf_error("%s: set-incompatible type", (yyvsp[(1) - (1)].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[(1) - (1)].s)->def);
   }
    break;

  case 338:
/* Line 1792 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 339:
/* Line 1792 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 340:
/* Line 1792 of yacc.c  */
#line 2004 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 341:
/* Line 1792 of yacc.c  */
#line 2005 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 342:
/* Line 1792 of yacc.c  */
#line 2006 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 343:
/* Line 1792 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 344:
/* Line 1792 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 345:
/* Line 1792 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 346:
/* Line 1792 of yacc.c  */
#line 2015 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (5)].i32), (yyvsp[(2) - (5)].i32), 0, CC_ALL); }
    break;

  case 347:
/* Line 1792 of yacc.c  */
#line 2016 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 348:
/* Line 1792 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.e) = f_new_pair_set((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 349:
/* Line 1792 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, CC_ALL); }
    break;

  case 350:
/* Line 1792 of yacc.c  */
#line 2019 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (5)].i32), (yyvsp[(4) - (5)].i32)); }
    break;

  case 351:
/* Line 1792 of yacc.c  */
#line 2020 "cf-parse.y"
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 352:
/* Line 1792 of yacc.c  */
#line 2021 "cf-parse.y"
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
    break;

  case 353:
/* Line 1792 of yacc.c  */
#line 2023 "cf-parse.y"
    { (yyval.e) = f_new_pair_item((yyvsp[(2) - (11)].i32), (yyvsp[(8) - (11)].i32), (yyvsp[(4) - (11)].i32), (yyvsp[(10) - (11)].i32)); }
    break;

  case 354:
/* Line 1792 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 355:
/* Line 1792 of yacc.c  */
#line 2028 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 356:
/* Line 1792 of yacc.c  */
#line 2029 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 357:
/* Line 1792 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 358:
/* Line 1792 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 359:
/* Line 1792 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 360:
/* Line 1792 of yacc.c  */
#line 2036 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 361:
/* Line 1792 of yacc.c  */
#line 2040 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 362:
/* Line 1792 of yacc.c  */
#line 2041 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 363:
/* Line 1792 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), (yyvsp[(4) - (7)].i32), (yyvsp[(4) - (7)].i32), 0, LC_ALL); }
    break;

  case 364:
/* Line 1792 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), 0, LC_ALL); }
    break;

  case 365:
/* Line 1792 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (7)].i32), (yyvsp[(2) - (7)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 366:
/* Line 1792 of yacc.c  */
#line 2045 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (9)].i32), (yyvsp[(4) - (9)].i32), 0, LC_ALL, 0, LC_ALL); }
    break;

  case 367:
/* Line 1792 of yacc.c  */
#line 2046 "cf-parse.y"
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
    break;

  case 368:
/* Line 1792 of yacc.c  */
#line 2048 "cf-parse.y"
    { (yyval.e) = f_new_lc_item((yyvsp[(2) - (15)].i32), (yyvsp[(10) - (15)].i32), (yyvsp[(4) - (15)].i32), (yyvsp[(12) - (15)].i32), (yyvsp[(6) - (15)].i32), (yyvsp[(14) - (15)].i32)); }
    break;

  case 372:
/* Line 1792 of yacc.c  */
#line 2055 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 373:
/* Line 1792 of yacc.c  */
#line 2056 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 377:
/* Line 1792 of yacc.c  */
#line 2063 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 378:
/* Line 1792 of yacc.c  */
#line 2064 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 380:
/* Line 1792 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 382:
/* Line 1792 of yacc.c  */
#line 2074 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 383:
/* Line 1792 of yacc.c  */
#line 2078 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 384:
/* Line 1792 of yacc.c  */
#line 2085 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 385:
/* Line 1792 of yacc.c  */
#line 2086 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 386:
/* Line 1792 of yacc.c  */
#line 2087 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 387:
/* Line 1792 of yacc.c  */
#line 2088 "cf-parse.y"
    {
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 388:
/* Line 1792 of yacc.c  */
#line 2095 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 389:
/* Line 1792 of yacc.c  */
#line 2096 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 390:
/* Line 1792 of yacc.c  */
#line 2099 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 391:
/* Line 1792 of yacc.c  */
#line 2100 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 392:
/* Line 1792 of yacc.c  */
#line 2107 "cf-parse.y"
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 393:
/* Line 1792 of yacc.c  */
#line 2119 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 394:
/* Line 1792 of yacc.c  */
#line 2120 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 395:
/* Line 1792 of yacc.c  */
#line 2124 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 396:
/* Line 1792 of yacc.c  */
#line 2125 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 397:
/* Line 1792 of yacc.c  */
#line 2129 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 398:
/* Line 1792 of yacc.c  */
#line 2130 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(4) - (4)].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[(1) - (4)].i); (yyval.h)->val2 = (yyvsp[(3) - (4)].i); }
    break;

  case 399:
/* Line 1792 of yacc.c  */
#line 2131 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 400:
/* Line 1792 of yacc.c  */
#line 2132 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; }
    break;

  case 401:
/* Line 1792 of yacc.c  */
#line 2133 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 402:
/* Line 1792 of yacc.c  */
#line 2134 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 403:
/* Line 1792 of yacc.c  */
#line 2138 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 404:
/* Line 1792 of yacc.c  */
#line 2139 "cf-parse.y"
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; }
    break;

  case 405:
/* Line 1792 of yacc.c  */
#line 2140 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 406:
/* Line 1792 of yacc.c  */
#line 2144 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 407:
/* Line 1792 of yacc.c  */
#line 2145 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 408:
/* Line 1792 of yacc.c  */
#line 2146 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 409:
/* Line 1792 of yacc.c  */
#line 2147 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 410:
/* Line 1792 of yacc.c  */
#line 2148 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 411:
/* Line 1792 of yacc.c  */
#line 2149 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 412:
/* Line 1792 of yacc.c  */
#line 2150 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 413:
/* Line 1792 of yacc.c  */
#line 2151 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 414:
/* Line 1792 of yacc.c  */
#line 2152 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 415:
/* Line 1792 of yacc.c  */
#line 2153 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 416:
/* Line 1792 of yacc.c  */
#line 2154 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 417:
/* Line 1792 of yacc.c  */
#line 2158 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 418:
/* Line 1792 of yacc.c  */
#line 2159 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 419:
/* Line 1792 of yacc.c  */
#line 2160 "cf-parse.y"
    { (yyval.x) = f_generate_lc((yyvsp[(2) - (7)].x), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 421:
/* Line 1792 of yacc.c  */
#line 2174 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 422:
/* Line 1792 of yacc.c  */
#line 2197 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 423:
/* Line 1792 of yacc.c  */
#line 2211 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 424:
/* Line 1792 of yacc.c  */
#line 2212 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 425:
/* Line 1792 of yacc.c  */
#line 2213 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 426:
/* Line 1792 of yacc.c  */
#line 2214 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 427:
/* Line 1792 of yacc.c  */
#line 2215 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 428:
/* Line 1792 of yacc.c  */
#line 2216 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 429:
/* Line 1792 of yacc.c  */
#line 2217 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 430:
/* Line 1792 of yacc.c  */
#line 2218 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 431:
/* Line 1792 of yacc.c  */
#line 2219 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 432:
/* Line 1792 of yacc.c  */
#line 2220 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 433:
/* Line 1792 of yacc.c  */
#line 2224 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 434:
/* Line 1792 of yacc.c  */
#line 2225 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 435:
/* Line 1792 of yacc.c  */
#line 2226 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 436:
/* Line 1792 of yacc.c  */
#line 2227 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 437:
/* Line 1792 of yacc.c  */
#line 2228 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 438:
/* Line 1792 of yacc.c  */
#line 2229 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 439:
/* Line 1792 of yacc.c  */
#line 2230 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 440:
/* Line 1792 of yacc.c  */
#line 2231 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 441:
/* Line 1792 of yacc.c  */
#line 2232 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 442:
/* Line 1792 of yacc.c  */
#line 2233 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 443:
/* Line 1792 of yacc.c  */
#line 2234 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 444:
/* Line 1792 of yacc.c  */
#line 2235 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 445:
/* Line 1792 of yacc.c  */
#line 2236 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 446:
/* Line 1792 of yacc.c  */
#line 2237 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 447:
/* Line 1792 of yacc.c  */
#line 2238 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','~');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 448:
/* Line 1792 of yacc.c  */
#line 2239 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 449:
/* Line 1792 of yacc.c  */
#line 2240 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 450:
/* Line 1792 of yacc.c  */
#line 2242 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 451:
/* Line 1792 of yacc.c  */
#line 2243 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 452:
/* Line 1792 of yacc.c  */
#line 2244 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 453:
/* Line 1792 of yacc.c  */
#line 2246 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 454:
/* Line 1792 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 455:
/* Line 1792 of yacc.c  */
#line 2250 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 456:
/* Line 1792 of yacc.c  */
#line 2252 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 457:
/* Line 1792 of yacc.c  */
#line 2253 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 458:
/* Line 1792 of yacc.c  */
#line 2254 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 459:
/* Line 1792 of yacc.c  */
#line 2255 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 460:
/* Line 1792 of yacc.c  */
#line 2256 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 461:
/* Line 1792 of yacc.c  */
#line 2257 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','L'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 462:
/* Line 1792 of yacc.c  */
#line 2267 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 463:
/* Line 1792 of yacc.c  */
#line 2268 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 464:
/* Line 1792 of yacc.c  */
#line 2269 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 465:
/* Line 1792 of yacc.c  */
#line 2270 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_LCLIST; }
    break;

  case 466:
/* Line 1792 of yacc.c  */
#line 2271 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 467:
/* Line 1792 of yacc.c  */
#line 2272 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 468:
/* Line 1792 of yacc.c  */
#line 2273 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 469:
/* Line 1792 of yacc.c  */
#line 2274 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 470:
/* Line 1792 of yacc.c  */
#line 2276 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 471:
/* Line 1792 of yacc.c  */
#line 2277 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 472:
/* Line 1792 of yacc.c  */
#line 2282 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 473:
/* Line 1792 of yacc.c  */
#line 2305 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 474:
/* Line 1792 of yacc.c  */
#line 2306 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 475:
/* Line 1792 of yacc.c  */
#line 2307 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 476:
/* Line 1792 of yacc.c  */
#line 2308 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 477:
/* Line 1792 of yacc.c  */
#line 2309 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 478:
/* Line 1792 of yacc.c  */
#line 2310 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 479:
/* Line 1792 of yacc.c  */
#line 2314 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 480:
/* Line 1792 of yacc.c  */
#line 2317 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 481:
/* Line 1792 of yacc.c  */
#line 2318 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 482:
/* Line 1792 of yacc.c  */
#line 2319 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 483:
/* Line 1792 of yacc.c  */
#line 2327 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 484:
/* Line 1792 of yacc.c  */
#line 2334 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 485:
/* Line 1792 of yacc.c  */
#line 2343 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 486:
/* Line 1792 of yacc.c  */
#line 2344 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 487:
/* Line 1792 of yacc.c  */
#line 2348 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 488:
/* Line 1792 of yacc.c  */
#line 2354 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 489:
/* Line 1792 of yacc.c  */
#line 2364 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 490:
/* Line 1792 of yacc.c  */
#line 2373 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 491:
/* Line 1792 of yacc.c  */
#line 2379 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 492:
/* Line 1792 of yacc.c  */
#line 2384 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 493:
/* Line 1792 of yacc.c  */
#line 2391 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 494:
/* Line 1792 of yacc.c  */
#line 2396 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 495:
/* Line 1792 of yacc.c  */
#line 2402 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 496:
/* Line 1792 of yacc.c  */
#line 2403 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 497:
/* Line 1792 of yacc.c  */
#line 2404 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 498:
/* Line 1792 of yacc.c  */
#line 2412 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 499:
/* Line 1792 of yacc.c  */
#line 2413 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 500:
/* Line 1792 of yacc.c  */
#line 2414 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 501:
/* Line 1792 of yacc.c  */
#line 2415 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 502:
/* Line 1792 of yacc.c  */
#line 2416 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 503:
/* Line 1792 of yacc.c  */
#line 2423 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 511:
/* Line 1792 of yacc.c  */
#line 2450 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
    break;

  case 512:
/* Line 1792 of yacc.c  */
#line 2464 "cf-parse.y"
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
    break;

  case 513:
/* Line 1792 of yacc.c  */
#line 2484 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 514:
/* Line 1792 of yacc.c  */
#line 2485 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 515:
/* Line 1792 of yacc.c  */
#line 2486 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 516:
/* Line 1792 of yacc.c  */
#line 2487 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 517:
/* Line 1792 of yacc.c  */
#line 2488 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 518:
/* Line 1792 of yacc.c  */
#line 2489 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 519:
/* Line 1792 of yacc.c  */
#line 2490 "cf-parse.y"
    { BFD_IFACE->auth_type = (yyvsp[(2) - (2)].i); }
    break;

  case 520:
/* Line 1792 of yacc.c  */
#line 2491 "cf-parse.y"
    {}
    break;

  case 521:
/* Line 1792 of yacc.c  */
#line 2495 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_NONE; }
    break;

  case 522:
/* Line 1792 of yacc.c  */
#line 2496 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_SIMPLE; }
    break;

  case 523:
/* Line 1792 of yacc.c  */
#line 2497 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
    break;

  case 524:
/* Line 1792 of yacc.c  */
#line 2498 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
    break;

  case 525:
/* Line 1792 of yacc.c  */
#line 2499 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
    break;

  case 526:
/* Line 1792 of yacc.c  */
#line 2500 "cf-parse.y"
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
    break;

  case 532:
/* Line 1792 of yacc.c  */
#line 2518 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 533:
/* Line 1792 of yacc.c  */
#line 2522 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 534:
/* Line 1792 of yacc.c  */
#line 2523 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 535:
/* Line 1792 of yacc.c  */
#line 2524 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 536:
/* Line 1792 of yacc.c  */
#line 2528 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 537:
/* Line 1792 of yacc.c  */
#line 2529 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 538:
/* Line 1792 of yacc.c  */
#line 2533 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 539:
/* Line 1792 of yacc.c  */
#line 2534 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 540:
/* Line 1792 of yacc.c  */
#line 2538 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 541:
/* Line 1792 of yacc.c  */
#line 2557 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 542:
/* Line 1792 of yacc.c  */
#line 2562 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[(1) - (2)].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->setkey = 1;
 }
    break;

  case 544:
/* Line 1792 of yacc.c  */
#line 2589 "cf-parse.y"
    { BGP_CFG->remote_port = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Invalid port number");  }
    break;

  case 545:
/* Line 1792 of yacc.c  */
#line 2590 "cf-parse.y"
    { BGP_CFG->remote_as = (yyvsp[(3) - (3)].i); }
    break;

  case 548:
/* Line 1792 of yacc.c  */
#line 2596 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 549:
/* Line 1792 of yacc.c  */
#line 2597 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 551:
/* Line 1792 of yacc.c  */
#line 2599 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     if ((yyvsp[(4) - (6)].iface)) BGP_CFG->iface = (yyvsp[(4) - (6)].iface);
   }
    break;

  case 552:
/* Line 1792 of yacc.c  */
#line 2605 "cf-parse.y"
    { BGP_CFG->iface = if_get_by_name((yyvsp[(3) - (4)].t)); }
    break;

  case 553:
/* Line 1792 of yacc.c  */
#line 2606 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 554:
/* Line 1792 of yacc.c  */
#line 2607 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 555:
/* Line 1792 of yacc.c  */
#line 2608 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 556:
/* Line 1792 of yacc.c  */
#line 2609 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 557:
/* Line 1792 of yacc.c  */
#line 2610 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 558:
/* Line 1792 of yacc.c  */
#line 2611 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 559:
/* Line 1792 of yacc.c  */
#line 2612 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 560:
/* Line 1792 of yacc.c  */
#line 2613 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 561:
/* Line 1792 of yacc.c  */
#line 2614 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 562:
/* Line 1792 of yacc.c  */
#line 2615 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 563:
/* Line 1792 of yacc.c  */
#line 2616 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 564:
/* Line 1792 of yacc.c  */
#line 2617 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 565:
/* Line 1792 of yacc.c  */
#line 2618 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 566:
/* Line 1792 of yacc.c  */
#line 2619 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 567:
/* Line 1792 of yacc.c  */
#line 2620 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 568:
/* Line 1792 of yacc.c  */
#line 2621 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 569:
/* Line 1792 of yacc.c  */
#line 2622 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 570:
/* Line 1792 of yacc.c  */
#line 2623 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 571:
/* Line 1792 of yacc.c  */
#line 2624 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 572:
/* Line 1792 of yacc.c  */
#line 2625 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 573:
/* Line 1792 of yacc.c  */
#line 2626 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 574:
/* Line 1792 of yacc.c  */
#line 2627 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 575:
/* Line 1792 of yacc.c  */
#line 2628 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 576:
/* Line 1792 of yacc.c  */
#line 2629 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
    break;

  case 577:
/* Line 1792 of yacc.c  */
#line 2630 "cf-parse.y"
    { BGP_CFG->connect_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 578:
/* Line 1792 of yacc.c  */
#line 2631 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 579:
/* Line 1792 of yacc.c  */
#line 2632 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 580:
/* Line 1792 of yacc.c  */
#line 2633 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 581:
/* Line 1792 of yacc.c  */
#line 2634 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 582:
/* Line 1792 of yacc.c  */
#line 2635 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 583:
/* Line 1792 of yacc.c  */
#line 2636 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 584:
/* Line 1792 of yacc.c  */
#line 2637 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 585:
/* Line 1792 of yacc.c  */
#line 2638 "cf-parse.y"
    { BGP_CFG->enable_extended_messages = (yyvsp[(5) - (6)].i); }
    break;

  case 586:
/* Line 1792 of yacc.c  */
#line 2639 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 587:
/* Line 1792 of yacc.c  */
#line 2640 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 588:
/* Line 1792 of yacc.c  */
#line 2641 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 589:
/* Line 1792 of yacc.c  */
#line 2642 "cf-parse.y"
    { BGP_CFG->setkey = (yyvsp[(3) - (4)].i); }
    break;

  case 590:
/* Line 1792 of yacc.c  */
#line 2643 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
    break;

  case 591:
/* Line 1792 of yacc.c  */
#line 2649 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 592:
/* Line 1792 of yacc.c  */
#line 2650 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 593:
/* Line 1792 of yacc.c  */
#line 2651 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 594:
/* Line 1792 of yacc.c  */
#line 2652 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 595:
/* Line 1792 of yacc.c  */
#line 2653 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 596:
/* Line 1792 of yacc.c  */
#line 2654 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 597:
/* Line 1792 of yacc.c  */
#line 2655 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 598:
/* Line 1792 of yacc.c  */
#line 2656 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 599:
/* Line 1792 of yacc.c  */
#line 2657 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 600:
/* Line 1792 of yacc.c  */
#line 2658 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 601:
/* Line 1792 of yacc.c  */
#line 2659 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 602:
/* Line 1792 of yacc.c  */
#line 2660 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 603:
/* Line 1792 of yacc.c  */
#line 2661 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 604:
/* Line 1792 of yacc.c  */
#line 2662 "cf-parse.y"
    { BGP_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 605:
/* Line 1792 of yacc.c  */
#line 2663 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 606:
/* Line 1792 of yacc.c  */
#line 2674 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
    break;

  case 610:
/* Line 1792 of yacc.c  */
#line 2690 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 611:
/* Line 1792 of yacc.c  */
#line 2691 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 612:
/* Line 1792 of yacc.c  */
#line 2692 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 613:
/* Line 1792 of yacc.c  */
#line 2693 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 614:
/* Line 1792 of yacc.c  */
#line 2694 "cf-parse.y"
    { OSPF_CFG->merge_external = (yyvsp[(3) - (3)].i); }
    break;

  case 615:
/* Line 1792 of yacc.c  */
#line 2695 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 616:
/* Line 1792 of yacc.c  */
#line 2696 "cf-parse.y"
    { OSPF_CFG->instance_id = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<0) || ((yyvsp[(3) - (3)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 618:
/* Line 1792 of yacc.c  */
#line 2700 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 619:
/* Line 1792 of yacc.c  */
#line 2715 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 622:
/* Line 1792 of yacc.c  */
#line 2724 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 623:
/* Line 1792 of yacc.c  */
#line 2725 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 624:
/* Line 1792 of yacc.c  */
#line 2726 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 625:
/* Line 1792 of yacc.c  */
#line 2727 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 626:
/* Line 1792 of yacc.c  */
#line 2728 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 627:
/* Line 1792 of yacc.c  */
#line 2729 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 628:
/* Line 1792 of yacc.c  */
#line 2730 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); ospf_check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 629:
/* Line 1792 of yacc.c  */
#line 2731 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 630:
/* Line 1792 of yacc.c  */
#line 2732 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 631:
/* Line 1792 of yacc.c  */
#line 2733 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 633:
/* Line 1792 of yacc.c  */
#line 2734 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 640:
/* Line 1792 of yacc.c  */
#line 2746 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 643:
/* Line 1792 of yacc.c  */
#line 2760 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 644:
/* Line 1792 of yacc.c  */
#line 2761 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 645:
/* Line 1792 of yacc.c  */
#line 2762 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 646:
/* Line 1792 of yacc.c  */
#line 2766 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 647:
/* Line 1792 of yacc.c  */
#line 2767 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 651:
/* Line 1792 of yacc.c  */
#line 2776 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 652:
/* Line 1792 of yacc.c  */
#line 2777 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 653:
/* Line 1792 of yacc.c  */
#line 2778 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 654:
/* Line 1792 of yacc.c  */
#line 2779 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 655:
/* Line 1792 of yacc.c  */
#line 2780 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 656:
/* Line 1792 of yacc.c  */
#line 2781 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 657:
/* Line 1792 of yacc.c  */
#line 2782 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
    break;

  case 658:
/* Line 1792 of yacc.c  */
#line 2783 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 659:
/* Line 1792 of yacc.c  */
#line 2784 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 660:
/* Line 1792 of yacc.c  */
#line 2785 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 661:
/* Line 1792 of yacc.c  */
#line 2789 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
    break;

  case 662:
/* Line 1792 of yacc.c  */
#line 2808 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 663:
/* Line 1792 of yacc.c  */
#line 2809 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 664:
/* Line 1792 of yacc.c  */
#line 2810 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 665:
/* Line 1792 of yacc.c  */
#line 2811 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Retransmit int must be greater than one"); }
    break;

  case 666:
/* Line 1792 of yacc.c  */
#line 2812 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Wait interval must be greater than one"); }
    break;

  case 667:
/* Line 1792 of yacc.c  */
#line 2813 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 668:
/* Line 1792 of yacc.c  */
#line 2814 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 669:
/* Line 1792 of yacc.c  */
#line 2815 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 670:
/* Line 1792 of yacc.c  */
#line 2816 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 671:
/* Line 1792 of yacc.c  */
#line 2817 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 672:
/* Line 1792 of yacc.c  */
#line 2818 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 673:
/* Line 1792 of yacc.c  */
#line 2819 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 674:
/* Line 1792 of yacc.c  */
#line 2820 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 675:
/* Line 1792 of yacc.c  */
#line 2821 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 676:
/* Line 1792 of yacc.c  */
#line 2822 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 677:
/* Line 1792 of yacc.c  */
#line 2823 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 678:
/* Line 1792 of yacc.c  */
#line 2824 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
    break;

  case 679:
/* Line 1792 of yacc.c  */
#line 2825 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 680:
/* Line 1792 of yacc.c  */
#line 2826 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 681:
/* Line 1792 of yacc.c  */
#line 2827 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 682:
/* Line 1792 of yacc.c  */
#line 2828 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 683:
/* Line 1792 of yacc.c  */
#line 2829 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 684:
/* Line 1792 of yacc.c  */
#line 2830 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 685:
/* Line 1792 of yacc.c  */
#line 2831 "cf-parse.y"
    { OSPF_PATT->link_lsa_suppression = (yyvsp[(4) - (4)].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
    break;

  case 687:
/* Line 1792 of yacc.c  */
#line 2833 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
    break;

  case 688:
/* Line 1792 of yacc.c  */
#line 2834 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
    break;

  case 689:
/* Line 1792 of yacc.c  */
#line 2835 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
    break;

  case 690:
/* Line 1792 of yacc.c  */
#line 2836 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 691:
/* Line 1792 of yacc.c  */
#line 2837 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 692:
/* Line 1792 of yacc.c  */
#line 2838 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 693:
/* Line 1792 of yacc.c  */
#line 2839 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 694:
/* Line 1792 of yacc.c  */
#line 2840 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 695:
/* Line 1792 of yacc.c  */
#line 2841 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 696:
/* Line 1792 of yacc.c  */
#line 2842 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 697:
/* Line 1792 of yacc.c  */
#line 2843 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 698:
/* Line 1792 of yacc.c  */
#line 2844 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 699:
/* Line 1792 of yacc.c  */
#line 2845 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 700:
/* Line 1792 of yacc.c  */
#line 2846 "cf-parse.y"
    { ospf_check_auth(); }
    break;

  case 704:
/* Line 1792 of yacc.c  */
#line 2857 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 706:
/* Line 1792 of yacc.c  */
#line 2867 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 707:
/* Line 1792 of yacc.c  */
#line 2868 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 710:
/* Line 1792 of yacc.c  */
#line 2877 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 711:
/* Line 1792 of yacc.c  */
#line 2878 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 712:
/* Line 1792 of yacc.c  */
#line 2882 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 713:
/* Line 1792 of yacc.c  */
#line 2891 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 715:
/* Line 1792 of yacc.c  */
#line 2914 "cf-parse.y"
    { OSPF_PATT->instance_id = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Instance ID must be in range 0-255"); }
    break;

  case 716:
/* Line 1792 of yacc.c  */
#line 2918 "cf-parse.y"
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
    break;

  case 722:
/* Line 1792 of yacc.c  */
#line 2932 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 724:
/* Line 1792 of yacc.c  */
#line 2937 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 725:
/* Line 1792 of yacc.c  */
#line 2943 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 726:
/* Line 1792 of yacc.c  */
#line 2946 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 727:
/* Line 1792 of yacc.c  */
#line 2949 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 728:
/* Line 1792 of yacc.c  */
#line 2954 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 729:
/* Line 1792 of yacc.c  */
#line 2957 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 730:
/* Line 1792 of yacc.c  */
#line 2962 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 731:
/* Line 1792 of yacc.c  */
#line 2965 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 732:
/* Line 1792 of yacc.c  */
#line 2969 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 733:
/* Line 1792 of yacc.c  */
#line 2972 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 734:
/* Line 1792 of yacc.c  */
#line 2975 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 735:
/* Line 1792 of yacc.c  */
#line 2976 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 736:
/* Line 1792 of yacc.c  */
#line 2977 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 737:
/* Line 1792 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 738:
/* Line 1792 of yacc.c  */
#line 2979 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 739:
/* Line 1792 of yacc.c  */
#line 2980 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 740:
/* Line 1792 of yacc.c  */
#line 2981 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 741:
/* Line 1792 of yacc.c  */
#line 2982 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 742:
/* Line 1792 of yacc.c  */
#line 2988 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 745:
/* Line 1792 of yacc.c  */
#line 2997 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 746:
/* Line 1792 of yacc.c  */
#line 3002 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 747:
/* Line 1792 of yacc.c  */
#line 3003 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 748:
/* Line 1792 of yacc.c  */
#line 3010 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 751:
/* Line 1792 of yacc.c  */
#line 3021 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 752:
/* Line 1792 of yacc.c  */
#line 3022 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 753:
/* Line 1792 of yacc.c  */
#line 3022 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 754:
/* Line 1792 of yacc.c  */
#line 3023 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 755:
/* Line 1792 of yacc.c  */
#line 3023 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 756:
/* Line 1792 of yacc.c  */
#line 3024 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 760:
/* Line 1792 of yacc.c  */
#line 3041 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
    break;

  case 761:
/* Line 1792 of yacc.c  */
#line 3059 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 762:
/* Line 1792 of yacc.c  */
#line 3060 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 763:
/* Line 1792 of yacc.c  */
#line 3061 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 764:
/* Line 1792 of yacc.c  */
#line 3062 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 765:
/* Line 1792 of yacc.c  */
#line 3063 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 766:
/* Line 1792 of yacc.c  */
#line 3064 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 767:
/* Line 1792 of yacc.c  */
#line 3065 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 768:
/* Line 1792 of yacc.c  */
#line 3066 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 769:
/* Line 1792 of yacc.c  */
#line 3067 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 770:
/* Line 1792 of yacc.c  */
#line 3068 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 771:
/* Line 1792 of yacc.c  */
#line 3073 "cf-parse.y"
    { RADV_IFACE->default_preference = (yyvsp[(3) - (3)].i); }
    break;

  case 772:
/* Line 1792 of yacc.c  */
#line 3074 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 773:
/* Line 1792 of yacc.c  */
#line 3075 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 774:
/* Line 1792 of yacc.c  */
#line 3075 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 775:
/* Line 1792 of yacc.c  */
#line 3076 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 776:
/* Line 1792 of yacc.c  */
#line 3076 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 777:
/* Line 1792 of yacc.c  */
#line 3077 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 778:
/* Line 1792 of yacc.c  */
#line 3078 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 779:
/* Line 1792 of yacc.c  */
#line 3082 "cf-parse.y"
    { (yyval.i) = RA_PREF_LOW; }
    break;

  case 780:
/* Line 1792 of yacc.c  */
#line 3083 "cf-parse.y"
    { (yyval.i) = RA_PREF_MEDIUM; }
    break;

  case 781:
/* Line 1792 of yacc.c  */
#line 3084 "cf-parse.y"
    { (yyval.i) = RA_PREF_HIGH; }
    break;

  case 782:
/* Line 1792 of yacc.c  */
#line 3087 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 788:
/* Line 1792 of yacc.c  */
#line 3120 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 789:
/* Line 1792 of yacc.c  */
#line 3132 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 790:
/* Line 1792 of yacc.c  */
#line 3133 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 791:
/* Line 1792 of yacc.c  */
#line 3134 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 792:
/* Line 1792 of yacc.c  */
#line 3135 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 793:
/* Line 1792 of yacc.c  */
#line 3140 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 794:
/* Line 1792 of yacc.c  */
#line 3148 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 800:
/* Line 1792 of yacc.c  */
#line 3172 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 801:
/* Line 1792 of yacc.c  */
#line 3181 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 804:
/* Line 1792 of yacc.c  */
#line 3188 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 805:
/* Line 1792 of yacc.c  */
#line 3192 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 810:
/* Line 1792 of yacc.c  */
#line 3216 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 811:
/* Line 1792 of yacc.c  */
#line 3228 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 814:
/* Line 1792 of yacc.c  */
#line 3235 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 815:
/* Line 1792 of yacc.c  */
#line 3239 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 820:
/* Line 1792 of yacc.c  */
#line 3263 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 821:
/* Line 1792 of yacc.c  */
#line 3264 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 822:
/* Line 1792 of yacc.c  */
#line 3268 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 823:
/* Line 1792 of yacc.c  */
#line 3269 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 824:
/* Line 1792 of yacc.c  */
#line 3276 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[(1) - (2)].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
    break;

  case 826:
/* Line 1792 of yacc.c  */
#line 3289 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (2)].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 827:
/* Line 1792 of yacc.c  */
#line 3290 "cf-parse.y"
    { RIP_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 828:
/* Line 1792 of yacc.c  */
#line 3291 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(2) - (2)].i); }
    break;

  case 833:
/* Line 1792 of yacc.c  */
#line 3305 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
    break;

  case 834:
/* Line 1792 of yacc.c  */
#line 3328 "cf-parse.y"
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
    break;

  case 835:
/* Line 1792 of yacc.c  */
#line 3358 "cf-parse.y"
    { RIP_IFACE->metric = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Metric must be in range 1-255"); }
    break;

  case 836:
/* Line 1792 of yacc.c  */
#line 3359 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
    break;

  case 837:
/* Line 1792 of yacc.c  */
#line 3360 "cf-parse.y"
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
    break;

  case 838:
/* Line 1792 of yacc.c  */
#line 3361 "cf-parse.y"
    { RIP_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 839:
/* Line 1792 of yacc.c  */
#line 3362 "cf-parse.y"
    { RIP_IFACE->address = (yyvsp[(2) - (2)].a); }
    break;

  case 840:
/* Line 1792 of yacc.c  */
#line 3363 "cf-parse.y"
    { RIP_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 841:
/* Line 1792 of yacc.c  */
#line 3364 "cf-parse.y"
    { RIP_IFACE->version = (yyvsp[(2) - (2)].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[(2) - (2)].i) != RIP_V1) && ((yyvsp[(2) - (2)].i) != RIP_V2)) cf_error("Unsupported version");
			}
    break;

  case 842:
/* Line 1792 of yacc.c  */
#line 3368 "cf-parse.y"
    { RIP_IFACE->version_only = (yyvsp[(3) - (3)].i); }
    break;

  case 843:
/* Line 1792 of yacc.c  */
#line 3369 "cf-parse.y"
    { RIP_IFACE->split_horizon = (yyvsp[(3) - (3)].i); }
    break;

  case 844:
/* Line 1792 of yacc.c  */
#line 3370 "cf-parse.y"
    { RIP_IFACE->poison_reverse = (yyvsp[(3) - (3)].i); }
    break;

  case 845:
/* Line 1792 of yacc.c  */
#line 3371 "cf-parse.y"
    { RIP_IFACE->check_zero = (yyvsp[(3) - (3)].i); }
    break;

  case 846:
/* Line 1792 of yacc.c  */
#line 3372 "cf-parse.y"
    { RIP_IFACE->update_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Update time must be positive"); }
    break;

  case 847:
/* Line 1792 of yacc.c  */
#line 3373 "cf-parse.y"
    { RIP_IFACE->timeout_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Timeout time must be positive"); }
    break;

  case 848:
/* Line 1792 of yacc.c  */
#line 3374 "cf-parse.y"
    { RIP_IFACE->garbage_time = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i)<=0) cf_error("Garbage time must be positive"); }
    break;

  case 849:
/* Line 1792 of yacc.c  */
#line 3375 "cf-parse.y"
    { RIP_IFACE->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 850:
/* Line 1792 of yacc.c  */
#line 3376 "cf-parse.y"
    { RIP_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX length must be in range 256-65535"); }
    break;

  case 851:
/* Line 1792 of yacc.c  */
#line 3377 "cf-parse.y"
    { RIP_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 852:
/* Line 1792 of yacc.c  */
#line 3378 "cf-parse.y"
    { RIP_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 853:
/* Line 1792 of yacc.c  */
#line 3379 "cf-parse.y"
    { RIP_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 854:
/* Line 1792 of yacc.c  */
#line 3380 "cf-parse.y"
    { RIP_IFACE->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 855:
/* Line 1792 of yacc.c  */
#line 3381 "cf-parse.y"
    { RIP_IFACE->ttl_security = 2; }
    break;

  case 856:
/* Line 1792 of yacc.c  */
#line 3382 "cf-parse.y"
    { RIP_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 857:
/* Line 1792 of yacc.c  */
#line 3383 "cf-parse.y"
    { RIP_IFACE->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 858:
/* Line 1792 of yacc.c  */
#line 3384 "cf-parse.y"
    { RIP_IFACE->auth_type = (yyvsp[(2) - (2)].i); if ((yyvsp[(2) - (2)].i)) rip_check_auth(); }
    break;

  case 859:
/* Line 1792 of yacc.c  */
#line 3385 "cf-parse.y"
    { rip_check_auth(); }
    break;

  case 860:
/* Line 1792 of yacc.c  */
#line 3389 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_NONE; }
    break;

  case 861:
/* Line 1792 of yacc.c  */
#line 3390 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_PLAIN; }
    break;

  case 862:
/* Line 1792 of yacc.c  */
#line 3391 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 863:
/* Line 1792 of yacc.c  */
#line 3392 "cf-parse.y"
    { (yyval.i) = RIP_AUTH_CRYPTO; }
    break;

  case 869:
/* Line 1792 of yacc.c  */
#line 3413 "cf-parse.y"
    { rip_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 870:
/* Line 1792 of yacc.c  */
#line 3416 "cf-parse.y"
    { rip_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_rip), (yyvsp[(5) - (6)].t)); }
    break;

  case 871:
/* Line 1792 of yacc.c  */
#line 3422 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 874:
/* Line 1792 of yacc.c  */
#line 3431 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 875:
/* Line 1792 of yacc.c  */
#line 3432 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 876:
/* Line 1792 of yacc.c  */
#line 3433 "cf-parse.y"
    { static_route_finish(); }
    break;

  case 877:
/* Line 1792 of yacc.c  */
#line 3436 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
    break;

  case 878:
/* Line 1792 of yacc.c  */
#line 3446 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
    break;

  case 879:
/* Line 1792 of yacc.c  */
#line 3455 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 880:
/* Line 1792 of yacc.c  */
#line 3459 "cf-parse.y"
    {
     this_srt_nh->use_bfd = (yyvsp[(3) - (3)].i); cf_check_bfd((yyvsp[(3) - (3)].i));
   }
    break;

  case 881:
/* Line 1792 of yacc.c  */
#line 3465 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 882:
/* Line 1792 of yacc.c  */
#line 3466 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 883:
/* Line 1792 of yacc.c  */
#line 3470 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 884:
/* Line 1792 of yacc.c  */
#line 3475 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 885:
/* Line 1792 of yacc.c  */
#line 3481 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 886:
/* Line 1792 of yacc.c  */
#line 3484 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 887:
/* Line 1792 of yacc.c  */
#line 3489 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 888:
/* Line 1792 of yacc.c  */
#line 3490 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 889:
/* Line 1792 of yacc.c  */
#line 3491 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 890:
/* Line 1792 of yacc.c  */
#line 3492 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 891:
/* Line 1792 of yacc.c  */
#line 3493 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 892:
/* Line 1792 of yacc.c  */
#line 3497 "cf-parse.y"
    { *this_srt_last_cmd = (yyvsp[(1) - (1)].x); this_srt_last_cmd = &((yyvsp[(1) - (1)].x)->next); }
    break;

  case 893:
/* Line 1792 of yacc.c  */
#line 3498 "cf-parse.y"
    { this_srt->use_bfd = (yyvsp[(2) - (3)].i); cf_check_bfd((yyvsp[(2) - (3)].i)); }
    break;

  case 898:
/* Line 1792 of yacc.c  */
#line 3513 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 899:
/* Line 1792 of yacc.c  */
#line 3519 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[(1) - (2)].i));
  init_list(&BABEL_CFG->iface_list);
}
    break;

  case 905:
/* Line 1792 of yacc.c  */
#line 3539 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
    break;

  case 906:
/* Line 1792 of yacc.c  */
#line 3552 "cf-parse.y"
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
    break;

  case 908:
/* Line 1792 of yacc.c  */
#line 3576 "cf-parse.y"
    { BABEL_IFACE->port = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid port number"); }
    break;

  case 909:
/* Line 1792 of yacc.c  */
#line 3577 "cf-parse.y"
    { BABEL_IFACE->rxcost = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i)<1) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Invalid rxcost"); }
    break;

  case 910:
/* Line 1792 of yacc.c  */
#line 3578 "cf-parse.y"
    { BABEL_IFACE->hello_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
    break;

  case 911:
/* Line 1792 of yacc.c  */
#line 3579 "cf-parse.y"
    { BABEL_IFACE->update_interval = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
    break;

  case 912:
/* Line 1792 of yacc.c  */
#line 3580 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
    break;

  case 913:
/* Line 1792 of yacc.c  */
#line 3581 "cf-parse.y"
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
    break;

  case 914:
/* Line 1792 of yacc.c  */
#line 3582 "cf-parse.y"
    { BABEL_IFACE->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
    break;

  case 915:
/* Line 1792 of yacc.c  */
#line 3583 "cf-parse.y"
    { BABEL_IFACE->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i)<256) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 916:
/* Line 1792 of yacc.c  */
#line 3584 "cf-parse.y"
    { BABEL_IFACE->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 917:
/* Line 1792 of yacc.c  */
#line 3585 "cf-parse.y"
    { BABEL_IFACE->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 918:
/* Line 1792 of yacc.c  */
#line 3586 "cf-parse.y"
    { BABEL_IFACE->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 924:
/* Line 1792 of yacc.c  */
#line 3607 "cf-parse.y"
    { babel_show_interfaces(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 925:
/* Line 1792 of yacc.c  */
#line 3610 "cf-parse.y"
    { babel_show_neighbors(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel), (yyvsp[(5) - (6)].t)); }
    break;

  case 926:
/* Line 1792 of yacc.c  */
#line 3613 "cf-parse.y"
    { babel_show_entries(proto_get_named((yyvsp[(4) - (6)].s), &proto_babel)); }
    break;

  case 999:
/* Line 1792 of yacc.c  */
#line 3621 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 1000:
/* Line 1792 of yacc.c  */
#line 3621 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 1013:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 1014:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 1015:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 1016:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 1017:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
    break;

  case 1018:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
    break;

  case 1019:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
    break;

  case 1020:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
    break;

  case 1021:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
    break;

  case 1022:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
    break;

  case 1023:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
    break;

  case 1024:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
    break;

  case 1025:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
    break;

  case 1026:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
    break;

  case 1027:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
    break;

  case 1028:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
    break;

  case 1029:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
    break;

  case 1030:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
    break;

  case 1031:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
    break;

  case 1032:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
    break;

  case 1033:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
    break;

  case 1034:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
    break;

  case 1035:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
    break;

  case 1036:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
    break;

  case 1037:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
    break;

  case 1038:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
    break;

  case 1039:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
    break;

  case 1040:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
    break;

  case 1041:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
    break;

  case 1042:
/* Line 1792 of yacc.c  */
#line 3624 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
    break;

  case 1043:
/* Line 1792 of yacc.c  */
#line 3625 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 1044:
/* Line 1792 of yacc.c  */
#line 3625 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 1045:
/* Line 1792 of yacc.c  */
#line 3626 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 1046:
/* Line 1792 of yacc.c  */
#line 3627 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 1047:
/* Line 1792 of yacc.c  */
#line 3628 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 1048:
/* Line 1792 of yacc.c  */
#line 3629 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 1049:
/* Line 1792 of yacc.c  */
#line 3630 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 1050:
/* Line 1792 of yacc.c  */
#line 3631 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 1051:
/* Line 1792 of yacc.c  */
#line 3632 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 1052:
/* Line 1792 of yacc.c  */
#line 3633 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 1053:
/* Line 1792 of yacc.c  */
#line 3634 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 1054:
/* Line 1792 of yacc.c  */
#line 3635 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 1055:
/* Line 1792 of yacc.c  */
#line 3636 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 1056:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
    break;

  case 1057:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 1058:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 1059:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 1060:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 1061:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 1062:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;

  case 1063:
/* Line 1792 of yacc.c  */
#line 3637 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
    break;


/* Line 1792 of yacc.c  */
#line 10646 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3639 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

